#include <amxmod>
#include <amxmisc>
#include <Vexd_Utilities>
#include <VexdUM_stock>


new Title[] = "AMX Fireworks"
new Version[] = "1.2.0"
new Author[] = "Sanji"

new Game[32]

new sprSmoke
new sprFlare6
new sprLgtning
new sprBflare
new sprRflare
new sprGflare
new sprTflare
new sprOflare
new sprPflare
new sprYflare

new has_rocket = 0
new has_drop = 0

new fPlayer[33] = {0,...}

public HandleSay(id) {
	new arg1[32]
	new arg2[32]
	read_argv(1,arg1,sizeof(arg1))
	read_argv(2,arg2,sizeof(arg2))

	if (equali(arg1,"fireworks menu") || equali(arg1,"fireworks_menu"))
		fireworks_menu(id)

	return PLUGIN_CONTINUE
}

public fireworks_think() {
	new iCurrent
	new temp
	new Float:vVelocity[3]
	new Float:vNormal[3]
	new Float:vOrigin[3]
	new Float:vTraceStart[3]
	new Float:vTraceEnd[3]
	new stat,stat2,c1[128]
	new life
	new id

	new Float:fmin,Float:fmax,Float:fxy
	fmin = get_cvar_float("fireworks_velocity_min")
	fmax = get_cvar_float("fireworks_velocity_max")
	fxy = get_cvar_float("fireworks_velocity_xy")

	iCurrent = FindEntity(-1, "fly_fireworks")

	while (iCurrent != -1) {
		temp = iCurrent
		iCurrent = FindEntity(iCurrent, "fly_fireworks")
		life = Entvars_Get_Int(temp,EV_INT_iuser1)
		life--
		Entvars_Set_Int(temp,EV_INT_iuser1,life)
		vVelocity[0] = random_float(-fxy,fxy)
		vVelocity[1] = random_float(-fxy,fxy)
		vVelocity[2] = random_float(fmin,fmax)
		Entvars_Set_Vector(temp,EV_VEC_velocity,vVelocity)
		Entvars_Get_Vector(temp,EV_VEC_origin,vOrigin)
		id = Entvars_Get_Edict(temp,EV_ENT_owner)
		vTraceStart[0] = vOrigin[0]
		vTraceStart[1] = vOrigin[1]
		vTraceStart[2] = vOrigin[2] - 1.0
		vTraceEnd[0] = vOrigin[0]
		vTraceEnd[1] = vOrigin[1]
		vTraceEnd[2] = vOrigin[2] + 5.0
		stat2 = TraceLn(temp, vTraceStart, vTraceEnd, vNormal)
		stat = TraceNormal(temp, vTraceStart, vTraceEnd, vNormal)
		if (stat != 0) {
			if (is_entity(stat2)) {
				Entvars_Get_String(stat2,EV_SZ_classname,c1,sizeof(c1))
				if (!equali("fly_fireworks",c1) && !equali("nrm_fireworks",c1) && !equali("player",c1)) {
					explode(temp)
					if (id != 0) {
						fPlayer[id]--
					}
				}
			} else {
				explode(temp)
				if (id != 0) {
					fPlayer[id]--
				}
			}
		} else {
			if (life <= 0) {
				explode(temp)
				if (id != 0) {
					fPlayer[id]--
				}
			}
		}
	}
}

public shooter_think() {
	new iCurrent
	new temp
	new Float:vVelocity[3]
	new Float:Origin[3]
	new Float:Angles[3]
	new Float:Mins[3] = {-2.0, -2.0, -1.0}
	new Float:Maxs[3] = {2.0, 2.0, 12.0}
	new r,g,b
	new count

	iCurrent = FindEntity(-1, "shooter_fireworks")

	while (iCurrent != -1) {
		temp = iCurrent
		iCurrent = FindEntity(iCurrent, "shooter_fireworks")
		count = Entvars_Get_Int(temp,EV_INT_iuser1)
		if (count <= 0) {
			RemoveEntity(temp)
			continue
		}
		count--
		Entvars_Set_Int(temp,EV_INT_iuser1,count)
		Entvars_Get_Vector(temp,EV_VEC_origin,Origin)
		Angles[0] = 90.0
		Angles[1] = random_float(0.0,360.0)
		Angles[2] = 0.0
		Origin[2] += 18.0
		new Ent = CreateEntity("info_target")
		if (Ent) {
			Entvars_Set_String(Ent,EV_SZ_classname,"fly_fireworks")
			Entvars_Set_Vector(Ent,EV_VEC_origin,Origin)
			Entvars_Set_Vector(Ent,EV_VEC_angles,Angles)
			Entvars_Set_Vector(Ent,EV_VEC_mins,Mins)
			Entvars_Set_Vector(Ent,EV_VEC_maxs,Maxs)
			Entvars_Set_Int(Ent,EV_INT_solid,2)
			Entvars_Set_Int(Ent,EV_INT_movetype,6)
			ENT_SetModel(Ent,"models/rpgrocket.mdl")
			if (get_cvar_num("fireworks_colortype")) {
				switch(random_num(0,6)) {
					case 0: {
						r = 255
						g = 0
						b = 0
					}
					case 1: {
						r = 0
						g = 255
						b = 0
					}
					case 2: {
						r = 0
						g = 0
						b = 255
					}
					case 3: {
						r = 0
						g = 255
						b = 255
					}
					case 4: {
						r = 255
						g = 0
						b = 255
					}
					case 5: {
						r = 255
						g = 255
						b = 0
					}
					case 6: {
						r = 255
						g = 128
						b = 0
					}
				}
			} else {
				r = random_num(0,255)
				g = random_num(0,255)
				b = random_num(0,255)
			}
			Entvars_Set_Int(Ent,EV_INT_iuser1,get_cvar_num("fireworks_maxlife"))
			Entvars_Set_Int(Ent,EV_INT_iuser2,r)
			Entvars_Set_Int(Ent,EV_INT_iuser3,g)
			Entvars_Set_Int(Ent,EV_INT_iuser4,b)
			Entvars_Set_Int(Ent,EV_INT_effects,64)

			emit_sound(Ent, CHAN_WEAPON, "weapons/rocketfire1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

			if (has_rocket)
				emit_sound(Ent, CHAN_VOICE, "fireworks/rocket1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			else
				emit_sound(Ent, CHAN_VOICE, "weapons/rocket1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(22)
			write_short(Ent)
			write_short(sprSmoke)
			write_byte(45)
			write_byte(4)
			write_byte(r)
			write_byte(g)
			write_byte(b)
			write_byte(255)
			message_end()
			Entvars_Get_Vector(Ent,EV_VEC_velocity,vVelocity)
			vVelocity[0] = random_float(-150.0,150.0)
			vVelocity[1] = random_float(-150.0,150.0)
			Entvars_Set_Vector(Ent,EV_VEC_velocity,vVelocity)
		}
	}
}

public fireworks_spawn(id) {
	new sr[64],r
	read_argv(1,sr,sizeof(sr))
	r = strtonum(sr)
	return spawn(id,r)
}

spawn(id,salve) {
	new fenable = get_cvar_num("fireworks_enable")
	new maxcount

	if ((get_user_flags(id)&ADMIN_LEVEL_H))
		maxcount = get_cvar_num("fireworks_amaxcount")
	else
		maxcount = get_cvar_num("fireworks_maxcount")

	if (fenable == 1) {
		if (!(get_user_flags(id)&ADMIN_LEVEL_H)) {
			return PLUGIN_HANDLED
		}
		if (fPlayer[id] > (maxcount-1)) {
			return PLUGIN_HANDLED
		}
	} else if (fenable == 2) {
		if (fPlayer[id] > (maxcount-1)) {
			return PLUGIN_HANDLED
		}
	} else {
		return PLUGIN_HANDLED
	}

	new Float:Return[3]
	new Float:Origin[3]
	new Float:Angles[3]
	Angles[0] = 90.0
	Angles[1] = random_float(0.0,360.0)
	Angles[2] = 0.0
	VelocityByAim(id,64,Return)
	Entvars_Get_Vector(id,EV_VEC_origin,Origin)
	Origin[0] += Return[0]
	Origin[1] += Return[1]
	Origin[2] += Return[2]
	new Float:Mins[3] = {-2.0, -2.0, -1.0}
	new Float:Maxs[3] = {2.0, 2.0, 12.0}
	new r,g,b

	new Ent = CreateEntity("info_target")
	if (Ent) {
		fPlayer[id]++
		Entvars_Set_String(Ent,EV_SZ_classname,"nrm_fireworks")
		Entvars_Set_Vector(Ent,EV_VEC_mins,Mins)
		Entvars_Set_Vector(Ent,EV_VEC_maxs,Maxs)
		Entvars_Set_Vector(Ent,EV_VEC_origin,Origin)
		Entvars_Set_Vector(Ent,EV_VEC_angles,Angles)
		Entvars_Set_Edict(Ent,EV_ENT_owner,id)
		Entvars_Set_Int(Ent,EV_INT_solid,2)
		Entvars_Set_Int(Ent,EV_INT_movetype,6)
		Entvars_Set_Float(Ent,EV_FL_fuser1,float(salve))
		ENT_SetModel(Ent,"models/rpgrocket.mdl")
		if (get_cvar_num("fireworks_colortype")) {
			switch(random_num(0,6)) {
				case 0: {
					r = 255
					g = 0
					b = 0
				}
				case 1: {
					r = 0
					g = 255
					b = 0
				}
				case 2: {
					r = 0
					g = 0
					b = 255
				}
				case 3: {
					r = 0
					g = 255
					b = 255
				}
				case 4: {
					r = 255
					g = 0
					b = 255
				}
				case 5: {
					r = 255
					g = 255
					b = 0
				}
				case 6: {
					r = 255
					g = 128
					b = 0
				}
			}
		} else {
			r = random_num(0,255)
			g = random_num(0,255)
			b = random_num(0,255)
		}
		set_rendering(Ent,kRenderFxGlowShell,r,g,b,kRenderNormal,20)
		Entvars_Set_Int(Ent,EV_INT_iuser2,r)
		Entvars_Set_Int(Ent,EV_INT_iuser3,g)
		Entvars_Set_Int(Ent,EV_INT_iuser4,b)
		if (has_drop)
			emit_sound(Ent, CHAN_WEAPON, "fireworks/weapondrop1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		else
			emit_sound(Ent, CHAN_WEAPON, "items/weapondrop1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	}

	return PLUGIN_HANDLED
}

public fireworks_spawn_rgb(id,level,cid) {
	new fenable = get_cvar_num("fireworks_enable")
	new maxcount

	if ((get_user_flags(id)&ADMIN_LEVEL_H))
		maxcount = get_cvar_num("fireworks_amaxcount")
	else
		maxcount = get_cvar_num("fireworks_maxcount")

	if (fenable == 1) {
		if (!(get_user_flags(id)&ADMIN_LEVEL_H)) {
			return PLUGIN_HANDLED
		}
		if (fPlayer[id] > (maxcount-1)) {
			return PLUGIN_HANDLED
		}
	} else if (fenable == 2) {
		if (fPlayer[id] > (maxcount-1)) {
			return PLUGIN_HANDLED
		}
	} else {
		return PLUGIN_HANDLED
	}

	if (read_argc() < 4) {
		console_print(id, "Usage:  fireworks_spawn_rgb <r> <g> <b>")
		return PLUGIN_HANDLED
	}

	new Float:Return[3]
	new Float:Origin[3]
	new Float:Angles[3]
	Angles[0] = 90.0
	Angles[1] = random_float(0.0,360.0)
	Angles[2] = 0.0
	VelocityByAim(id,64,Return)
	Entvars_Get_Vector(id,EV_VEC_origin,Origin)
	Origin[0] += Return[0]
	Origin[1] += Return[1]
	Origin[2] += Return[2]
	new Float:Mins[3] = {-2.0, -2.0, -1.0}
	new Float:Maxs[3] = {2.0, 2.0, 12.0}
	new sr[8],sg[8],sb[8]
	new r,g,b
	read_argv(1,sr,sizeof(sr))
	read_argv(2,sg,sizeof(sg))
	read_argv(3,sb,sizeof(sb))
	r = strtonum(sr)
	g = strtonum(sg)
	b = strtonum(sb)

	new Ent = CreateEntity("info_target")
	if (Ent) {
		fPlayer[id]++
		Entvars_Set_String(Ent,EV_SZ_classname,"nrm_fireworks")
		Entvars_Set_Vector(Ent,EV_VEC_mins,Mins)
		Entvars_Set_Vector(Ent,EV_VEC_maxs,Maxs)
		Entvars_Set_Vector(Ent,EV_VEC_origin,Origin)
		Entvars_Set_Vector(Ent,EV_VEC_angles,Angles)
		Entvars_Set_Edict(Ent,EV_ENT_owner,id)
		Entvars_Set_Int(Ent,EV_INT_solid,2)
		Entvars_Set_Int(Ent,EV_INT_movetype,6)
		ENT_SetModel(Ent,"models/rpgrocket.mdl")
		set_rendering(Ent,kRenderFxGlowShell,r,g,b,kRenderNormal,20)
		Entvars_Set_Int(Ent,EV_INT_iuser2,r)
		Entvars_Set_Int(Ent,EV_INT_iuser3,g)
		Entvars_Set_Int(Ent,EV_INT_iuser4,b)
		if (has_drop)
			emit_sound(Ent, CHAN_WEAPON, "fireworks/weapondrop1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		else
			emit_sound(Ent, CHAN_WEAPON, "items/weapondrop1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	}

	return PLUGIN_HANDLED
}

public fireworks_shoot(id) {
	new sr[64],r
	read_argv(1,sr,sizeof(sr))
	r = strtonum(sr)
	return shoot(id,r)
}

shoot(id,salve) {
	new Owner
	new r,g,b
	new iCurrent
	new iCurrent2
	new Float:vVelocity[3]
	new temp
	new sid

	iCurrent2 = FindEntity(-1, "fly_fireworks")

	while (iCurrent2 != -1) {
		temp = iCurrent2
		iCurrent2 = FindEntity(iCurrent2, "fly_fireworks")
		Owner = Entvars_Get_Edict(temp,EV_ENT_owner)
		if (Owner == id) {
			explode(temp)
			fPlayer[id]--
		}
	}

	iCurrent = FindEntity(-1, "nrm_fireworks")

	while (iCurrent != -1) {
		temp = iCurrent
		iCurrent = FindEntity(iCurrent, "nrm_fireworks")
		Owner = Entvars_Get_Edict(temp,EV_ENT_owner)
		sid = floatround(Entvars_Get_Float(temp,EV_FL_fuser1))
		if (Owner == id && sid == salve) {
			Entvars_Set_String(temp,EV_SZ_classname,"fly_fireworks")
			Entvars_Set_Int(temp,EV_INT_effects,64)

			emit_sound(temp, CHAN_WEAPON, "weapons/rocketfire1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

			if (has_rocket)
				emit_sound(temp, CHAN_VOICE, "fireworks/rocket1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			else
				emit_sound(temp, CHAN_VOICE, "weapons/rocket1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

			r = Entvars_Get_Int(temp,EV_INT_iuser2)
			g = Entvars_Get_Int(temp,EV_INT_iuser3)
			b = Entvars_Get_Int(temp,EV_INT_iuser4)
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(22)
			write_short(temp)
			write_short(sprSmoke)
			write_byte(45)
			write_byte(4)
			write_byte(r)
			write_byte(g)
			write_byte(b)
			write_byte(255)
			message_end()
			Entvars_Set_Int(temp,EV_INT_iuser1,get_cvar_num("fireworks_maxlife"))
			Entvars_Get_Vector(temp,EV_VEC_velocity,vVelocity)
			vVelocity[0] = random_float(-150.0,150.0)
			vVelocity[1] = random_float(-150.0,150.0)
			Entvars_Set_Vector(temp,EV_VEC_velocity,vVelocity)
		}
	}

	return PLUGIN_HANDLED
}

public admin_createshooter(id,level,cid) {
	if (!(get_user_flags(id)&ADMIN_LEVEL_H)) {
		console_print(id, "[AMX] You have no access to that command")
		return PLUGIN_HANDLED
	}

	new Float:Return[3]
	new Float:Origin[3]
	VelocityByAim(id,64,Return)
	Entvars_Get_Vector(id,EV_VEC_origin,Origin)
	Origin[0] += Return[0]
	Origin[1] += Return[1]
	Origin[2] += Return[2]
	new Float:Angles[3]
	Angles[0] = 0.0
	Angles[1] = random_float(0.0,360.0)
	Angles[2] = 0.0
	new Float:Mins[3] = {-6.0, -6.0, -6.0}
	new Float:Maxs[3] = {1.0, 1.0, 10.0}
	new sr[8]
	new r

	new Ent = CreateEntity("info_target")
	if (Ent) {
		Entvars_Set_String(Ent,EV_SZ_classname,"shooter_fireworks")
		Entvars_Set_Vector(Ent,EV_VEC_origin,Origin)
		Entvars_Set_Vector(Ent,EV_VEC_angles,Angles)
		Entvars_Set_Edict(Ent,EV_ENT_owner,id)
		Entvars_Set_Int(Ent,EV_INT_solid,2)
		Entvars_Set_Int(Ent,EV_INT_movetype,6)
		if (read_argc() < 2) {
			Entvars_Set_Int(Ent,EV_INT_iuser1,get_cvar_num("fireworks_maxcount"))
		} else {
			read_argv(1,sr,sizeof(sr))
			r = strtonum(sr)
			Entvars_Set_Int(Ent,EV_INT_iuser1,r)
		}
		ENT_SetModel(Ent,"models/w_rpgammo.mdl")
		Entvars_Set_Vector(Ent,EV_VEC_mins,Mins)
		Entvars_Set_Vector(Ent,EV_VEC_maxs,Maxs)
	}

	return PLUGIN_HANDLED
}

public admin_removeshooter(id,level,cid) {
	if (!(get_user_flags(id)&ADMIN_LEVEL_H)) {
		console_print(id, "[AMX] You have no access to that command")
		return PLUGIN_HANDLED
	}

	new temp
	new iCurrent = FindEntity(-1, "shooter_fireworks")

	while (iCurrent != -1) {
		temp = iCurrent
		iCurrent = FindEntity(iCurrent, "shooter_fireworks")
		RemoveEntity(temp)
	}

	return PLUGIN_HANDLED
}

public admin_remover(id,level,cid) {
	if (!(get_user_flags(id)&ADMIN_LEVEL_H)) {
		console_print(id, "[AMX] You have no access to that command")
		return PLUGIN_HANDLED
	}

	new temp

	new iCurrent = FindEntity(-1, "nrm_fireworks")

	while (iCurrent != -1) {
		temp = iCurrent
		iCurrent = FindEntity(iCurrent, "nrm_fireworks")
		RemoveEntity(temp)

	}

	new iCurrent2 = FindEntity(-1, "fly_fireworks")

	while (iCurrent2 != -1) {
		temp = iCurrent2
		iCurrent2 = FindEntity(iCurrent2, "fly_fireworks")
		RemoveEntity(temp)

	}

	for (new i = 0; i <= 32; i++)
		fPlayer[i] = 0

	return PLUGIN_HANDLED
}

public admin_shoot(id,level,cid) {
	if (!(get_user_flags(id)&ADMIN_LEVEL_H)) {
		console_print(id, "[AMX] You have no access to that command")
		return PLUGIN_HANDLED
	}

	new Owner
	new r,g,b
	new iCurrent
	new iCurrent2
	new Float:vVelocity[3]
	new temp

	iCurrent2 = FindEntity(-1, "fly_fireworks")

	while (iCurrent2 != -1) {
		temp = iCurrent2
		iCurrent2 = FindEntity(iCurrent2, "fly_fireworks")
		Owner = Entvars_Get_Edict(temp,EV_ENT_owner)
		if (Owner != 0) {
			explode(temp)
			fPlayer[id]--
		}
	}

	iCurrent = FindEntity(-1, "nrm_fireworks")

	while (iCurrent != -1) {
		Owner = Entvars_Get_Edict(iCurrent,EV_ENT_owner)
		if (Owner != 0) {
			Entvars_Set_String(iCurrent,EV_SZ_classname,"fly_fireworks")
			Entvars_Set_Int(iCurrent,EV_INT_effects,64)

			emit_sound(iCurrent, CHAN_WEAPON, "weapons/rocketfire1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

			if (has_rocket)
				emit_sound(iCurrent, CHAN_VOICE, "fireworks/rocket1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			else
				emit_sound(iCurrent, CHAN_VOICE, "weapons/rocket1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

			r = Entvars_Get_Int(iCurrent,EV_INT_iuser2)
			g = Entvars_Get_Int(iCurrent,EV_INT_iuser3)
			b = Entvars_Get_Int(iCurrent,EV_INT_iuser4)
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(22)
			write_short(iCurrent)
			write_short(sprSmoke)
			write_byte(45)
			write_byte(4)
			write_byte(r)
			write_byte(g)
			write_byte(b)
			write_byte(255)
			message_end()
			Entvars_Set_Int(iCurrent,EV_INT_iuser1,get_cvar_num("fireworks_maxlife"))
			Entvars_Get_Vector(iCurrent,EV_VEC_velocity,vVelocity)
			vVelocity[0] = random_float(-150.0,150.0)
			vVelocity[1] = random_float(-150.0,150.0)
			Entvars_Set_Vector(iCurrent,EV_VEC_velocity,vVelocity)
		}
		iCurrent = FindEntity(iCurrent, "nrm_fireworks")
	}

	return PLUGIN_HANDLED
}

explode(id) {
	new Float:Origin[3]
	Entvars_Get_Vector(id,EV_VEC_origin,Origin)
	new szType[64],type
	get_cvar_string("fireworks_effect",szType,sizeof(szType))
	type = read_flags(szType)
	new r = Entvars_Get_Int(id,EV_INT_iuser2)
	new g = Entvars_Get_Int(id,EV_INT_iuser3)
	new b = Entvars_Get_Int(id,EV_INT_iuser4)

	if (type&(1<<0)) { //a
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(20) 				// TE_BEAMDISK
		write_coord(floatround(Origin[0]))			// coord coord coord (center position)
		write_coord(floatround(Origin[1]))
		write_coord(floatround(Origin[2]))
		write_coord(floatround(Origin[0]))			// coord coord coord (axis and radius)
		write_coord(floatround(Origin[1]))
		write_coord(floatround(Origin[2]+random_float(250.0,750.0)))
		switch(random_num(0,1)) {
			case 0: write_short(sprFlare6)			// short (sprite index)
			case 1: write_short(sprLgtning)			// short (sprite index)
		}
		write_byte(0)				// byte (starting frame)
		write_byte(0)				// byte (frame rate in 0.1's)
		write_byte(45)				// byte (life in 0.1's)
		write_byte(150)				// byte (line width in 0.1's)
		write_byte(0)				// byte (noise amplitude in 0.01's)
		write_byte(r)				// byte,byte,byte (color)
		write_byte(g)
		write_byte(b)
		write_byte(255)				// byte (brightness)
		write_byte(0)				// byte (scroll speed in 0.1's)
		message_end()
	}
	if (type&(1<<1) && get_cvar_num("fireworks_colortype")) { //b
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(15)				// TE_SPRITETRAIL
		write_coord(floatround(Origin[0]))			// coord, coord, coord (start)
		write_coord(floatround(Origin[1]))
		write_coord(floatround(Origin[2]-20.0))
		write_coord(floatround(Origin[0]))			// coord, coord, coord (end)
		write_coord(floatround(Origin[1]))
		write_coord(floatround(Origin[2]+20.0))
		if ((r == 255) && (g == 0) && (b == 0)) {
			write_short(sprRflare)
		} else if ((r == 0) && (g == 255) && (b == 0)) {
			write_short(sprGflare)
		} else if ((r == 0) && (g == 0) && (b == 255)) {
			write_short(sprBflare)
		} else if ((r == 0) && (g == 255) && (b == 255)) {
			write_short(sprTflare)
		} else if ((r == 255) && (g == 0) && (b == 255)) {
			write_short(sprPflare)
		} else if ((r == 255) && (g == 255) && (b == 0)) {
			write_short(sprYflare)
		} else if ((r == 255) && (g == 128) && (b == 0)) {
			write_short(sprOflare)
		} else {
			write_short(sprBflare)
		}
		write_byte(get_cvar_num("fireworks_flare_count"))				// byte (count)
		write_byte(10)				// byte (life in 0.1's)
		write_byte(10)				// byte (scale in 0.1's)
		write_byte(random_num(40,100))		// byte (velocity along vector in 10's)
		write_byte(40)				// byte (randomness of velocity in 10's)
		message_end()
	}
	if (type&(1<<2)) { //c
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(4)
		write_coord(floatround(Origin[0]))			// coord, coord, coord (start)
		write_coord(floatround(Origin[1]))
		write_coord(floatround(Origin[2]))
		message_end()
	}
	if (type&(1<<3)) { //d
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(122)
		write_coord(floatround(Origin[0]))			// coord, coord, coord (start)
		write_coord(floatround(Origin[1]))
		write_coord(floatround(Origin[2]))
		write_short(random_num(400,1000))
		write_byte(random_num(0,255))
		write_byte(40)
		message_end()
	}
	if (type&(1<<4)) { //e
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(27)
		write_coord(floatround(Origin[0]))			// coord, coord, coord (start)
		write_coord(floatround(Origin[1]))
		write_coord(floatround(Origin[2]))
		write_byte(60)			// byte (radius in 10's) 
		write_byte(r)			// byte byte byte (color)
		write_byte(g)
		write_byte(b)
		write_byte(100)			// byte (life in 10's)
		write_byte(15)			// byte (decay rate in 10's)
		message_end()
	}

	if (type&(1<<25)) { //z
		emit_sound(id, CHAN_VOICE, "weapons/mortarhit.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	}

	RemoveEntity(id)
}

public client_disconnect(id) {
	new Owner
	new temp

	new iCurrent2 = FindEntity(-1, "fly_fireworks")

	while (iCurrent2 != -1) {
		temp = iCurrent2
		iCurrent2 = FindEntity(iCurrent2, "fly_fireworks")
		Owner = Entvars_Get_Edict(temp,EV_ENT_owner)
		if (Owner == id) {
			RemoveEntity(temp)
		}
	}

	new iCurrent = FindEntity(-1, "nrm_fireworks")

	while (iCurrent != -1) {
		temp = iCurrent
		iCurrent = FindEntity(iCurrent, "nrm_fireworks")
		Owner = Entvars_Get_Edict(iCurrent,EV_ENT_owner)
		if (Owner == id) {
			RemoveEntity(temp)
		}
	}

	fPlayer[id] = 0
}

public fireworks_aktion(id,key) {
	switch(key) {
		case 0: {
			spawn(id,1)
			fireworks_menu(id)
		}
		case 1: {
			spawn(id,2)
			fireworks_menu(id)
		}
		case 2: {
			spawn(id,3)
			fireworks_menu(id)
		}
		case 3: {
			spawn(id,4)
			fireworks_menu(id)
		}
		case 4: {
			shoot(id,1)
			fireworks_menu(id)
		}
		case 5: {
			shoot(id,2)
			fireworks_menu(id)
		}
		case 6: {
			shoot(id,3)
			fireworks_menu(id)
		}
		case 7: {
			shoot(id,4)
			fireworks_menu(id)
		}
	}

	return PLUGIN_HANDLED
}

public fireworks_menu(id) {
	new fenable = get_cvar_num("fireworks_enable")
	new maxcount = get_cvar_num("fireworks_maxcount")
	if (fenable == 1) {
		if (!(get_user_flags(id)&ADMIN_LEVEL_H)) {
			return PLUGIN_HANDLED
		}
		maxcount = get_cvar_num("fireworks_amaxcount")
	} else if (fenable == 2) {
		if ((get_user_flags(id)&ADMIN_LEVEL_H)) {
			maxcount = get_cvar_num("fireworks_amaxcount")
		}
	} else {
		new Out[256]
		format(Out, 256, "Fireworks is disabled for you!")
		console_print(id, Out)
		set_hudmessage()
		show_hudmessage(id, Out, 4)
		return PLUGIN_HANDLED
	}

	new menu[1024]
	if (equali(Game,"cstrike")) {
		new tmp[8]
		if (fPlayer[id] == maxcount) {
			tmp = "\r"
		}
		format(menu,sizeof(menu),"\yFireworks Menu %s(%d of %d)\w^n^n1. Spawn Rocket (Salve 1)^n2. Spawn Rocket (Salve 2)^n3. Spawn Rocket (Salve 3)^n4. Spawn Rocket (Salve 4)^n5. Fire Rockets (Salve 1)^n6. Fire Rockets (Salve 2)^n7. Fire Rockets (Salve 3)^n8. Fire Rockets (Salve 4)^n^n0. Exit",tmp,fPlayer[id],maxcount)
	} else {
		format(menu,sizeof(menu),"Fireworks Menu (%d of %d)^n^n1. Spawn Rocket (Salve 1)^n2. Spawn Rocket (Salve 2)^n3. Spawn Rocket (Salve 3)^n4. Spawn Rocket (Salve 4)^n5. Fire Rockets (Salve 1)^n6. Fire Rockets (Salve 2)^n7. Fire Rockets (Salve 3)^n8. Fire Rockets (Salve 4)^n^n0. Exit",fPlayer[id],maxcount)
	}
	show_menu(id,((1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<9)),menu)
	return PLUGIN_HANDLED
}

public client_putinserver(id) {
	if (!is_user_bot(id)){
		new param[3]
		param[0] = id
		set_task(15.0,"display_info",0,param,2)
	}

	return PLUGIN_CONTINUE
}

public display_info(param[]){
	new id = param[0]
	if (id) {
		client_print(id,print_chat,"Type 'fireworks_menu' in the console to open the fireworks menu")
		client_cmd(id,"bind 1 slot1")
		client_cmd(id,"bind 2 slot2")
		client_cmd(id,"bind 3 slot3")
		client_cmd(id,"bind 4 slot4")
		client_cmd(id,"bind 5 slot5")
		client_cmd(id,"bind 6 slot6")
		client_cmd(id,"bind 7 slot7")
		client_cmd(id,"bind 8 slot8")
		client_cmd(id,"bind 9 slot9")
		client_cmd(id,"bind 0 slot10")
	}
}

public plugin_precache() {
	precache_sound("weapons/rocketfire1.wav")
	precache_sound("weapons/mortarhit.wav")

	if (file_exists("sound/fireworks/rocket1.wav")) {
		precache_sound("fireworks/rocket1.wav")
		has_rocket = 1
	} else {
		precache_sound("weapons/rocket1.wav")
		has_rocket = 0
	}

	if (file_exists("sound/fireworks/weapondrop1.wav")) {
		precache_sound("fireworks/weapondrop1.wav")
		has_drop = 1
	} else {
		precache_sound("items/weapondrop1.wav")
		has_drop = 0
	}

	precache_model("models/rpgrocket.mdl")
	precache_model("models/w_rpgammo.mdl")

	sprSmoke = precache_model("sprites/smoke.spr")
	sprFlare6 = precache_model("sprites/flare6.spr")
	sprLgtning = precache_model("sprites/lgtning.spr")

	sprBflare = precache_model("sprites/fireworks/bflare.spr")
	sprRflare = precache_model("sprites/fireworks/rflare.spr")
	sprGflare = precache_model("sprites/fireworks/gflare.spr")
	sprTflare = precache_model("sprites/fireworks/tflare.spr")
	sprOflare = precache_model("sprites/fireworks/oflare.spr")
	sprPflare = precache_model("sprites/fireworks/pflare.spr")
	sprYflare = precache_model("sprites/fireworks/yflare.spr")

	return PLUGIN_CONTINUE
}

public plugin_init() {
	register_plugin(Title,Version,Author)

	set_task(0.1, "fireworks_think", 21, "", 0, "b")
	set_task(0.3, "shooter_think", 21, "", 0, "b")

	register_menucmd(register_menuid("Fireworks Menu"),((1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<9)),"fireworks_aktion")

	register_clcmd("fireworks_menu","fireworks_menu")

	register_clcmd("say","HandleSay")

	register_concmd("fireworks_spawn","fireworks_spawn")
	register_concmd("fireworks_spawn_rgb","fireworks_spawn_rgb")
	register_concmd("fireworks_shoot","fireworks_shoot")

	register_concmd("amx_create_shooter","admin_createshooter",ADMIN_LEVEL_H)
	register_concmd("amx_remove_shooter","admin_removeshooter",ADMIN_LEVEL_H)
	register_concmd("amx_remove_rockets","admin_remover",ADMIN_LEVEL_H)
	register_concmd("amx_shoot_rockets","admin_shoot",ADMIN_LEVEL_H)

	if (!cvar_exists("fireworks_enable"))
		register_cvar("fireworks_enable","1",FCVAR_SERVER)
	if (!cvar_exists("fireworks_maxlife"))
		register_cvar("fireworks_maxlife","20",FCVAR_SERVER)
	if (!cvar_exists("fireworks_flare_count"))
		register_cvar("fireworks_flare_count","30",FCVAR_SERVER)
	if (!cvar_exists("fireworks_maxcount"))
		register_cvar("fireworks_maxcount","4",FCVAR_SERVER)
	if (!cvar_exists("fireworks_effect"))
		register_cvar("fireworks_effect","abez",FCVAR_SERVER)
	if (!cvar_exists("fireworks_velocity_min"))
		register_cvar("fireworks_velocity_min","1800.0",FCVAR_SERVER)
	if (!cvar_exists("fireworks_velocity_max"))
		register_cvar("fireworks_velocity_max","2000.0",FCVAR_SERVER)
	if (!cvar_exists("fireworks_velocity_xy"))
		register_cvar("fireworks_velocity_xy","100.0",FCVAR_SERVER)
	if (!cvar_exists("fireworks_colortype"))
		register_cvar("fireworks_colortype","1",FCVAR_SERVER)
	if (!cvar_exists("fireworks_amaxcount"))
		register_cvar("fireworks_amaxcount","16",FCVAR_SERVER)

	register_cvar("fireworks_version",Version,FCVAR_SERVER|FCVAR_EXTDLL|FCVAR_UNLOGGED|FCVAR_SPONLY)

	get_modname(Game,sizeof(Game))

	return PLUGIN_CONTINUE
}
