/*
*
* AMX_GRAVITY
*  by JustinHoMi
*
*/

#include <amxmod>

public admin_gravity(id,level){
	if (!(get_user_flags(id)&level)){
			console_print(id,"[AMX] You have no access to that command.")
			return PLUGIN_HANDLED
		}
	if (read_argc() < 2){
		    new gravity_cvar = get_cvar_num("sv_gravity")
		    console_print(id,"[AMX] ^"sv_gravity^" is ^"%i^"",gravity_cvar)
		    return PLUGIN_HANDLED
	}
	new gravity[6]
	read_argv(1,gravity,6)
	server_cmd("sv_gravity %s",gravity)
	console_print(id,"[AMX] Gravity has been set to %s",gravity)
	return PLUGIN_HANDLED
}

public check_gravity(id){
	new gravity = get_cvar_num("sv_gravity")
	client_print(id,print_chat,"[AMX] The gravity is set at %i",gravity)
	return PLUGIN_HANDLED
}

public plugin_init(){
	register_plugin("Admin Gravity","0.2","JustinHoMi")
	register_concmd("amx_gravity","admin_gravity",ADMIN_CVAR,"< gravity >")
	register_clcmd("say /gravity","check_gravity")
	register_clcmd("say_team /gravity","check_gravity")
	return PLUGIN_CONTINUE
}
