/* AMX Mod script.
*
* Admin Weapon II
*  by SniperBeamer
*
*
* Description: Give clients weapons.
*
* Settings: amx_weaponmsg (0/1) - announces when a player gets a weapon
*
* Usage: amx_weapon <authid, nick, @team, @all or #userid> <weapon #>
* Example: amx_weapon SniperBeamer 43
*
*/

#include <amxmod>
#include <amxmisc>
#include <fun>

public plugin_init()
{
	register_plugin("Admin Weapon II","1.0","SniperBeamer")
	register_cvar("amx_weaponmsg","0")
	register_concmd("amx_weapon","admin_weapon",ADMIN_LEVEL_A,"<authid, nick, @team, @all or #userid> <weapon #>")
}

public admin_weapon(id,level,cid)
{
	if ( !cmd_access(id,level,cid,3) )
		return PLUGIN_HANDLED

	new arg1[32],arg2[8],weapon
	read_argv(1,arg1,31)
	read_argv(2,arg2,7)
	weapon = str_to_num(arg2)

	if ( equali(arg1,"@all") )
	{
		new plist[32],pnum
		get_players(plist,pnum,"a")
		if (pnum==0)
		{
			console_print(id,"[AMX] There are no clients")
			return PLUGIN_HANDLED
		}
		for (new i=0; i<pnum; i++)
				if ( !give_weapon(plist[i],weapon) )
				{
					console_print(id,"[AMX] Gave all players the weapon %d",weapon)
				}
		console_print(id,"[AMX] Gave all players the weapon %d",weapon)
		if (!get_cvar_num("amx_weaponmsg")) return PLUGIN_HANDLED
		set_hudmessage(10,200,10,-1.0,0.30,0,6.0,6.0,0.5,0.15,1)
		show_hudmessage(0,"All players have been given a weapon!")
	}
	else if ( arg1[0]=='@' )
	{
		new plist[32],pnum
		get_players(plist,pnum,"ae",arg1[1])
		if ( pnum==0 )
		{
			console_print(id,"[AMX] No clients in such team")
			return PLUGIN_HANDLED
		}
		for (new i=0; i<pnum; i++)
				give_weapon(plist[i],weapon)
		console_print(id,"[AMX] Gave all %ss the weapon %d",arg1[1],weapon)
		if ( get_cvar_num("amx_weaponmsg") )
		{
			if (equali(arg1[1],"CT")) set_hudmessage(200,20,0,-1.0,0.30,0,6.0,6.0,0.5,0.15,1)
			else set_hudmessage(0,20,200,-1.0,0.30,0,6.0,6.0,0.5,0.15,1)
			show_hudmessage(0,"The %ss have been given a weapon!",arg1[1])
		}
	}
	else
	{
		new pName[32]
		new player = cmd_target(id,arg1,6)
		if (!player) return PLUGIN_HANDLED
		give_weapon(player,weapon)
		get_user_name(player,pName,31)
		console_print(id,"[AMX] Gave %s the weapon %d",pName,weapon)
		if (get_cvar_num("amx_weaponmsg"))
		{
			set_hudmessage(10,200,10,-1.0,0.30,0,6.0,6.0,0.5,0.15,1)
			show_hudmessage(0,"%s has been given a weapon!",pName)
		}
	}

	return PLUGIN_HANDLED
}

give_weapon(id,weapon)
{
	switch (weapon)
	{
		//secondary weapons
		//pistols
		case 11:{
			give_item(id,"weapon_usp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
		}
		case 12:{
			give_item(id,"weapon_glock18")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
		}
		case 13:{
			give_item(id,"weapon_deagle")
			give_item(id,"ammo_50ae")
			give_item(id,"ammo_50ae")
			give_item(id,"ammo_50ae")
			give_item(id,"ammo_50ae")
			give_item(id,"ammo_50ae")
			give_item(id,"ammo_50ae")
			give_item(id,"ammo_50ae")
		}
		case 14:{
			give_item(id,"weapon_p228")
			give_item(id,"ammo_357sig")
			give_item(id,"ammo_357sig")
			give_item(id,"ammo_357sig")
			give_item(id,"ammo_357sig")
			give_item(id,"ammo_357sig")
			give_item(id,"ammo_357sig")
		}
		case 15:{
			give_item(id,"weapon_elite")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
		}
		case 16:{
			give_item(id,"weapon_fiveseven")
			give_item(id,"ammo_57mm")
			give_item(id,"ammo_57mm")
			give_item(id,"ammo_57mm")
			give_item(id,"ammo_57mm")
		}
		//primary weapons
		//shotguns
		case 21:{
			give_item(id,"weapon_m3")
			give_item(id,"ammo_buckshot")
			give_item(id,"ammo_buckshot")
			give_item(id,"ammo_buckshot")
			give_item(id,"ammo_buckshot")
		}
		case 22:{
			give_item(id,"weapon_xm1014")
			give_item(id,"ammo_buckshot")
			give_item(id,"ammo_buckshot")
			give_item(id,"ammo_buckshot")
			give_item(id,"ammo_buckshot")
		}
		//smgs
		case 31:{
			give_item(id,"weapon_mp5navy")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
		}
		case 32:{
			give_item(id,"weapon_tmp")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
		}
		case 33:{
			give_item(id,"weapon_p90")
			give_item(id,"ammo_57mm")
			give_item(id,"ammo_57mm")
			give_item(id,"ammo_57mm")
			give_item(id,"ammo_57mm")
		}
		case 34:{
			give_item(id,"weapon_mac10")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
		}
		case 35:{
			give_item(id,"weapon_ump45")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
			give_item(id,"ammo_45acp")
		}
		//rifles
		case 41:{
			give_item(id,"weapon_ak47")
			give_item(id,"ammo_762nato")
			give_item(id,"ammo_762nato")
			give_item(id,"ammo_762nato")
		}
		case 42:{
			give_item(id,"weapon_sg552")
			give_item(id,"ammo_556nato")
			give_item(id,"ammo_556nato")
			give_item(id,"ammo_556nato")
		}
		case 43:{
			give_item(id,"weapon_m4a1")
			give_item(id,"ammo_556nato")
			give_item(id,"ammo_556nato")
			give_item(id,"ammo_556nato")
		}
		case 44:{
			give_item(id,"weapon_aug")
			give_item(id,"ammo_556nato")
			give_item(id,"ammo_556nato")
			give_item(id,"ammo_556nato")
		}
		case 45:{
			give_item(id,"weapon_scout")
			give_item(id,"ammo_762nato")
			give_item(id,"ammo_762nato")
			give_item(id,"ammo_762nato")
		}
		case 46:{
			give_item(id,"weapon_awp")
			give_item(id,"ammo_338magnum")
			give_item(id,"ammo_338magnum")
			give_item(id,"ammo_338magnum")
		}
		case 47:{
			give_item(id,"weapon_g3sg1")
			give_item(id,"ammo_762nato")
			give_item(id,"ammo_762nato")
			give_item(id,"ammo_762nato")
		}
		case 48:{
			give_item(id,"weapon_sg550")
			give_item(id,"ammo_556nato")
			give_item(id,"ammo_556nato")
			give_item(id,"ammo_556nato")
		}
		//machine gun
		case 51:{
			give_item(id,"weapon_m249")
			give_item(id,"ammo_556natobox")
			give_item(id,"ammo_556natobox")
			give_item(id,"ammo_556natobox")
			give_item(id,"ammo_556natobox")
			give_item(id,"ammo_556natobox")
			give_item(id,"ammo_556natobox")
			give_item(id,"ammo_556natobox")
		}
		//equipment
		case 81:{
			give_item(id,"item_kevlar")
		}
		case 82:{
			give_item(id,"item_assaultsuit")
		}
		case 83:{
			give_item(id,"weapon_flashbang")
			give_item(id,"weapon_flashbang")
		}
		case 84:{
			give_item(id,"weapon_hegrenade")
		}
		case 85:{
			give_item(id,"weapon_smokegrenade")
		}
		case 86:{
			give_item(id,"item_thighpack")
		}
		default: return false
	}
	return true
}
