/* Admin Gag cmd 1.2.1
About:
This plugin allows you to gag players from using say_team or normal say, even voicecomm can be muted. It also echos admin acctions 
based on amx_show_activity. Admins with immunity will not be executed on, unless their executing on themself

Usage:
amx_gag <nick/userid> <flags (a/b/c)> <time in seconds> // lets you control what you want to gag
amx_gag <nick/userid>  <time in seconds> // Will automaticly add the abc flag.
amx_gag <nick/userid>	// Will automaticly add abc flag, and 600 secounds gag.
amx_ungag <nick/userid> // Will remove all "gags"

Forum  topic: http://djeyl.net/forum/index.php?showtopic=28689
Note: If you dont want to use vexd module or dont need to be able to mute voice comm. Please download version 1.10 from http://home.no/eks/amx_plugins/

Credits:
This plugin is heavly based on the work of tcquest78 in his gag plugin http://djeyl.net/forum/index.php?showtopic=4962
OP`s in #amxmod @ Quakenet, for helping me alot with my endless questions.

Changelog:
    1.2.1 ( 06.02.2004 )
	- Fixed support for #userid again
	- Now use console_print to echo when player is not gaged ( in amx_ungag )

    1.2
	- Now supports muting voicecomm ( the flag c )
        - REQUIRES Vexd module, use 1.1 if you dont want to run this module
	
    1.1
	- Now supports amx_gag <nick> <time> ( Adds ab as flag if no other flag is entered.)
	- Now supports amx_gag <nick/auth>
	- Fixed echoing with amx_show_activity 1 not showing the secounds

    1.0  (Changes are from the orinal plugin to this one)
	- Now echos admin acctions based on amx_show_activity
	- Now echos when a player is ungaged by admin
	- Now echos when a player is ungaged becuse the "time" has run out.
	- Now echos when a gaged player disconnects
	- Admins with immunity flag can do actions on themself.
	- If you try to ungag a player thats not gaged, you get a "error" message
	- Changed the "your gaged" message so its simpler to spot in Steam.
	- Somehow the compiled file is smaller then with the orignal
	
Known issues:
* Trying to ungag a player that does not exist. It will echo that the player is not gaged
*/

#include <amxmod>
#include <amxmisc>
#include <Vexd_Utilities>

new gGagPlayers[33] 

public plugin_init() { 
	register_plugin("Admin Gag cmd","1.2.1","EKS/tcquest78") 
	register_clcmd("say","block_gaged") 
	register_clcmd("say_team","block_gaged") 
	register_concmd("amx_gag","amx_gag",ADMIN_KICK,"<nick or #userid> <a|b> [time]") 
	register_concmd("amx_ungag","amx_ungag",ADMIN_KICK,"<nick or #userid>") 
	return PLUGIN_CONTINUE 
	} 

public block_gaged(id){ 
	if(!gGagPlayers[id]) return PLUGIN_CONTINUE // Checks if player is gaged or not.
	new cmd[6] 
	read_argv(0,cmd,4) 
	if ( cmd[3] == '_' )
		{ 
		if (gGagPlayers[id] & 2){ 
			client_print(id,print_chat,"* You are gagged...") 
			return PLUGIN_HANDLED 
			} 
		} 
	else if (gGagPlayers[id] & 1)   { 
		client_print(id,print_chat,"* You are gagged...") 
		return PLUGIN_HANDLED 
		} 
	return PLUGIN_HANDLED 
	} 
public amx_gag(id,level,cid) { 
	new arg[32],AdminName[32],VictimID
	new sgagtime[8] = 0
	read_argv(1,arg,31)  			// Arg contains Targets nick or Userid
	VictimID = cmd_target(id,arg,8)
	get_user_name(id,AdminName,31)		// Gets Admin name
	if ((get_user_flags(VictimID) & ADMIN_IMMUNITY) && VictimID != id) { return PLUGIN_HANDLED; } // Checks admin immunity, but will execute on if the admin tried to execute on self.
	if (!VictimID) return PLUGIN_HANDLED // Checks if target is anything else then a "human" player

	new sflags[4] 
	read_argv(2,sflags,3) 

	read_argv(3,sgagtime,7) 
	if(isdigit(sflags[0])) // This code checks if the "sflags" contains a number instead. If it does, it move the number to gag time and sets def. flags
		{
		format(sgagtime,7,"%s",sflags)
		sflags = "abc"
		}
	new flags = read_flags(sflags) 
	if (strlen(sgagtime) == 0 ) // This code should check if sgagtime is emty, if it is give sgagtime a value of 600. Also ads the value 7 to flags ( witch means gag say/team_say and voicecomm)
		{
		format(sgagtime,7,"600")
		flags = 7
		}
	new Float:gagtime = floatstr(sgagtime)	
	gGagPlayers[VictimID] = flags 
	if(flags & 3) // This code checks if the c flag was used ( reprisented by the number 3 ), If pressent it mutes his voicecomm.
		{
		SetSpeak(VictimID, SPEAK_LISTENALL)
		client_print(0,print_chat,"Voice comm should be muted now.") 
		}
		
	new param[2]
	param[0] = VictimID 
	set_task( gagtime,"ungag",VictimID,param,1) 
   	switch(get_cvar_num("amx_show_activity"))   { 
   		case 2:   client_print(0,print_chat,"ADMIN %s: has gaged %s from speaking for %s seconds",AdminName,arg,sgagtime,flags,sflags) 
   		case 1:   client_print(0,print_chat,"ADMIN: has gaged %s from speaking for %s seconds",arg,sgagtime) 
  	 	}	
	return PLUGIN_HANDLED 
	} 


public ungag(param[]) // Removes gag when the time is passed
	{ 
	new VictimName[32],VictimID
	VictimID = param[0]
	get_user_name(VictimID,VictimName,31)
	gGagPlayers[VictimID] = 0 
	remove_task(VictimID)
	SetSpeak(param[0], SPEAK_NORMAL)
	client_print(0,print_chat,"ADMIN: %s is no longer gaged",VictimName)
	return PLUGIN_HANDLED 
	} 

public amx_ungag(id,level,cid) {  /// Removed gaged player ( done via console command )
	new arg[32],AdminName[32],VictimID 
	read_argv(1,arg,31)  			// Arg contains Targets nick
	VictimID = cmd_target(id,arg,8) 	// Finds VictimID based on whats in arg
	get_user_name(id,AdminName,31)		// Gets Admin name
	if(!gGagPlayers[VictimID])		// Checks if player has gaged flag
		{
		console_print(id,"%s is not gaged, and cannot be ungaged.",arg)
		return PLUGIN_HANDLED
		}
	gGagPlayers[VictimID] = 0 
	SetSpeak(VictimID, SPEAK_NORMAL)
	remove_task(VictimID)
	switch(get_cvar_num("amx_show_activity"))   { 
   		case 2:   client_print(0,print_chat,"ADMIN %s: has ungaged %s",AdminName,arg) 
   		case 1:   client_print(0,print_chat,"ADMIN: has ungaged %s",arg) 
  	 	}
	return PLUGIN_HANDLED 
	} 

public client_disconnect(id) 
	{ 
	if(gGagPlayers[id]) // Checks if disconnected player is gaged, and removes flags from his id.
		{
		new Temp[32]
		get_user_name(id,Temp,31)
		gGagPlayers[id] = 0 
		SetSpeak(id, SPEAK_NORMAL)
		remove_task(id)
		client_print(0,print_chat,"%s gaged player has disconnected",Temp)
		}
	return PLUGIN_HANDLED 
	}
