/* AMXMOD script. 
*
* (c) Copyright 2000-2002, SBloP - This file is provided as is (no warranties).  Thanks to Rich.
*
* Alive FPH 1.0
*
* - Shows your Frags Per Hour
*
* - Only Counts time your alive and playing
*
* - Shows top 3 rankings every 45 seconds
*/

#include <amxmod>

new topid[4], showfph[33], alivetime[33], Float:topfph[4]



public plugin_init()
{
  register_plugin("FPH", "1.0", "Rich")
  register_cvar("amx_fph", "1")
  register_cvar("amx_fpha", "1")
//  register_clcmd("say /fphon","fph_on")
  register_event("find_fph","show_top","hud") 
  set_task(1.0,"find_fph",0,"",0,"b")
  set_task(45.0,"show_top",0,"",0,"b")
}



public find_fph()
{
  if (!(get_cvar_num("amx_fph")))
  {
    return PLUGIN_CONTINUE
  }

  set_hudmessage(50, 0, 150, -1.0, 0.04, 0, 1.0, 5.0, 0.1, 0.0, 11)

  topid[1] = 0
  topid[2] = 0
  topid[3] = 0
  topfph[1] = 0.0
  topfph[2] = 0.0
  topfph[3] = 0.0

  new playernum, players[32]
  get_players(players,playernum)

  for(new a = 0; a < playernum; ++a) 
  { 
    if (is_user_alive(players[a]) == 1)
    {
      ++alivetime[players[a]]
    }

    new Float:fph = get_user_frags(players[a]) * 60 * 60 / float(alivetime[players[a]])

    if (showfph[players[a]])
    {
      show_hudmessage(players[a],"KILLS: %i - SECONDS: %i - FPH: %.2f", get_user_frags(players[a]), alivetime[players[a]], fph)
    } 

    if (fph > topfph[1])
    {
      topid[3] = topid[2]
      topid[2] = topid[1]
      topid[1] = players[a]
      topfph[3] = topfph[2]
      topfph[2] = topfph[1]
      topfph[1] = fph
    }
    else if (fph >= topfph[2] && players[a] != topid[1])
    {
      topid[3] = topid[2]
      topid[2] = players[a]
      topfph[3] = topfph[2]
      topfph[2] = fph
    }
    else if (fph >= topfph[3] && players[a] != topid[1] && players[a] != topid[2])
    {
      topid[3] = players[a]
      topfph[3] = fph
    }
  }
  return PLUGIN_CONTINUE
}

public show_top(id)
{
  new namea[33], nameb[33], namec[33]
  get_user_name(topid[1], namea, 32)
  get_user_name(topid[2], nameb, 32)
  get_user_name(topid[3], namec, 32)
  client_print(0, print_chat, "FPH RANKING: 1. %s (%.2f) - 2. %s (%.2f) - 3. %s (%.2f)", namea,  topfph[1], nameb, topfph[2], namec, topfph[3])
  showfph[id] = true
  return PLUGIN_CONTINUE
}

//public fph_on(id)
//{
//  showfph[id] = true
//  return PLUGIN_CONTINUE
// }

//public fph_off(id)
//{
//  showfph[id] = false
//  return PLUGIN_CONTINUE
//}

public client_connect(id)
{
  showfph[id] = true
  return PLUGIN_CONTINUE
}

public client_disconnect(id)
{
  showfph[id] = false
  return PLUGIN_CONTINUE
}

//public hud(id){ 
//if (get_cvar_num("amx_fpha")!=1) 
//{
//showfph[id] = true
//return PLUGIN_CONTINUE
//} 


//public hud(id)
//{
//  if (!(get_cvar_num("amx_fpha")))
//  {
//    return PLUGIN_CONTINUE
//  }
//showfph[id] = true
//}



