/* AMX Mod script. 
* 
* AMX Auto Remove Password (auto_remove_pass)
* 
* (c) Copyright 2003 by Marach (marach@phreaker.net, ICQ: 242122535, AIM: marach24, MSN IM: marach24@hotmail.com)
* 
* This file is provided as is (no warranties). 
*
* This plugin will remove password from server if it's empty for some time. It's written for the need of Croatian
* CS community which has only few clan servers which are used by more than one clan. Sometimes one clan forgot to 
* remove the password before they left the server and other clan couldn't connect and play their match. With this
* plugin you don't have to worry about such problems anymore.
*
* Usage:
*	- open file addons\amx\admin.cfg
*	- add these lines to admin.cfg only if you don't like defaults:
*		arp_checkdelay <delay>
*		arp_checktimes <number of checks>
*	- save the changes to file admin.cfg :)
*
* CVAR explanation:
*	arp_checkdelay - delay in seconds between each check (default is 60 seconds)
*	arp_checktimes - number of checks before plugin removes password from the server (default is 5 checks)
* If you leave defaults (you don't add any lines to admin.cfg) then the plugin will remove the password from the
* server after 5 minutes (60 seconds * 5 = 300 seconds = 5 minutes).
*
* Example (admin.cfg):
*	arp_checkdelay 30
*	arp_checktimes 3
* Plugin will check every 30 seconds if there are any players on server. If the server is still empty after the
* 3rd check then the server password will be cleared.
*
*/

#include <amxmod>

new numchecked

public check_server() {
	remove_task(1410)
	new curpass[32]
	get_cvar_string("sv_password", curpass, 31)
	if (strlen(curpass)>0) {
		new players[32], curnum
		get_players(players, curnum, "c")
		if (curnum==0) {
			numchecked++
			if (numchecked>(get_cvar_num("arp_checktimes"))) {
				set_cvar_string("sv_password","")	
				server_print("* [ARP] Server password cleared")
				numchecked=1
				}
			}
		else
			numchecked=1
		}
	else
		numchecked=1
	new Float:freq=get_cvar_float("arp_checkdelay")
	if (freq>0.0) set_task(freq, "check_server", 1410)
	return PLUGIN_CONTINUE
}

public plugin_init() {
	register_plugin("Auto Remove Password", "1.0", "Marach")
	register_cvar("arp_checkdelay", "60")
	register_cvar("arp_checktimes", "5")	
	numchecked=1
	new Float:freq=get_cvar_float("arp_checkdelay")
	if (freq>0.0) set_task(freq, "check_server", 1410)
	return PLUGIN_CONTINUE
}
