#include <amxmod> 
#include <amxmisc>
#include <fun>
#include <csstats>

/*follow declaring method borrowed from amx_gore, just giving credit where its due*/
#define PISTOLS 		(1<<0) // "a"
#define SMGS 		(1<<1) // "b"
#define AUTOSNIPE	(1<<2) // "c"
#define SHAKEYHANDS	(1<<3) // "d"
#define DEAF		(1<<5) // "f"
#define HIGHDAMAGE	(1<<4) // "e"
#define BELT		(1<<6) // "g"
#define RATE_CONTROL	(1<<7) // "h"

new msgfade, msgtweak, msgStatusText, countdown, injured[33], flashed[33], money[33], fire
new bool: belted[33]

public plugin_init() {
	new i
	msgfade = get_user_msgid("ScreenFade")
	msgtweak = get_user_msgid("ScreenShake")
	msgStatusText = get_user_msgid("StatusText")
	register_plugin("CS Revamped","1.0","[FBX]")
	register_cvar("cs_revamped","abcdefgh") //a is for pistols, b is for smgs, c is for autosnipers, d is for arm shaking, e is for high damage red flash, f is for flashbang, and g is for suicide belt
	register_cvar("amx_suicidebelt", "30")
	register_event("Damage","damage_event","be","2!0","3=0","4!0")
	register_event("RoundTime", "stopshake", "bc") 
	register_event("ScreenFade","flashed_event","be","1>30","4!0","5!30")
	register_event("Health", "dies", "b", "1<1")
	register_concmd("amx_sbelt","decide",ADMIN_USER,"  Buy or detonate a suicide belt.")
	register_event("Money","get_cash","b")
	set_task(1.0, "counter", 2, "", 0, "b")
	set_task(40.0, "go_rates", 3, "", 0, "b")
	set_task(500.0, "remind", 4, "", 0, "b")
	set_task(random_float(1.0, 2.0), "restore_hearing", 1,"",0,"b")
	for(i = 0; i < 33; i++) {
		injured[i] = 0
		flashed[i] = 0
		money[i] = 800
	}
	return PLUGIN_CONTINUE
}

public plugin_precache(){ 
   fire = precache_model("sprites/explode1.spr") 
}

public remind() {
	new i, moder = getmode()
	if(moder&BELT) {
		for(i = 0; i < 32; i++) {
			if(is_user_connected(i) == 1) {
				client_print(i, print_chat, "To use the suicide belt, bind a key to 'amx_sbelt'.")
				client_print(i, print_chat, "It costs $500 to buy and you must be a terrorist.")
			}
		}
	}
}

public dies(id) {
	belted[id] = false
}

public go_rates() {
	new iping, iloss, i
	new moder = getmode()
	if(moder&RATE_CONTROL) {
	for(i = 0; i < 33; i++) {
	if(is_user_connected(i) == 1) {
		get_user_ping(i, iping, iloss)
		if(iping < 100 && iping != 0)
			client_cmd(i, "cl_rate 20000")
		if(iping < 175 && iping >= 100)
			client_cmd(i, "cl_rate 16000")
		if(iping < 250 && iping >= 175)
			client_cmd(i, "cl_rate 4400")
		if(iping < 350 && iping >= 250)
			client_cmd(i, "cl_rate 3300")
		if(iping >= 350)
			client_cmd(i, "cl_rate 2400")
	}
	}
	}
}

public client_disconnect(id) {
	belted[id] = false
}

public counter() {
	countdown++
}

public get_cash(id) {
	new current = read_data(1)
	money[id] = current
}

public bool: findonteam(id) {
	new  team[32], i, num
	get_players(team, num, "e", "CT")
	for (i = 0; i < 33; i++) {
		if(team[i] == id)
			return true
	}
	return false
}


public decide(id) {
	new buytime
	new moder = getmode()
	if(moder&BELT) {
	if(findonteam(id)) {
		client_print(id, print_chat, "You are not a terrorist")
		return PLUGIN_HANDLED
	}
	if(is_user_alive(id) == 0) {
		client_print(id, print_chat, "Your dead")
		return PLUGIN_HANDLED
	}
	buytime = get_cvar_num("amx_suicidebelt")
	if(buytime > countdown && !belted[id]) {
		if(money[id] >= 500) {
			client_print(id, print_chat, "You have purchased a suicide belt for $500")
			money[id] -= 500
			set_user_money(id,money[id],1)
			belted[id] = true
			 message_begin( MSG_ONE, msgStatusText, {0,0,0}, id) 
  			 write_byte(0) 
			 write_string("Suicide Belt") 
  			 message_end()
			return PLUGIN_HANDLED
		} else {
			client_print(id, print_chat, "Sorry your are not financed enough for a suicide belt")
		}
	}
	if(buytime < countdown && !belted[id]) {
		client_print(id, print_chat, "You cannot buy a suicide belt now, %i out of %i sec have passed", countdown, buytime)
	}
	if(belted[id]) {
		explode(id)
	}
	}
	return PLUGIN_HANDLED
}

// Credit given to authors of Nukem and Kamikazi for the time they spent on their code- I'll admit the explosions all borrowed from nukem and some of the explosion code borrowed from kamikazi
public explode(id) {
	new place[3], other[3], kills = 0, frags = 0, victimfrag = 0
	frags = get_user_frags(id)
	belted[id] = false
	get_user_origin(id, place)
	
	//Explosion2 
	   message_begin( MSG_BROADCAST,SVC_TEMPENTITY) 
	   write_byte( 12 ) 
	   write_coord(place[0]) 
	   write_coord(place[1]) 
	   write_coord(place[2]) 
	   write_byte( 188 ) // byte (scale in 0.1's) 188 
	   write_byte( 10 ) // byte (framerate) 
	   message_end() 
    	  
	   //TE_Explosion 
	   message_begin( MSG_BROADCAST,SVC_TEMPENTITY,place) 
	   write_byte( 3 ) 
	   write_coord(place[0]) 
	   write_coord(place[1]) 
	   write_coord(place[2]) 
	   write_short( fire ) 
	   write_byte( 188 ) // byte (scale in 0.1's) 188 
	  write_byte( 10 ) // byte (framerate) 
	   write_byte( 0 ) // byte flags 
	   message_end()
	new i, distance, short
	for(i = 0; i < 32; i++) {
		if(is_user_alive(i) && i != id) {
			get_user_origin(i,other)
			distance = place[0] - other[0]
			if(distance < 0)
				distance = distance * -1
			short = place[1] - other[1]
			if(short < 0)
				short = short * -1
			distance += short
			short = place[2] - other[2]
			if(short < 0)
				short = short * -1
			distance += short
			victimfrag = get_user_frags(i)
			if(findonteam(i)) {
			if(distance < 350) {
				set_user_frags(i,victimfrag + 1)
				set_user_health(i, 0)
			}
			if(distance >= 350 && distance < 400) {
				if(get_user_health(i) - 75 <= 0)
					set_user_frags(i,victimfrag + 1)
				set_user_health(i, get_user_health(i) - 75)
			}
			if(distance >= 400 && distance < 500) {
				if(get_user_health(i) - 40 <= 0)
					set_user_frags(i,victimfrag + 1)
				set_user_health(i, get_user_health(i) - 40)
			}
			if(distance >= 500 && distance < 550) {
				if(get_user_health(i) - 15 <= 0)
					set_user_frags(i,victimfrag + 1)
				set_user_health(i, get_user_health(i) - 15)
			}
			if(distance >= 550 && distance < 800) {
				if(get_user_health(i) - 5 <= 0)
					set_user_frags(i,victimfrag + 1)
				set_user_health(i, get_user_health(i) - 5)
			}
			if(get_user_health(i) <= 0) {
				kills++
			}
			} else if(cvar_exists("mp_friendlyfire")){ 
             				  new ffcvar = get_cvar_num("mp_friendlyfire") 
               				if(ffcvar == 1){
					if(distance < 350) {
						if(get_user_health(i) - 25 <= 0)
							set_user_frags(i,victimfrag + 1)
						set_user_health(i, get_user_health(i) - 25)
					}
					if(distance >= 350 && distance < 500) {
						if(get_user_health(i) - 5 <= 0)
							set_user_frags(i,victimfrag + 1)
						set_user_health(i, get_user_health(i) - 5)
					}
					if(get_user_health(i) <= 0) {
						kills--
						if(belted[i]) {
							explode(i)
						}
					}
				}
			}
			
		}
	}
	set_user_frags(id, frags + kills)
	set_user_health(id, 0)
	client_print(id, print_chat, "You got %i kills", kills)
			
}


public stopshake() {
	new i
	if(countdown > 10) {
	for(i = 0; i < 33; i++) {
		injured[i] = 0
		flashed[i] = 0
		if(belted[i]) {
			 message_begin( MSG_ONE, msgStatusText, {0,0,0}, i) 
  			 write_byte(0) 
			 write_string("Suicide Belt") 
  			 message_end()
		}
	}
	}
	countdown = 0
}

public getmode() 
{ 
   new mytype[24] 
   get_cvar_string("cs_revamped",mytype,24) 
   return read_flags(mytype) 
} 


public arminjury() {
	new i
	for(i = 0; i < 33; i ++) {
		if(injured[i] > 0 && is_user_connected(i)) {
		 message_begin(MSG_ONE, msgtweak, {0,0,0}, i)
		write_short(1<<14)
		write_short(1<<14)
		write_short(1<<14)
		message_end()	
		injured[i]++
		}
		if(injured[i] == 33 || !is_user_connected(i) || !is_user_alive(i)) {
			injured[i] = 0
		}
	}
	
}

public damage_event(id) {
	new moder = getmode()
	new wpn[33],dmg[8],body[8],otherguy,dmg2 = 0,diff = 0, weapon[20],hitplace, wep, amp
	otherguy = get_user_attacker(id, wep, hitplace)
	get_user_astats(id,otherguy,dmg,body,wpn)
	if(moder&SHAKEYHANDS) {
		if(body[HIT_LEFTARM] > 0 || body[HIT_RIGHTARM] > 0) {
			 message_begin(MSG_ONE, msgtweak, {0,0,0}, id)
			write_short(1<<14)
			write_short(1<<14)
			write_short(1<<14)
			message_end()
			injured[id] = 1
			set_task(random_float(3.5, 8.5), "arminjury", 0,"",0,"a",35)
		}	
	}
	get_weaponname(wep, weapon,20)
	dmg2 = dmg[6] / dmg[5]
	if(moder&HIGHDAMAGE) {
		if(dmg2 > 50) {
			message_begin(MSG_ONE, msgfade, {0,0,0}, id)
			write_short(1<<12) //total duration
			write_short(1<<6) //time it stays one color
			write_short(0<<1) //fade out, which means it goes away
			write_byte(255) //red
			write_byte(30) //green
			write_byte(30) //blue
			write_byte(255) //alpha, 255 means non-transparent
			message_end()
		}
	}
	diff = 0
	if(moder&PISTOLS) {
		if(equal(weapon, "weapon_p228")) {
			diff = dmg2 * 10 / 8
		}
		if(equal(weapon, "weapon_elite")) {
			diff = dmg2 * 10 / 7
		}
		if(equal(weapon, "weapon_fiveseven")) {
			diff = dmg2 * 9 / 7
		}
	}
	if(moder&SMGS) {
		if(equal(weapon, "weapon_mac10")) {
			diff = dmg2 * 10 / 9
		}
		if(equal(weapon, "weapon_p90")) {
			diff = dmg2 * 11 / 10
		}
		if(equal(weapon, "weapon_ump45")) {
			diff = dmg2 * 11 / 9
		}
		if(equal(weapon, "weapon_tmp")) {
			diff = dmg2 * 13 / 12
		}
	}
	if(moder&AUTOSNIPE) {
		if(equal(weapon, "weapon_g3sg1")) {
			diff = dmg2 * 13 / 12
		}
		if(equal(weapon, "weapon_sg550")) {
			diff = dmg2 * 10 / 8
		}
	}
	if(diff > 0) {
		dmg2 = diff - dmg2
	} else {
		dmg2 = 0
	}
	if(get_user_health(id) - dmg2 <= 0) {
		set_user_health(id, 1)
	} else {
	set_user_health(id, get_user_health(id) - dmg2)
	}
	
}

public flashed_event(id) {
	new words[9]
	new moder = getmode()
	if(moder&DEAF) {
		if(is_user_bot(id) == 0) {
			get_user_info(id,"volume", words, 8)
			client_print(id,print_chat, "%s", words)
		//origvol = str_to_num(words)
		//flashed[id][0] = origvol
		//flashed [id][2] = origvol / 25
		client_print(id, print_chat, "You have gone temporarily deaf from the flashbang, if you are unable to restore")
		client_print(id, print_chat, "your original volume, open up the console with the ~ key and type in 'volume 0.8'")
			client_cmd(id, "volume 0.0")
			flashed[id] = 1
			
		}
	}
}

/*note: this function is still executed to clean up anyone who becomes deaf and the admin disables deafness problems*/
public restore_hearing() {
	new i, werds[20], j[5]
	for(i = 0; i < 33; i ++) {
		if(flashed[i] != 0 && is_user_connected(i) && is_user_alive(i)) {
			flashed[i] = flashed[i] + 1
			if(flashed[i] >= 1 && flashed[i] <=18)
				copy(j,5,  "00001")
			if(flashed[i] == 19)
				copy(j,5,  "01000")
			if(flashed[i] == 20)
				copy(j,5, "10000")
			if(flashed[i] == 21)
				copy(j,5, "15000")
			if(flashed[i] == 22)
				copy(j,5, "25000")
			if(flashed[i] == 23)
				copy(j,5, "35000")
			if(flashed[i] == 24)
				copy(j, 5,"55000")
			format(werds, 20, "volume 0.%s", j)
			//client_print(i, print_chat, "your current volume is %i", j)
			//client_print(i, print_chat, "%s %s %s", flashed[i][0], flashed[i][1], flashed[i][2])
			client_cmd(i, werds)
		}
		if(flashed[i] == 25 || !is_user_connected(i) || !is_user_alive(i)) {
			flashed[i] = 0
		}
		if(flashed[i] == 0 && is_user_connected(i) && !is_user_bot(i)) {
			client_cmd(i, "volume .8")
		}
	}
	
}
