
/*
*
* LeadSounds plugin for DoD 1.0 
*
* (c) Copyright 2003, SidLuke
* This file is provided as is (no warranties).
*
*/

#include <amxmod>

#define MAXPLAYERS 32 + 1

new LeaderScore
new numl
new LeaderID
new PScore[MAXPLAYERS]

public plugin_precache(){
  precache_sound( "misc/takenlead.wav" )
  precache_sound( "misc/tiedlead.wav" )
  precache_sound( "misc/lostlead.wav" )
  return PLUGIN_CONTINUE
}

public client_disconnect(id)
{
  if ( !get_cvar_float("amx_leadsounds") )
    return PLUGIN_CONTINUE

  if ( PScore[id] == LeaderScore && LeaderScore > 0 ){
    numl--
    PScore[id] = 0
    if ( numl == 0 ){
      LeaderScore = 0
      for ( new i=1; i<MAXPLAYERS; i++ )
        if ( PScore[i] > LeaderScore ){ 
          LeaderScore = PScore[i] 
          numl = 1
          LeaderID = i
        }
        else if ( PScore[i] == LeaderScore )
          numl++

      if ( LeaderScore == 0 ) 
        numl = 0
      else if ( numl == 1 )
        client_cmd( LeaderID,"spk misc/takenlead" )
      else if ( numl > 1 )
        for ( new i=1; i<MAXPLAYERS; i++ )
          if ( PScore[i] == LeaderScore )
            client_cmd( i,"spk misc/tiedlead")
      //else no players on server or have 0 score
    }
    else if ( numl == 1 )
      if ( LeaderID != id ){
        client_cmd( LeaderID,"spk misc/takenlead" )
      }
      else {
        for ( new i=1; i<MAXPLAYERS; i++ )
        if ( PScore[i] == LeaderScore ) client_cmd( i,"spk misc/takenlead" )
      }
  }
  else  
    PScore[id] = 0
  return PLUGIN_CONTINUE
}

public get_score(){
  if ( !get_cvar_float("amx_leadsounds") )
    return PLUGIN_CONTINUE
  new PlayerID = read_data(1)
  new PlayerScore = read_data(2)

  if ( PlayerScore > PScore[PlayerID] ){
    PScore[PlayerID] = PlayerScore

    if ( PlayerScore > LeaderScore  ){
      if ( numl == 1 ){
        if ( LeaderID != PlayerID ){  
          client_cmd( LeaderID,"spk misc/lostlead" )
          client_cmd( PlayerID,"spk misc/takenlead" )
        }
      }

      else if ( numl > 1 ){
        for ( new i=1; i<MAXPLAYERS; i++ )
          if ( PScore[i] == LeaderScore  && i != PlayerID )
            client_cmd( i,"spk misc/lostlead" ) 
        client_cmd( PlayerID,"spk misc/takenlead" )
      } 
    
      else if ( numl == 0 ){ // start
        for ( new i=1; i<MAXPLAYERS; i++ )
          if ( i != PlayerID && is_user_connected(i) ) client_cmd( i,"spk misc/lostlead" )
        client_cmd( PlayerID,"spk misc/takenlead" )
      }

      LeaderScore = PlayerScore
      LeaderID = PlayerID    
      numl = 1
    }

    else if ( PlayerScore == LeaderScore ){
      if ( numl == 1 ) 
        client_cmd( LeaderID,"spk misc/tiedlead" )
      client_cmd( PlayerID,"spk misc/tiedlead" )
      numl++
    } 
  }
  return PLUGIN_CONTINUE
}

public plugin_init(){ 
  register_plugin("LeadSounds","0.2","SidLuke")
  register_event("ObjScore","get_score","a")
  register_cvar("amx_leadsounds","1")
  return PLUGIN_CONTINUE 
}

