/*
* Tag Blocker
*  v 0.1
*
*  by ImJust2Nasty
*   djmumbles69@hotmail.com
*
* Cvars: amx_tagblocker
* 
*/

#include <amxmod>
#define MAX_TAGS 100

new blockedtags[] = "addons/amx/blockedtags.ini"
new namestore[MAX_TAGS][32]
new bool:dontcheck[33]
new num_words

read_list(filename[]){
	if (file_exists(filename)){
		new readdata[64], len, pos = 0
		while (num_words < MAX_TAGS && read_file(filename,pos++,readdata,63,len)){   
			parse(readdata, namestore[num_words],31)
			++num_words
		}
	}
	else
		log_message("Tag Blocker: File not found (file ^"%s^")",filename)
}

public client_infochanged(id){
   if (dontcheck[id])
      dontcheck[id] = false
   else if (is_user_connected(id) && get_cvar_float("amx_tagblocker")){
      new newname[32], oldname[32]
      get_user_info(id, "name", newname,31)
      get_user_name(id,oldname,31)
      if (!equal(oldname,newname)){
         dontcheck[id] = true
         client_print(id,print_chat,"[AMX] You can't change your name in game")
         set_user_info(id,"name",oldname)
      }
   }  
   return PLUGIN_CONTINUE
}

public client_connect(id){     
	if (!get_cvar_float("amx_tagblocker"))
		return PLUGIN_CONTINUE
	new name[32]
	get_user_name(id,name,31)
	for(new i=0; i<num_words; ++i){
		if (containi(name,namestore[i])!=-1 ){
			client_cmd(id,"echo Your tag is blocked from this server; disconnect")
			client_print(0,print_chat,"[AMX] %s was kicked for using a blocked tag",name)
		}
	} 
	return PLUGIN_CONTINUE
}

public plugin_init() {     
	register_plugin("Tag Blocker","0.1","ImJust2Nasty")
	register_cvar("amx_tagblocker","1")
	read_list(blockedtags)
	return PLUGIN_CONTINUE     
}
