/* AMX Mod script.
*
* (c) 2003, 
* This file is provided as is (no warranties).
* toggleconsole by Fyre
* 
* Admin commands:
* amx_togglemenu - displays toggle console menu
* "say /console" - brings down console 
*
* Admin Custom Level A needed
*
* This is my 1st Plugin and I hope it helps ppl having trouble bringing down their Console
* It works over a Menu and brings the Players console down.
* Or just type as say command "/console"
*/

#include <amxmod> 
#include <amxmisc> 

new g_menuPosition[33]
new g_menuPlayers[33][32]
new g_menuPlayersNum[33]


new g_cstrikeRunning

public plugin_init()
{
  register_plugin("Toggle Menu","0.2","Fyre")
  register_clcmd("amx_togglemenu","cmdtoggleMenu",ADMIN_LEVEL_A,"- displays Toggle Console Menu")
  register_clcmd("say /console","toggle_console", 0 ," - brings down console")
    

  register_menucmd(register_menuid("Toggle Console Menu"),1023,"actiontoggleMenu")
  
  g_cstrikeRunning = is_running("cstrike")

  
  
}
/* Toggle */

public toggle_console (id)
{                  
           
      console_cmd(id,"console 1")     
      client_cmd(id,"toggleconsole")
                 
  return PLUGIN_HANDLED

}


public actiontoggleMenu(id,key)
{
  switch(key){
  case 8: displaytoggleMenu(id,++g_menuPosition[id])
  case 9: displaytoggleMenu(id,--g_menuPosition[id])
  default:{
      new player = g_menuPlayers[id][g_menuPosition[id] * 8 + key]
                  
      new authid[32],authid2[32], name[32], name2[32]
      get_user_authid(id,authid,31)
      get_user_authid(player,authid2,31)
      get_user_name(id,name,31)
      get_user_name(player,name2,31)      
      new userid2 = get_user_userid(player)
      
      console_cmd(userid2,"console 1")     
      client_cmd(userid2,"toggleconsole")
                  
      displaytoggleMenu(id,g_menuPosition[id])
    }
  }
  return PLUGIN_HANDLED
}


displaytoggleMenu(id,pos){

  if (pos < 0)  return
    
  get_players(g_menuPlayers[id],g_menuPlayersNum[id])
    
  new menuBody[512]
  new b = 0
  new i
  new name[32]
  new start = pos * 8
  
  if (start >= g_menuPlayersNum[id])
    start = pos = g_menuPosition[id] = 0
    
  new len = format(menuBody,511, g_cstrikeRunning ?
    "\yToggle Console Menu\R%d/%d^n\w^n" : "Toggle Console Menu %d/%d^n^n",
    pos+1,(  g_menuPlayersNum[id] / 8 + ((g_menuPlayersNum[id] % 8) ? 1 : 0 )) )
    
  new end = start + 8
  new keys = (1<<9)
  
  if (end > g_menuPlayersNum[id])
    end = g_menuPlayersNum[id]
    
  for(new a = start; a < end; ++a)
  {
    i = g_menuPlayers[id][a]
    get_user_name(i,name,31)
    
    if ( get_user_flags(i) & ADMIN_IMMUNITY )
    {
      ++b   
      if ( g_cstrikeRunning )
        len += format(menuBody[len],511-len,"\d%d. %s^n\w",b,name)
      else
        len += format(menuBody[len],511-len,"#. %s^n",name)

    }
    else
    {
      keys |= (1<<b)
      len += format(menuBody[len],511-len,"%d. %s^n",++b,name)
    }
  }
      
  if (end != g_menuPlayersNum[id])
  {
    format(menuBody[len],511-len,"^n9. More...^n0. %s", pos ? "Back" : "Exit")
    keys |= (1<<8)
  }
  else  format(menuBody[len],511-len,"^n0. %s", pos ? "Back" : "Exit")
  
  show_menu(id,keys,menuBody)
}

public cmdtoggleMenu(id,level,cid)
{
  if (cmd_access(id,level,cid,1))
    displaytoggleMenu(id,g_menuPosition[id] = 0)
  
  return PLUGIN_HANDLED 
}

