/***************************************
Star Wars Mod Beta

Gev

V 0.7.0

Thanks go to everyone who helped on this
Mod. Thanks to Spacedude for his grab code,
and to freecode for his help with models,
and AssKicR for his help with animations,
and to Blunted1 for getting the models,
and ImInspectorGadget for the idea, and
Lud for most of the lightsaber code.
***************************************/

/****************************************************
INCLUDES
****************************************************/

#include <amxmod>
#include <amxmisc>
#include <fun>
#include <csstats>
#include <Vexd_Utilities>
#include <VexdUM_stock>


/****************************************************
GLOBALS
****************************************************/

new jedi[2][12]
new light 
new smoke
new grabbed[33]
new grablength[33]
new bool:grabmodeon[33]

//new hunter[7]

/****************************************************
EVENTS
****************************************************/

stock get_user_velocity(id, velocity[3]) {
  new Float:vel[3]
  entity_get_vector(id, EV_VEC_velocity, vel)
  FVecIVec(vel, velocity)
}

stock set_user_velocity(id, velocity[3]) {
  new Float:vel[3]
  IVecFVec(velocity, vel)
  entity_set_vector(id, EV_VEC_velocity, vel)
}

public round_start(){
	new CTplayers[32],CTnum,Tplayers[32],Tnum
	get_players(CTplayers,CTnum,"ae","CT")
	get_players(Tplayers,Tnum,"ae","TERRORIST")
	jedi[0][0]=CTplayers[random_num(0,CTnum)]
	if(!is_dedicated_server()){
		if(!jedi[0][0])
			jedi[0][0] = 1
	}
	jedi[1][0]=Tplayers[random_num(0,Tnum)]
	if(!is_dedicated_server()){
		if(!jedi[1][0])
			jedi[1][0] = 1
	}
	new Tteam[32],CTteam[32]
	get_user_team(jedi[0][0],CTteam,31)
	get_user_team(jedi[1][0],Tteam,31)
	if(jedi[0][0]==jedi[1][0]||!is_user_alive(jedi[0][0])||!is_user_alive(jedi[1][0])||jedi[0][0]<1||jedi[1][0]<1||!equal(CTteam,"CT")||!equal(Tteam,"TERRORIST"))
		set_task(0.1,"round_start")
	else{
		set_task(0.1,"jedi_init")
	}
	return PLUGIN_CONTINUE
}

public round_end(){
	for(new i=0;i<2;i++){
		remove_task(110+jedi[i][0])
		remove_task(150+jedi[i][0])
		remove_task(200+jedi[i][0])
		remove_task(250+jedi[i][0])
		client_cmd(jedi[i][0],"bind MOUSE1 +attack")
		client_cmd(jedi[i][0],"bind MOUSE2 +attack2")
		client_cmd(jedi[i][0],"bind MWHEELDOWN invnext")
		client_cmd(jedi[i][0],"bind MWHEELUP invprev")
		Entvars_Set_String(jedi[i][0], EV_SZ_viewmodel, "models/v_knife.mdl")
		Entvars_Set_String(jedi[i][0], EV_SZ_weaponmodel, "models/p_knife.mdl")
		new iCurrent = FindEntity(-1,"weapon_knife")
		while(iCurrent != -1) {
			iCurrent = FindEntity(iCurrent,"weapon_knife") 
		}
		set_user_maxspeed(jedi[i][0],240.0)
		release(jedi[i][0])
		jedi[i][0]=0
		jedi[i][3]=0
		jedi[i][4]=0
		jedi[i][6]=7
		jedi[i][7]=0
		jedi[i][8]=0
		jedi[i][9]=0
		jedi[i][10]=0
		jedi[i][11]=0
	}
	return PLUGIN_CONTINUE
}

/****************************************************
JEDI SETUP
****************************************************/

public jedi_init(){
	new stats[8],body[8]
	new Float:acc,Float:killratio
	for(new i=0;i<2;i++){
		engclient_cmd(jedi[i][0],"weapon_knife")
		client_cmd(jedi[i][0],"-attack")
		jedi[i][3]=0
		client_cmd(jedi[i][0],"bind MOUSE1 jediattack")
		client_cmd(jedi[i][0],"bind MOUSE2 jedimenu")
		client_cmd(jedi[i][0],"bind MWHEELDOWN powerdown")
		client_cmd(jedi[i][0],"bind MWHEELUP powerup")
		get_user_stats(jedi[i][0],stats,body)
		if(stats[4]!=0)
			acc=stats[5]/stats[4]*100.0
		else
			acc=0.0
		if(stats[1]==0)
			killratio=stats[0]*1.0
		else
			killratio=stats[0]/stats[1]*1.0
		if(acc<5.0){
			jedi[i][1]=1
		}
		else{
			if(acc<10.0){
				jedi[i][1]=2
			}
			else{
				if(acc<15.0){
					jedi[i][1]=3
				}
				else{
					if(acc<20.0){
						jedi[i][1]=4
					}
					else{
						if(acc<25.0){
							jedi[i][1]=5
						}
						else{
							if(acc<30.0){
								jedi[i][1]=6
							}
							else{
								jedi[i][1]=7
							}
						}
					}
				}
			}
		}
		if(killratio<0.3){
			jedi[i][2]=1
		}
		else{
			if(killratio<0.5){
				jedi[i][2]=2
			}
			else{
				if(killratio<0.75){
					jedi[i][2]=3
				}
				else{
					if(killratio<1.0){
						jedi[i][2]=4
					}
					else{
						if(killratio<1.5){
							jedi[i][2]=5
						}
						else{
							if(killratio<2.0){
								jedi[i][2]=6
							}
							else{
								jedi[i][2]=7
							}
						}
					}
				}
			}
		}
		set_user_maxspeed(jedi[i][0],400.0)
		client_cmd(jedi[i][0],"cl_forwardspeed 1000;cl_backspeed 1000")
		set_cvar_num("sv_maxspeed",400)
		emit_sound(jedi[i][0],CHAN_VOICE, "starwars/saberglow.wav", 0.5, ATTN_NORM, 0, PITCH_NORM)
		if(i==0){
			Entvars_Set_String(jedi[i][0], EV_SZ_viewmodel, "models/v_saber.mdl")
			Entvars_Set_String(jedi[i][0], EV_SZ_weaponmodel, "models/p_saber.mdl")
			new iCurrent = FindEntity(-1,"weapon_knife")
			while(iCurrent != -1) {
				iCurrent = FindEntity(iCurrent,"weapon_knife") 
			}
		}
		if(i==1){
			Entvars_Set_String(jedi[i][0], EV_SZ_viewmodel, "models/v_darksaber.mdl")
			Entvars_Set_String(jedi[i][0], EV_SZ_weaponmodel, "models/p_darksaber.mdl")
			new iCurrent = FindEntity(-1,"weapon_knife")
			while(iCurrent != -1) {
				iCurrent = FindEntity(iCurrent,"weapon_knife") 
			}
		}
		new pindex[2]
		pindex[0]=jedi[i][0]
		set_task(0.1,"jedi_func",110+jedi[i][0],pindex,2,"b")
		set_task(1.6,"saber_glow",150+jedi[i][0],pindex,2,"b")
	}
	return PLUGIN_CONTINUE
}

public saber_glow(pindex[]){
	new id=pindex[0]
	if(is_user_alive(id))
		emit_sound(id,CHAN_VOICE, "starwars/saberglow.wav", 0.5, ATTN_NORM, 0, PITCH_NORM)
	return PLUGIN_CONTINUE
}

/****************************************************
LIGHTSABER ATTACK
****************************************************/

public jedi_attack(jid){
	Entvars_Set_Int(jedi[jid][0],EV_INT_weaponanim,jedi[jid][6])
	if(jedi[jid][6]==6)
		jedi[jid][6]=7
	else
		jedi[jid][6]=6
	new vid,hit=0
	new vec[3] 
	new aimvec[3] 
	new lseffvec[3]
	new length
	new speed = 70 
	get_user_origin(jedi[jid][0],vec,1) 
	get_user_origin(jedi[jid][0],aimvec,2) 
	lseffvec[0]=aimvec[0]-vec[0] 
	lseffvec[1]=aimvec[1]-vec[1] 
	lseffvec[2]=aimvec[2]-vec[2] 
	length=sqrt(lseffvec[0]*lseffvec[0]+lseffvec[1]*lseffvec[1]+lseffvec[2]*lseffvec[2]) 
	lseffvec[0]=(lseffvec[0]*speed/length)+vec[0]
	lseffvec[1]=(lseffvec[1]*speed/length)+vec[1]
	lseffvec[2]=(lseffvec[2]*speed/length)+vec[2]
	new players[32],plrnum,i,vorigin[3]
	get_players(players,plrnum,"ae",jid ? "CT" : "TERRORIST")
	for(i=0;i<plrnum;i++){
		vid=players[i]
		if(!vid)
			break
		get_user_origin(vid,vorigin)
		if(get_distance(lseffvec,vorigin)<70){
			message_begin(MSG_ONE, get_user_msgid("Damage"), {0,0,0}, vid) 
			write_byte(30) // dmg_save 
			write_byte(30) // dmg_take 
			write_long(1<<0) // visibleDamageBits
			write_coord(vec[0]) // damageOrigin.x 
			write_coord(vec[1]) // damageOrigin.y 
			write_coord(vec[2]) // damageOrigin.z 
			message_end()
			emit_sound(jedi[jid][0],CHAN_WEAPON, "starwars/saberhit.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			new vhealth=get_user_health(vid)
			vhealth-=random_num(30,105)
			if(vhealth<1)
				saber_kill(jid,vid)
			else
				set_user_health(vid,vhealth)
			hit=1
		}
	}
	if(hit==0)
		emit_sound(jedi[jid][0],CHAN_WEAPON, "starwars/saberswing.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	new var[2]
	var[0]=jid
	set_task(0.6,"jedi_attack_restore",0,var,2)
}

public saber_kill(jid,vid){
	new kid=jedi[jid][0]
	if(!kid)
		kid=1
	if(!vid)
		vid=1
	MessageBlock(get_user_msgid("DeathMsg"),BLOCK_ONCE)
	user_kill(vid,1)
	message_begin( MSG_ALL, get_user_msgid("DeathMsg"),{0,0,0},0)
	write_byte(kid)
	write_byte(vid)
	write_byte(0)
	write_string("Lightsaber")
	message_end()
	new frags=get_user_frags(kid)
	new money=get_user_money(kid)
	set_user_frags(kid,frags+1)
	set_user_money(kid,money+150)
	new namea[24],namev[24],authida[20],authidv[20],teama[32],teamv[32]
	//Info On Attacker
	get_user_name(kid,namea,23) 
	get_user_team(kid,teama,7) 
	get_user_authid(kid,authida,19) 
	//Info On Victim
	get_user_name(vid,namev,23) 
	get_user_team(vid,teamv,7) 
	get_user_authid(vid,authidv,19)
	//Log This Kill
	log_message("^"%s<%d><%s><%s>^" killed ^"%s<%d><%s><%s>^" with ^"Lightsaber^"",namea,get_user_userid(kid),authida,teama,namev,get_user_userid(vid),authidv,teamv)
}

public jedi_attack_restore(var[]){
	jedi[var[0]][3]=0
	return PLUGIN_CONTINUE
}
		
public attack_func(id){
	new jid
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	jid=get_jedi_id(id)
	if(jid==-1)
		return PLUGIN_CONTINUE
	if(jedi[jid][3]==0&&is_user_alive(id)){
		jedi[jid][3]=1
		jedi_attack(jid)
	}
	return PLUGIN_CONTINUE
}

/****************************************************
LIGHTSABER BLOCK
****************************************************/

public damage_event(id){
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	new jid=get_jedi_id(id)
	if(jid==-1)
		return PLUGIN_CONTINUE
	new damage=read_data(2)
	new block,health,dodge
	block=random_num(1,20)
	dodge=random_num(6,12)
	if(block>dodge+jedi[jid][1]*2)
		return PLUGIN_CONTINUE
	else{
		health=get_user_health(jedi[jid][0])
		health+=damage
		if(health>100)
			health=100
		set_user_health(jedi[jid][0],health)
		emit_sound(jid,CHAN_ITEM,"starwars/saberblock.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
	return PLUGIN_CONTINUE
}

/****************************************************
FORCE PUSH
****************************************************/

public force_push(id){
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	if(!is_user_alive(id))
		return PLUGIN_CONTINUE
	new jid=get_jedi_id(id)
	if(jid==-1)
		return PLUGIN_CONTINUE
	if(jedi[jid][5]==1)
		return PLUGIN_CONTINUE
	jedi[jid][5]=1
	emit_sound(jedi[jid][0],CHAN_ITEM,"starwars/force_push.wav",1.0,ATTN_NORM,0, PITCH_NORM)
	new players[32],plrnum,i,jorigin[3],vorigin[3],velocity[3]
	get_players(players,plrnum,"ae",jid ? "CT" : "TERRORIST")
	get_user_origin(jedi[jid][0],jorigin)
	for(i=0;i<plrnum;i++){
		get_user_origin(players[i],vorigin)
		if(get_distance(jorigin,vorigin)<700){
			velocity[0]=floatround((float(vorigin[0]-jorigin[0])/float(get_distance(jorigin,vorigin)))*600.0)
			velocity[1]=floatround((float(vorigin[1]-jorigin[1])/float(get_distance(jorigin,vorigin)))*600.0)
			velocity[2]=players[i]
			set_user_velocity(players[i],{0,0,300})
			set_task(0.1,"move_enemy",0,velocity,3)
		}
	}
	new var[2]
	var[0]=jid
	set_task(2.0,"restore_push",0,var,2)
	return PLUGIN_CONTINUE
}

public restore_push(var[]){
	jedi[var[0]][5]=0
	return PLUGIN_CONTINUE
}

public move_enemy(velocity[3]){
	new id=velocity[2]
	velocity[2]=200
	set_user_velocity(id,velocity)
	emit_sound(id,CHAN_BODY,"player/PL_PAIN2.WAV",1.0,ATTN_NORM,0, PITCH_NORM)
	return PLUGIN_CONTINUE
}

/****************************************************
FORCE SPEED
****************************************************/

public drop_it(){
	new id=read_data(0)
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	new jid=get_jedi_id(id)
	if(jid==-1)
		return PLUGIN_CONTINUE
	engclient_cmd(id,"weapon_knife")
	set_user_maxspeed(id,400.0)
	if(jid==0){
		Entvars_Set_String(id, EV_SZ_viewmodel, "models/v_saber.mdl")
		Entvars_Set_String(id, EV_SZ_weaponmodel, "models/p_saber.mdl")
		new iCurrent = FindEntity(-1,"weapon_knife")
		while(iCurrent != -1) {
			iCurrent = FindEntity(iCurrent,"weapon_knife") 
		}
	}
	if(jid==1){
		Entvars_Set_String(id, EV_SZ_viewmodel, "models/v_darksaber.mdl")
		Entvars_Set_String(id, EV_SZ_weaponmodel, "models/p_darksaber.mdl")
		new iCurrent = FindEntity(-1,"weapon_knife")
		while(iCurrent != -1) {
			iCurrent = FindEntity(iCurrent,"weapon_knife") 
		}
	}
	return PLUGIN_CONTINUE
}

/****************************************************
FORCE JUMP
****************************************************/

public jedi_func(pindex[]){
	new id=pindex[0]
	if(!is_user_alive(id))
		return PLUGIN_CONTINUE
	client_cmd(id,"-attack")
	new jid=get_jedi_id(id)
	if(jid==-1)
		return PLUGIN_CONTINUE
	new velocity[3]
	get_user_velocity(id,velocity)
	if(get_user_button(id)&IN_JUMP){
		if(jedi[jid][4]==0&&jedi[jid][7]==0){
			if(velocity[0]<0)
				velocity[0]-=50
			if(velocity[0]>0)
				velocity[0]+=50
			if(velocity[1]<0)
				velocity[1]-=50
			if(velocity[1]>0)
				velocity[1]+=50
			velocity[2]+=200
			set_user_velocity(id,velocity)
			jedi[jid][4]=1
			jedi[jid][7]=1
			new var[2]
			var[0]=jid
			set_task(0.5,"restore_jump",0,var,2)
		}
	}
	else{
			jedi[jid][4]=0
	}
	return PLUGIN_CONTINUE
}

public restore_jump(var[]){
	jedi[var[0]][7]=0
	return PLUGIN_CONTINUE
}

/****************************************************
FORCE CHOKE
****************************************************/

public choke_func(id){
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	new jid=get_jedi_id(id)
	if(jid==-1)
		return PLUGIN_CONTINUE
	if(jedi[jid][8]==1)
		return PLUGIN_CONTINUE
	new vid,vbody,jteam[32],vteam[32]
	get_user_aiming(id,vid,vbody)
	if(!vid)
		return PLUGIN_CONTINUE
	get_user_team(id,jteam,31)
	get_user_team(vid,vteam,31)
	if(equal(jteam,vteam))
		return PLUGIN_CONTINUE
	set_user_velocity(vid,{0,0,550})
	jedi[jid][8]=1
	client_print(vid,print_chat,"*** You Are Being Choked By A Jedi")
	message_begin(MSG_ONE, get_user_msgid("ScreenShake") , {0,0,0}, vid)
	write_short(1<<14)
	write_short(1<<14)
	write_short(1<<14)
	message_end()
	message_begin(MSG_ONE, get_user_msgid("ScreenFade") , {0,0,0}, vid)
	write_short(1<<1) //total duration
	write_short(1<<0) //time it stays one color
	write_short(0<<1) //fade out, which means it goes away
	write_byte(255) //red
	write_byte(30) //green
	write_byte(30) //blue
	write_byte(180) //alpha, 255 means non-transparent
	message_end()
	new vec[3]
	get_user_origin(vid,vec)
	message_begin(MSG_ONE, get_user_msgid("Damage"), {0,0,0}, vid) 
	write_byte(30) // dmg_save 
	write_byte(30) // dmg_take 
	write_long(1<<0) // visibleDamageBits
	write_coord(vec[0]) // damageOrigin.x 
	write_coord(vec[1]) // damageOrigin.y 
	write_coord(vec[2]) // damageOrigin.z 
	message_end()
	new var[2],health,jar[3]
	var[0]=vid
	jar[0]=jid
	jar[1]=vid
	set_task(1.0,"repeat_shake",id+200,var,2,"a",10)
	set_task(30.0,"choke_restore",id+200,jar,3)
	emit_sound(vid,CHAN_BODY,"player/PL_PAIN2.WAV",1.0,ATTN_NORM,0, PITCH_NORM)
	health=get_user_health(vid)
	if(health>3)
		set_user_health(vid,get_user_health(vid)-3)
	return PLUGIN_CONTINUE
}

public repeat_shake(var[]){
	set_user_velocity(var[0],{0,0,400})
	message_begin(MSG_ONE, get_user_msgid("ScreenShake") , {0,0,0}, var[0])
	write_short(1<<14)
	write_short(1<<14)
	write_short(1<<14)
	message_end()
	message_begin(MSG_ONE, get_user_msgid("ScreenFade") , {0,0,0}, var[0])
	write_short(1<<1) //total duration
	write_short(1<<0) //time it stays one color
	write_short(0<<1) //fade out, which means it goes away
	write_byte(255) //red
	write_byte(30) //green
	write_byte(30) //blue
	write_byte(180) //alpha, 255 means non-transparent
	message_end()
	new vec[3]
	get_user_origin(var[0],vec)
	message_begin(MSG_ONE, get_user_msgid("Damage"), {0,0,0}, var[0]) 
	write_byte(30) // dmg_save 
	write_byte(30) // dmg_take 
	write_long(1<<0) // visibleDamageBits
	write_coord(vec[0]) // damageOrigin.x 
	write_coord(vec[1]) // damageOrigin.y 
	write_coord(vec[2]) // damageOrigin.z 
	message_end()
	new health=get_user_health(var[0])
	if(health>3)
		set_user_health(var[0],get_user_health(var[0])-3)
	emit_sound(var[0],CHAN_BODY,"player/PL_PAIN2.WAV",1.0,ATTN_NORM,0, PITCH_NORM)
	return PLUGIN_CONTINUE
}

public choke_restore(jar[]){
	jedi[jar[0]][8]=0
	return PLUGIN_CONTINUE
}

/****************************************************
JEDI SHOCK
****************************************************/

public shock_func(id){
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	new jid=get_jedi_id(id)
	if(jid==-1)
		return PLUGIN_CONTINUE
	if(jedi[jid][9]==1)
		return PLUGIN_CONTINUE
	new vid,vbody,jteam[32],vteam[32]
	get_user_aiming(id,vid,vbody)
	if(!vid)
		return PLUGIN_CONTINUE
	get_user_team(id,jteam,31)
	get_user_team(vid,vteam,31)
	if(equal(jteam,vteam))
		return PLUGIN_CONTINUE
	new vec1[3],vec2[3]
	get_user_origin(id,vec1)
	get_user_origin(vid,vec2)
	//Lightning 
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY) 
	write_byte( 0 ) 
	write_coord(vec1[0]) 
	write_coord(vec1[1]) 
	write_coord(vec1[2]) 
	write_coord(vec2[0]) 
	write_coord(vec2[1]) 
	write_coord(vec2[2]) 
	write_short( light ) 
	write_byte( 1 ) // framestart 
	write_byte( 5 ) // framerate 
	write_byte( 2 ) // life 
	write_byte( 20 ) // width 
	write_byte( 30 ) // noise 
	write_byte( 12 ) // r, g, b 
	write_byte( 50 ) // r, g, b 
	write_byte( 200 ) // r, g, b 
	write_byte( 200 ) // brightness 
	write_byte( 200 ) // speed 
	message_end() 
	//Sparks 
	message_begin( MSG_PVS, SVC_TEMPENTITY,vec2) 
	write_byte( 9 ) 
	write_coord( vec2[0] ) 
	write_coord( vec2[1] ) 
	write_coord( vec2[2] ) 
	message_end() 
	//Smoke    
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec2) 
	write_byte( 5 ) // 5 
	write_coord(vec2[0]) 
	write_coord(vec2[1]) 
	write_coord(vec2[2]) 
	write_short( smoke ) 
	write_byte( 10 )  // 10
	write_byte( 10 )  // 10
	message_end()
	message_begin(MSG_ONE, get_user_msgid("Damage"), {0,0,0}, vid) 
	write_byte(30) // dmg_save 
	write_byte(30) // dmg_take 
	write_long(1<<0) // visibleDamageBits
	write_coord(vec1[0]) // damageOrigin.x 
	write_coord(vec1[1]) // damageOrigin.y 
	write_coord(vec1[2]) // damageOrigin.z 
	message_end()
	new health=get_user_health(vid)
	if(health>7)
		set_user_health(vid,get_user_health(vid)-7)
	jedi[jid][9]=1
	new jar[2]
	jar[0]=jid
	set_task(1.0,"shock_restore",id+250,jar,2)
	emit_sound(vid,CHAN_BODY,"weapons/electro4.wav",1.0,ATTN_NORM,0, PITCH_NORM)
	return PLUGIN_CONTINUE
}

public shock_restore(jar[]){
	jedi[jar[0]][9]=0
	return PLUGIN_CONTINUE
}

/****************************************************
JEDI MENU
****************************************************/

public jedi_menu(id){
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	new jid=get_jedi_id(id)
	if(jid==-1){
		client_print(id,print_chat,"[AMX] The Jedi Menu can only be used by Jedi's")
		return PLUGIN_CONTINUE
	}
	new menu_body[512]
	copy(menu_body,511,"\yJedi Menu^n\w^n\%1. Force Push\w^n\%2. Force Choke\w^n\%3. Force Shock\w^n\%4. Force Grab\w^n^n\%0. Exit")
	show_menu(id,(1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<9),menu_body)
	return PLUGIN_HANDLED
}

public action_jedi(id,key){
	new jid=get_jedi_id(id)
	switch(key){
		case 0: {
			client_cmd(id,"bind MOUSE2 jedipush")
			jedi[jid][11]=1
			client_print(id,print_chat,"Force Push Activated")
		}
		case 1: {
			client_cmd(id,"bind MOUSE2 jedichoke")
			jedi[jid][11]=2
			client_print(id,print_chat,"Force Choke Activated")
		}
		case 2: {
			client_cmd(id,"bind MOUSE2 jedishock")
			jedi[jid][11]=3
			client_print(id,print_chat,"Force Shock Activated")
		}
		case 3: {
			client_cmd(id,"bind MOUSE2 jedigrab")
			jedi[jid][11]=4
			client_print(id,print_chat,"Force Grab Activated")
		}
	}
	return PLUGIN_HANDLED
}

/****************************************************
CHANGE JEDI POWER
****************************************************/

public next_power(id){
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	if(!is_user_alive(id))
		return PLUGIN_CONTINUE
	new jid=get_jedi_id(id)
	if(jid==-1)
		return PLUGIN_CONTINUE
	if(!jedi[jid][11]){
		jedi[jid][11]=1
		client_cmd(id,"bind MOUSE2 jedipush")
		client_print(id,print_chat,"Force Push Activated")
		return PLUGIN_CONTINUE
	}
	if(jedi[jid][11]==1){
		jedi[jid][11]=2
		client_cmd(id,"bind MOUSE2 jedichoke")
		client_print(id,print_chat,"Force Choke Activated")
		return PLUGIN_CONTINUE
	}
	if(jedi[jid][11]==2){
		jedi[jid][11]=3
		client_cmd(id,"bind MOUSE2 jedishock")
		client_print(id,print_chat,"Force Shock Activated")
		return PLUGIN_CONTINUE
	}
	if(jedi[jid][11]==3){
		jedi[jid][11]=4
		client_cmd(id,"bind MOUSE2 jedigrab")
		client_print(id,print_chat,"Force Grab Activated")
		return PLUGIN_CONTINUE
	}
	if(jedi[jid][11]==4){
		jedi[jid][11]=1
		client_cmd(id,"bind MOUSE2 jedipush")
		client_print(id,print_chat,"Force Push Activated")
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

public prev_power(id){
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	if(!is_user_alive(id))
		return PLUGIN_CONTINUE
	new jid=get_jedi_id(id)
	if(jid==-1)
		return PLUGIN_CONTINUE
	if(!jedi[jid][11]){
		jedi[jid][11]=4
		client_cmd(id,"bind MOUSE2 jedigrab")
		client_print(id,print_chat,"Force Grab Activated")
		return PLUGIN_CONTINUE
	}
	if(jedi[jid][11]==1){
		jedi[jid][11]=4
		client_cmd(id,"bind MOUSE2 jedigrab")
		client_print(id,print_chat,"Force Grab Activated")
		return PLUGIN_CONTINUE
	}
	if(jedi[jid][11]==2){
		jedi[jid][11]=1
		client_cmd(id,"bind MOUSE2 jedipush")
		client_print(id,print_chat,"Force Push Activated")
		return PLUGIN_CONTINUE
	}
	if(jedi[jid][11]==3){
		jedi[jid][11]=2
		client_cmd(id,"bind MOUSE2 jedichoke")
		client_print(id,print_chat,"Force Choke Activated")
		return PLUGIN_CONTINUE
	}
	if(jedi[jid][11]==4){
		jedi[jid][11]=3
		client_cmd(id,"bind MOUSE2 jedishock")
		client_print(id,print_chat,"Force Shock Activated")
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

/****************************************************
JEDI GRAB - code from Spacedude
****************************************************/

public grabtask(parm[])
{
	new id = parm[0]
	new velocity_multiplier = 8
	new targetid, body
	if (!grabbed[id])
	{
		get_user_aiming(id, targetid, body)
		if (targetid)
		{
			set_grabbed(id, targetid)
		}
	}
	if (grabbed[id])
	{
		new origin[3], look[3], direction[3], moveto[3], grabbedorigin[3], velocity[3], length

		if (!is_user_alive(grabbed[id]))
		{
			release(id)
			return
		}

		get_user_origin(id, origin, 1)
		get_user_origin(id, look, 3)
		get_user_origin(grabbed[id], grabbedorigin)

		direction[0]=look[0]-origin[0]
		direction[1]=look[1]-origin[1]
		direction[2]=look[2]-origin[2]
		length = get_distance(look,origin)
		if (!length) length=1				// avoid division by 0

		moveto[0]=origin[0]+direction[0]*grablength[id]/length
		moveto[1]=origin[1]+direction[1]*grablength[id]/length
		moveto[2]=origin[2]+direction[2]*grablength[id]/length

		velocity[0]=(moveto[0]-grabbedorigin[0])*velocity_multiplier
		velocity[1]=(moveto[1]-grabbedorigin[1])*velocity_multiplier
		velocity[2]=(moveto[2]-grabbedorigin[2])*velocity_multiplier

		set_user_velocity(grabbed[id], velocity)
	}
}

public grab_toggle(id)
{
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	if(!is_user_alive(id))
		return PLUGIN_CONTINUE
	new jid=get_jedi_id(id)
	if(jid==-1)
		return PLUGIN_CONTINUE
	if(jedi[jid][10]==1)
		return PLUGIN_CONTINUE
	jedi[jid][10]=1
	if(grabmodeon[id])
		release(id)
	else
		grab(id)
	return PLUGIN_HANDLED
}

public grab(id)
{
	if (!grabmodeon[id])
	{
		new targetid, body
		new parm[1]
		parm[0] = id
		grabmodeon[id]=true
		set_task(0.1, "grabtask", 300+id, parm, 1, "b")
		get_user_aiming(id, targetid, body)
		if (targetid)
		{
			set_grabbed(id, targetid)
		}
		else
		{
			client_print(id,print_notify,"[AMX] Searching for a target")
		}
	}
	return PLUGIN_HANDLED
}

public release(id)
{
	if (grabmodeon[id])
	{
		grabmodeon[id]=false
		if (grabbed[id])
		{
			new targname[32]
			set_user_gravity(grabbed[id])
			set_user_rendering(grabbed[id])
			get_user_name(grabbed[id],targname,31)
			client_print(id,print_notify,"[AMX] You have released %s", targname)
		}
		else
		{
			client_print(id,print_notify,"[AMX] No target found")
		}
		grabbed[id]=0
		remove_task(300+id)
	}
	return PLUGIN_HANDLED
}

public set_grabbed(id, targetid)
{
	new origin1[3], origin2[3], targname[32]
	get_user_origin(id, origin1)
	get_user_origin(targetid, origin2)
	grabbed[id]=targetid
	grablength[id]=get_distance(origin1,origin2)
	set_user_gravity(targetid,0.001)
	set_user_rendering(targetid,kRenderFxGlowShell,50,0,0, kRenderNormal, 16)
	get_user_name(targetid,targname,31)
	client_print(id,print_notify,"[AMX] You have grabbed onto %s", targname)
}

/****************************************************
MISC FUNCS
****************************************************/

public sqrt(num) { 
	new div = num 
	new result = 1 
	while (div > result) { // end when div == result, or just below 
		div = (div + result) / 2 // take mean value as new divisor 
		result = num / div 
	} 
	return div 
}

public get_jedi_id(id){
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	new int=-1
	for(new i=0;i<2;i++){
		if(id==jedi[i][0]){
			int=i
		}
	}
	return int
}

/****************************************************
FORWARDS
****************************************************/

public client_disconnect(id){
	if(!is_dedicated_server()){
		if(!id)
			id = 1
	}
	new jid=get_jedi_id(id)
	if(jid==-1)
		return PLUGIN_CONTINUE
	client_cmd(id,"bind MOUSE1 +attack")
	client_cmd(id,"bind MOUSE2 +attack2")
	client_cmd(id,"bind MWHEELDOWN invnext")
	client_cmd(id,"bind MWHEELUP invprev")
	return PLUGIN_CONTINUE
}

/****************************************************
INITIALIZE
****************************************************/

public plugin_precache(){
	light = precache_model("sprites/lgtning.spr")
	smoke = precache_model("sprites/steam1.spr")
	precache_model("models/v_saber.mdl")
	precache_model("models/p_saber.mdl")
	precache_model("models/v_knife.mdl")
	precache_model("models/p_knife.mdl")
	precache_model("models/v_darksaber.mdl")
	precache_model("models/p_darksaber.mdl")
	precache_sound("starwars/saberhit.wav")
	precache_sound("starwars/saberswing.wav")
	precache_sound("starwars/saberblock.wav")
	precache_sound("player/PL_PAIN2.WAV")
	precache_sound("starwars/force_push.wav")
	precache_sound("starwars/saberglow.wav")
	precache_sound("weapons/electro4.wav")
	return PLUGIN_CONTINUE
} 

public plugin_init(){
	register_plugin("Star Wars Mod","0.7.0","Gev")
	register_menucmd(register_menuid("Jedi Menu"),(1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<9),"action_jedi")
	register_cvar("starwars","0.7.0",FCVAR_SERVER|FCVAR_SPONLY)
	register_event("SendAudio","round_start","bc","2=%!MRAD_GO","2=%!MRAD_MOVEOUT","2=%!MRAD_LETSGO","2=%!MRAD_LOCKNLOAD")
	register_event("SendAudio","round_end","a","2=%!MRAD_terwin","2=%!MRAD_ctwin","2=%!MRAD_rounddraw")
	register_event("CurWeapon","drop_it","be","1=1")
	register_event("Damage","damage_event","be","2!0","3=0","4!0")
	register_concmd("jediattack","attack_func",0,"attacks with lightsaber")
	register_concmd("jedipush","force_push",0,"uses force push")
	register_concmd("jedichoke","choke_func",0,"lifts enemy into the air and drains their health")
	register_concmd("jedishock","shock_func",0,"shocks enemy with lightning")
	register_concmd("jedigrab","grab_toggle",0,"press once to grab and again to release")
	register_concmd("jedimenu","jedi_menu",0,"opens the jedi menu to change powers")
	register_concmd("powerup","next_power",0,"selects next power")
	register_concmd("powerdown","prev_power",0,"selects previous power")
	return PLUGIN_CONTINUE
}
