

/* AMX Mod script. 
* 
* (c) Copyright 2002, Rav
* This file is provided as is (no warranties).
*
* Send players to a stored location on maps.
* [AMX] Usage: amx_jail < authid | part of nick >
* ADMIN LEVEL A Required
*
* File addons/amx/jail/jail.cor is required (coord locations).
* Sound sound/misc/dead_police is needed.
* Release time is 45 seconds
*/

#include <amxmod> 
#include <fun>

#define MAX_NAME_LENGTH 32
#define MAX_DATA_LENGTH 256
#define MAX_PLAYERS 32
#define MAX_NAME_LENGTH 32
#define MAX_DATA_LENGTH 256
#define ON 1
#define OFF 0
#define YES 1
#define NO 0

//jail vars
new PlayerIsjailed[MAX_PLAYERS]
new PrejailOrigin[MAX_PLAYERS][3]

/**********************************  UNjail FUNCTION *****************************/
public release_jail(skIndex[]) 
{
	new kIndex = str_to_num(skIndex)
	new kName[32]
	get_user_name(kIndex,kName,32)
	if (is_user_alive(kIndex) == 1) 
		if(PlayerIsjailed[kIndex] == YES) 
		{
			set_user_origin(kIndex,PrejailOrigin[kIndex])
			PlayerIsjailed[kIndex]=NO
			set_hudmessage(0, 100, 200, 0.05, 0.50, 2, 0.1, 3.0, 0.02, 0.02, 10) 
			show_hudmessage(0,"%s has been released on parole!!", kName) 
		}
}
/**********************************  End Release FUNCTION **************************/

public admin_jail(id) 
{ 
	if (!(get_user_flags(id)&ADMIN_LEVEL_A)) { 
		client_print(id, print_console,"[AMX] You have no access to that command") 
		return PLUGIN_HANDLED 
	} 
	if (read_argc() < 2) { 
		client_print(id, print_console,"[AMX] Usage: amx_jail < authid | part of nick >") 
		return PLUGIN_HANDLED 
	} 
	new arg[MAX_NAME_LENGTH+1] 
	read_argv(1,arg,MAX_NAME_LENGTH) 
	new player = find_player("c",arg) 
	if (!player) player = find_player("bl",arg) 
	if (player)    { 
		new Name[MAX_NAME_LENGTH+1] 
		get_user_name(player,Name,MAX_NAME_LENGTH) 
		if (get_user_flags(player)&ADMIN_IMMUNITY) { 
			client_print(id, print_console,"[AMX] %s has immunity",Name) 
			return PLUGIN_HANDLED 
		} 
		if (is_user_alive(player)==0) { 
			client_print(id,print_console,"[AMX] %s is dead",Name) 
			return PLUGIN_HANDLED 
		}       
		if (file_exists("addons\amx\jail\jail.cor")){
			new readdata[50]
			new currentmap[32]
			new jaillocation[3]
			new len
			get_mapname(currentmap,32)                      
			for(new i=0; i < 100 && read_file("addons\amx\jail\jail.cor",i,readdata,50,len) != 0; i += 1) 
			{
			read_file("addons\amx\jail\jail.cor",i,readdata,50,len)
			new map[32]
			new x[12]
			new y[12]
			new z[12]
			parse(readdata,map,32,x,12,y,12,z,12)
			if(equal(map,currentmap))
			{
			jaillocation[0] = str_to_num(x)
			jaillocation[1] = str_to_num(y)
			jaillocation[2] = str_to_num(z)
			}
		}
			get_user_origin(player,PrejailOrigin[player])
			PrejailOrigin[player][2] += 5
			engclient_cmd(player,"drop")
			engclient_cmd(player,"drop")
			set_user_origin(player,jaillocation)
			new inmate[32]
			get_user_name(player,inmate,32)
			set_hudmessage(0, 100, 200, 0.05, 0.50, 2, 0.1, 3.0, 0.02, 0.02, 10) 
			show_hudmessage(0,"%s has been sentenced and put behind bars!",inmate) 
			set_user_rendering(player,kRenderFxNone,255,255,255, kRenderNormal,16);	
			new kIndex = player
			PlayerIsjailed[kIndex] = YES
			new skIndex[32]
			num_to_str(kIndex,skIndex,32)
			set_task(45.0, "release_jail" , 1 , skIndex, 32)
			client_cmd(0,"spk misc/dead_police")
			set_hudmessage(220,80,0,0.05,0.15,0, 6.0, 12.0, 1.0, 2.0, 1)
			show_hudmessage(kIndex,"You are now in jail, wait for parole! (45 seconds)")
			new param[1] 
	 		param[0] = kIndex
		}        
	} 
	else { 
		client_print(id,print_console,"[AMX] Client with that authid or part of nick not found") 
	} 
	return PLUGIN_HANDLED 
} 

public reset_hud(id){ 
	remove_task(1)
	return PLUGIN_CONTINUE 
} 

public plugin_init(){ 
	register_plugin("Admin Jail","1.12","Rav") 
	register_clcmd("amx_jail","admin_jail",ADMIN_LEVEL_A,"amx_jail < authid | part of nick >")
	register_event("ResetHUD","reset_hud","b")
	return PLUGIN_CONTINUE
} 
