// sounds based on oldest version of sank_sounds ... not configable
// by file, to add sounds, you must add code for each sound.
// dont ask ... if you can do it  ... fine ... if not, dont use
// this plugin

#include <amxmod>
#include <amxmisc>

new bool:cuss = true

new Float:SndFreq1[33]
new Float:SndFreq2
new SndFreq3

public plugin_init(){
	register_plugin("ejl sounds","0.0","EJL")
	register_concmd("amx_cuss", "admin_cuss",ADMIN_LEVEL_C,": Turns cuss filter on and off")
	register_clcmd("say", "HandleSay")
	register_cvar("amx_ejl_nocuss","1")
	set_task(1.0,"delay_cuss")

	register_srvcmd("botsay","handle_botsayplugin")
	return PLUGIN_CONTINUE
}

public delay_cuss(){
	if(get_cvar_num("amx_ejl_nocuss") == 0)
		cuss = true
	else
		cuss = false
	return PLUGIN_CONTINUE
}

public client_connect(id){
	SndFreq1[id] = 0.0
	return PLUGIN_CONTINUE
}

public client_disconnect(id) {
	SndFreq1[id] = 0.0
	return PLUGIN_CONTINUE
}

QuotaCheck(User[], UserIndex){
	new Float:CurTime = get_gametime()
	if (!(get_user_flags(UserIndex)&ADMIN_USER)){
		if (CurTime <= SndFreq1[UserIndex] + 3.0){
			get_user_name(UserIndex,User,32)
			client_print(UserIndex,print_chat,"[AMX] Sounds are fun, but not if you use them too fast, %s",User)
			SndFreq1[UserIndex] = CurTime
			return 1
		}
		SndFreq1[UserIndex] = CurTime
	}
	if (CurTime <= SndFreq2 + 0.3)
		SndFreq3 = 1
	else
		SndFreq3 = 0
	SndFreq2 = CurTime
	return 0
}

public admin_cuss(id,level,cid) {
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED

	if (cuss == true){
		cuss = false
	}else	{
		cuss = true
	}
	return PLUGIN_CONTINUE
}

playsoundall(ww[]){
	client_cmd(0,"play %s",ww)	
}

say(Text[])
{
	if (SndFreq3)
		return 0

	new bad = 0
	if(cuss == false){
		if ( (containi(Text, "ass") != -1) ||
		 (containi(Text, "cunt") != -1) ||
		 (containi(Text, "shit") != -1) ||
		 (containi(Text, "bastard") != -1) ||
		 (containi(Text, "piss") != -1) ||
		 (containi(Text, "fuc") != -1) ||
		 (containi(Text, "suck") != -1) ||
		 (containi(Text, "bitch") != -1) ||
		 (containi(Text, "dam") != -1) ||
		 (containi(Text, "fuk") != -1) ||
		 (containi(Text, "stfu") != -1) ||
		 (containi(Text, "dick") != -1) ||
		 (containi(Text, "fag") != -1) ){
			bad = 1
		}
	}

	if(bad==1){
		client_print(0,print_chat,"<Server>  PlaySound text has been censored.")
	}else{
		client_print(0,print_chat,Text)
	}
	bad=0
	return 0
}

public handle_botsayplugin(){
	new arg0[8]
	read_argv(1,arg0,7)
	new iarg0 = strtonum(arg0)
	new sarg2[192]
	read_args(sarg2,191)
	new arg1[8]
	read_argv(2,arg1,7)
	new iarg1 = strtonum(arg1)
	if(is_user_bot(iarg1)){
		new OnlySay[128]
		new len = strlen(sarg2)
		new start = contain(sarg2,":    ")
		copy(OnlySay,len-start+5,sarg2[start+5])
		if(HandleSay2(iarg1,OnlySay))
			server_cmd("botsayreturn %d 1",iarg0)
	}
	return PLUGIN_CONTINUE
}

public HandleSay(id){
	new Speech[192]
	read_args(Speech,192)
	remove_quotes(Speech)
	if(HandleSay2(id,Speech))	
		return PLUGIN_HANDLED
	return PLUGIN_CONTINUE
}

public HandleSay2(id,Speech[]) 
{
	new User[32]
	new Text[192]

	get_user_name(id,User,32)

	if (equali(Speech, "bud"))
	{
		if (!QuotaCheck(User, id))
		{
			format(Text, 192, "<PlaySound> %s :    %s", User, Speech)
			say(Text)
			new rand = random(3)
			switch(rand)
			{
				case 0:	playsoundall("misc\bud.wav")
				case 1: playsoundall("misc\weis.wav")
				case 2: playsoundall("misc\er.wav")
			}

			return PLUGIN_HANDLED
		}
	}
	else if (equali(Speech, "crap"))
	{
		if (!QuotaCheck(User, id))
		{
			format(Text, 192, "<PlaySound> %s :    %s", User, Speech)
			say(Text)
			new rand = random(3)
			switch(rand)
			{
				case 0:	playsoundall("misc\awwcrap.wav")
				case 1: playsoundall("misc\awwcrap2.wav")
				case 2: playsoundall("misc\awwman.wav")
			}

			return PLUGIN_HANDLED
		}
	}
	else if (equali(Speech, "doh"))
	{
		if (!QuotaCheck(User, id))
		{
			format(Text, 192, "<PlaySound> %s :    %s", User, Speech)
			say(Text)
			new rand = random(6)
			switch(rand)
			{
				case 0:	playsoundall("misc\doh.wav")
				case 1: playsoundall("misc\doh2.wav")
				case 2: playsoundall("misc\doh3.wav")
				case 3: playsoundall("misc\doh4.wav")
				case 4: playsoundall("misc\doh5.wav")
//				case 5: playsoundall("misc\doh6.wav")	// wasn't in PCM format
				case 5: playsoundall("misc\doh7.wav")
			}

			return PLUGIN_HANDLED
		}
	}
	else if (equali(Speech, "ha ha"))
	{
		if (!QuotaCheck(User, id))
		{
			format(Text, 192, "<PlaySound> %s :    %s", User, Speech)
			say(Text)
			playsoundall("misc\haha.wav")
			// I had a playsoundall("vox\haha2.wav") in here once, but
			// there was something wrong with the wav, and it went into
			// an infinite loop for somereason...

			return PLUGIN_HANDLED
		}
	}
	else if (equali(Speech, "ouch"))
	{
		if (!QuotaCheck(User, id))
		{
			format(Text, 192, "<PlaySound> %s :    %s", User, Speech)
			say(Text)
			playsoundall("misc\ow.wav")

			return PLUGIN_HANDLED
		}
	}
	else if (equali(Speech, "woohoo"))
	{
		if (!QuotaCheck(User, id))
		{
			format(Text, 192, "<PlaySound> %s :    %s", User, Speech)
			say(Text)
			new rand = random(2)
			switch(rand)
			{
				case 0:	playsoundall("misc\woohoo.wav")
				case 1: playsoundall("misc\woohoo2.wav")
			}

			return PLUGIN_HANDLED
		}
	}
	// Special sounds that nobody knows how to use but me
	else if (equali(Speech, "admin_doomed"))
	{
		if (!QuotaCheck(User, id))
		{
			format(Text, 192, "<PlaySound> %s :    %s", User, Speech)
			say(Text)
			playsoundall("misc\doomed.wav")

			return PLUGIN_HANDLED
		}
	}
	else if (equali(Speech, "admin_dohoo"))
	{
		if (!QuotaCheck(User, id))
		{
			format(Text, 192, "<PlaySound> %s :    %s", User, Speech)
			say(Text)
			playsoundall("misc\dohoo.wav")

			return PLUGIN_HANDLED
		}
	}
	else if (equali(Speech, "admin_dohnuts"))
	{
		if (!QuotaCheck(User, id))
		{
			format(Text, 192, "<PlaySound> %s :    %s", User, Speech)
			say(Text)
			playsoundall("misc\dohnuts.wav")

			return PLUGIN_HANDLED
		}
	}

	return PLUGIN_CONTINUE;
}

