#include <amxmod> 
#include <amxmisc> 

new bool:AWPDisabled
new bool:PistolsEnabled
new bool:KnifeEnabled
new bool:ScopesDisabled
new bool:RifleDisabled

new option[2]

public amx_awp(id,level,cid) {
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED

	new arg1[4]
	read_argv(1,arg1,3)
	
	if (equal(arg1,"1")||equali(arg1,"on")){
		AWPDisabled = true
	}
	else if (equal(arg1,"0")||equali(arg1,"off")){
		AWPDisabled = false
	}
	else {
		console_print(id,"Awps are %s",AWPDisabled ? "disabled" : "enabled")
		return PLUGIN_HANDLED
	}

	console_print(id,"AWP %s",AWPDisabled ? "disabled" : "enabled")
	client_print(0,print_center,"AWPs Have Been %s!",AWPDisabled ? "Disabled" : "Enabled")	
	set_hudmessage(0, 100, 0, 0.05, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)	
	show_hudmessage(0,AWPDisabled ? "AWPs Disabled" : "AWPs Allowed" )

	return PLUGIN_HANDLED
}  

public amx_awp2(id,level,cid){
	if (!(get_user_flags(id)&ADMIN_LEVEL_H)) { 
		if(id != 0){ 
			client_print(id,print_console,"[AMX] You have no access to that command") 
			return PLUGIN_HANDLED
		} 
	}
	if (AWPDisabled==true)
		AWPDisabled=false
	else
		AWPDisabled=true
	
	console_print(id,"AWP %s",AWPDisabled ? "disabled" : "enabled")
	client_print(0,print_center,"AWPs Have Been %s!",AWPDisabled ? "Disabled" : "Enabled")	
	set_hudmessage(0, 100, 0, 0.05, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)	
	show_hudmessage(0,AWPDisabled ? "AWPs Disabled" : "AWPs Allowed" )

	return PLUGIN_HANDLED
}

new voteawp[] = "\yAMX %s AWP?\w^n^n1. Yes^n2. No"

public vote_awp(id){
	new Float:voting = get_cvar_float("amx_last_voting")
	if (voting > get_gametime()){ 
		client_print(id,print_chat,"* There is already one voting...") 
		return PLUGIN_HANDLED 
	} 
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		client_print(id,print_chat,"* Voting not allowed at this time...") 
		return PLUGIN_HANDLED 
	}
	new menu_msg[256]
	format(menu_msg,255,voteawp,AWPDisabled ? "Enable" : "Disable")
	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting",  get_gametime() + vote_time )
	show_menu(0,(1<<0)|(1<<1),menu_msg,floatround(vote_time))
	set_task(vote_time,"check_awpvotes")
	client_print(0,print_chat,"* Voting has started...") 
	option[0]=option[1]=0
	return PLUGIN_HANDLED 	
}

public check_awpvotes(id){
	if (option[0] > option[1]){
		server_cmd(  "amx_disableawp %s", AWPDisabled ? "off" : "on" )
		client_print(0,print_chat,"* Voting successful (yes ^"%d^") (no ^"%d^").",option[0],option[1])
	}
	else{
		client_print(0,print_chat,"* Voting failed (yes ^"%d^") (no ^"%d^").",option[0],option[1])
	}
	return PLUGIN_CONTINUE
}

public amx_enablepistols(id,level,cid) {
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED

	new arg1[4]
	read_argv(1,arg1,3)
	
	if (equal(arg1,"1")||equali(arg1,"on")){
		PistolsEnabled = true
	}
	else if (equal(arg1,"0")||equali(arg1,"off")){
		PistolsEnabled = false
	}
	else {
		console_print(id,"Pistols Only Mode is %s",PistolsEnabled ? "enabled" : "disabled")
		return PLUGIN_HANDLED
	}

	console_print(id,"Pistols Only Mode %s",PistolsEnabled ? "enabled" : "disabled")
	client_print(0,print_center,"Pistols Only Mode Has Been %s!",PistolsEnabled ? "Enabled" : "Disabled")
	set_hudmessage(0, 100, 0, 0.05, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)	
	show_hudmessage(0,PistolsEnabled ? "Pistols Only Allowed" : "All Guns Allowed" )

	return PLUGIN_HANDLED
}  

public amx_pistols2(id,level,cid){
	if (!(get_user_flags(id)&ADMIN_LEVEL_H)) { 
		if(id != 0){ 
			client_print(id,print_console,"[AMX] You have no access to that command") 
			return PLUGIN_HANDLED
		} 
	}
	if (PistolsEnabled==true)
		PistolsEnabled=false
	else
		PistolsEnabled=true

	console_print(id,"Pistols Only Mode %s",PistolsEnabled ? "enabled" : "disabled")
	client_print(0,print_center,"Pistols Only Mode Has Been %s!",PistolsEnabled ? "Enabled" : "Disabled")
	set_hudmessage(0, 100, 0, 0.05, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)	
	show_hudmessage(0,PistolsEnabled ? "Pistols Only Allowed" : "All Guns Allowed" )

	return PLUGIN_HANDLED
}

new votepistols[] = "\yAMX %s Pistols Only Mode?\w^n^n1. Yes^n2. No"

public vote_pistols(id){
	new Float:voting = get_cvar_float("amx_last_voting")
	if (voting > get_gametime()){ 
		client_print(id,print_chat,"* There is already one voting...") 
		return PLUGIN_HANDLED 
	} 
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		client_print(id,print_chat,"* Voting not allowed at this time...") 
		return PLUGIN_HANDLED 
	}
	if (KnifeEnabled==true){
		client_print(id,print_chat,"Sorry, it's knives only right now. To change type vote_knives") 
		return PLUGIN_HANDLED 
	} 

	new menu_msg[256]
	format(menu_msg,255,votepistols,PistolsEnabled ? "Disable" : "Enable")
	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting",  get_gametime() + vote_time )
	show_menu(0,(1<<0)|(1<<1),menu_msg,floatround(vote_time))
	set_task(vote_time,"check_pistolvotes")
	client_print(0,print_chat,"* Voting has started...") 
	option[0]=option[1]=0
	return PLUGIN_HANDLED 	
}

public check_pistolvotes(id){
	if (option[0] > option[1]){
		server_cmd(  "amx_thepistols %s", PistolsEnabled ? "off" : "on" )
		client_print(0,print_chat,"* Voting successful (yes ^"%d^") (no ^"%d^").",option[0],option[1])
	}
	else{
		client_print(0,print_chat,"* Voting failed (yes ^"%d^") (no ^"%d^").",option[0],option[1])
	}
	return PLUGIN_CONTINUE
}

public amx_enableknife(id,level,cid) {
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED

	new arg1[4]
	read_argv(1,arg1,3)
	
	if (equal(arg1,"1")||equali(arg1,"on")){
		KnifeEnabled = true
		PistolsEnabled = false
	}
	else if (equal(arg1,"0")||equali(arg1,"off")){
		KnifeEnabled = false
	}
	else {
		console_print(id,"Knives Only Mode is %s",KnifeEnabled ? "enabled" : "disabled")
		return PLUGIN_HANDLED
	}

	console_print(id,"Knives Only Mode %s",KnifeEnabled ? "enabled" : "disabled")
	client_print(0,print_center,"Knives Only Mode Has Been %s!",KnifeEnabled ? "Enabled" : "Disabled")
	set_hudmessage(0, 100, 0, 0.05, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)	
	show_hudmessage(0,KnifeEnabled ? "Knives Only Allowed" : "All Guns Allowed" )

	return PLUGIN_HANDLED
}  

public amx_knife2(id,level,cid){
	if (!(get_user_flags(id)&ADMIN_LEVEL_H)) { 
		if(id != 0){ 
			client_print(id,print_console,"[AMX] You have no access to that command") 
			return PLUGIN_HANDLED
		} 
	}
	if (KnifeEnabled==true)
		KnifeEnabled=false
	else
		KnifeEnabled=true

	console_print(id,"Knives Only Mode %s",KnifeEnabled ? "enabled" : "disabled")
	client_print(0,print_center,"Knives Only Mode Has Been %s!",KnifeEnabled ? "Enabled" : "Disabled")
	set_hudmessage(0, 100, 0, 0.05, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)	
	show_hudmessage(0,KnifeEnabled ? "Knives Only Allowed" : "All Guns Allowed" )
	return PLUGIN_HANDLED
}

new voteknife[] = "\yAMX %s Knives Only Mode?\w^n^n1. Yes^n2. No"

public vote_knife(id){
	new Float:voting = get_cvar_float("amx_last_voting")
	if (voting > get_gametime()){ 
		client_print(id,print_chat,"* There is already one voting...") 
		return PLUGIN_HANDLED 
	} 
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		client_print(id,print_chat,"* Voting not allowed at this time...") 
		return PLUGIN_HANDLED 
	}
	new menu_msg[256]
	format(menu_msg,255,voteknife, KnifeEnabled ? "Disable" : "Enable")
	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting",  get_gametime() + vote_time )
	show_menu(0,(1<<0)|(1<<1),menu_msg,floatround(vote_time))
	set_task(vote_time,"check_knifevotes")
	client_print(0,print_chat,"* Voting has started...") 
	option[0]=option[1]=0
	return PLUGIN_HANDLED 	
}

public check_knifevotes(id){
	if (option[0] > option[1]){
		server_cmd(  "amx_enableknife %s", KnifeEnabled ? "off" : "on" )
		client_print(0,print_chat,"* Voting successful (yes ^"%d^") (no ^"%d^").",option[0],option[1])
	}
	else{
		client_print(0,print_chat,"* Voting failed (yes ^"%d^") (no ^"%d^").",option[0],option[1])
	}
	return PLUGIN_CONTINUE
}

public amx_disablescopes(id,level,cid) {
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED

	new arg1[4]
	read_argv(1,arg1,3)
	
	if (equal(arg1,"1")||equali(arg1,"on")){
		ScopesDisabled = true
	}
	else if (equal(arg1,"0")||equali(arg1,"off")){
		ScopesDisabled = false
	}
	else {
		console_print(id,"Scopes Only Mode is %s",ScopesDisabled ? "disabled" : "enabled")
		return PLUGIN_HANDLED
	}

	console_print(id,"Scopes Only Mode %s",ScopesDisabled ? "disabled" : "enabled")
	client_print(0,print_center,"Scopes Only Mode Has Been %s!",ScopesDisabled ? "Disabled" : "Enabled")
	set_hudmessage(0, 100, 0, 0.05, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)	
	show_hudmessage(0,ScopesDisabled ? "Scopes Only Allowed" : "All Guns Allowed" )

	return PLUGIN_HANDLED
}  

public amx_scopes2(id,level,cid){
	if (!(get_user_flags(id)&ADMIN_LEVEL_H)) { 
		if(id != 0){ 
			client_print(id,print_console,"[AMX] You have no access to that command") 
			return PLUGIN_HANDLED
		} 
	}
	if (ScopesDisabled==true)
		ScopesDisabled=false
	else
		ScopesDisabled=true

	console_print(id,"Scopes %s",ScopesDisabled ? "disabled" : "enabled")
	client_print(0,print_center,"Scopes Only Mode Has Been %s!",ScopesDisabled ? "Disabled" : "Enabled")
	set_hudmessage(0, 100, 0, 0.05, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)	
	show_hudmessage(0,ScopesDisabled ? "Scopes Only Allowed" : "All Guns Allowed" )

	return PLUGIN_HANDLED
}

new votescopes[] = "\yAMX %s Scopes?\w^n^n1. Yes^n2. No"

public vote_scopes(id){
	new Float:voting = get_cvar_float("amx_last_voting")
	if (voting > get_gametime()){ 
		client_print(id,print_chat,"* There is already one voting...") 
		return PLUGIN_HANDLED 
	} 
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		client_print(id,print_chat,"* Voting not allowed at this time...") 
		return PLUGIN_HANDLED 
	}
	if (KnifeEnabled==true){
		client_print(id,print_chat,"Sorry, it's knives only right now. To change type vote_knives") 
		return PLUGIN_HANDLED 
	} 

	new menu_msg[256]
	format(menu_msg,255,votescopes,ScopesDisabled ? "Disable" : "Enable")
	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting",  get_gametime() + vote_time )
	show_menu(0,(1<<0)|(1<<1),menu_msg,floatround(vote_time))
	set_task(vote_time,"check_scopevotes")
	client_print(0,print_chat,"* Voting has started...") 
	option[0]=option[1]=0
	return PLUGIN_HANDLED 	
}

public check_scopevotes(id){
	if (option[0] > option[1]){
		server_cmd(  "amx_disablescopes %s", ScopesDisabled ? "off" : "on" )
		client_print(0,print_chat,"* Voting successful (yes ^"%d^") (no ^"%d^").",option[0],option[1])
	}
	else{
		client_print(0,print_chat,"* Voting failed (yes ^"%d^") (no ^"%d^").",option[0],option[1])
	}
	return PLUGIN_CONTINUE
}

public amx_Rifle(id,level,cid) {
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED

	new arg1[4]
	read_argv(1,arg1,3)
	
	if (equal(arg1,"1")||equali(arg1,"on")){
		RifleDisabled = true
	}
	else if (equal(arg1,"0")||equali(arg1,"off")){
		RifleDisabled = false
	}
	else {
		console_print(id,"Rifles are %s",RifleDisabled ? "disabled" : "enabled")
		return PLUGIN_HANDLED
	}

	console_print(id,"Rifle %s",RifleDisabled ? "disabled" : "enabled")
	client_print(0,print_center,"Rifles Have Been %s!",RifleDisabled ? "Disabled" : "Enabled")	
	set_hudmessage(0, 100, 0, 0.05, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)	
	show_hudmessage(0,RifleDisabled ? "Rifles Disabled" : "Rifles Allowed" )

	return PLUGIN_HANDLED
}  

public amx_rifle2(id,level,cid){
	if (!(get_user_flags(id)&ADMIN_LEVEL_H)) { 
		if(id != 0){ 
			client_print(id,print_console,"[AMX] You have no access to that command") 
			return PLUGIN_HANDLED
		} 
	}
	if (RifleDisabled==true)
		RifleDisabled=false
	else
		RifleDisabled=true
	
	console_print(id,"Rifle %s",RifleDisabled ? "disabled" : "enabled")
	client_print(0,print_center,"Rifles Have Been %s!",RifleDisabled ? "Disabled" : "Enabled")	
	set_hudmessage(0, 100, 0, 0.05, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)	
	show_hudmessage(0,RifleDisabled ? "Rifles Disabled" : "Rifles Allowed" )

	return PLUGIN_HANDLED
}

new voteRifle[] = "\yAMX %s Rifles?\w^n^n1. Yes^n2. No"

public vote_Rifle(id){
	new Float:voting = get_cvar_float("amx_last_voting")
	if (voting > get_gametime()){ 
		client_print(id,print_chat,"* There is already one voting...") 
		return PLUGIN_HANDLED 
	} 
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		client_print(id,print_chat,"* Voting not allowed at this time...") 
		return PLUGIN_HANDLED 
	}
	new menu_msg[256]
	format(menu_msg,255,voteRifle,RifleDisabled ? "Enable" : "Disable")
	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting",  get_gametime() + vote_time )
	show_menu(0,(1<<0)|(1<<1),menu_msg,floatround(vote_time))
	set_task(vote_time,"check_Riflevotes")
	client_print(0,print_chat,"* Voting has started...") 
	option[0]=option[1]=0
	return PLUGIN_HANDLED 	
}

public check_Riflevotes(id){
	if (option[0] > option[1]){
		server_cmd(  "amx_disableRifle %s", RifleDisabled ? "off" : "on" )
		client_print(0,print_chat,"* Voting successful (yes ^"%d^") (no ^"%d^").",option[0],option[1])
	}
	else{
		client_print(0,print_chat,"* Voting failed (yes ^"%d^") (no ^"%d^").",option[0],option[1])
	}
	return PLUGIN_CONTINUE
}

public vote_count(id,key){ 
	if ( get_cvar_float("amx_vote_answers") ) { 
		new name[32] 
		get_user_name(id,name,31)
		client_print(0,print_chat,"* %s voted %s", name, key ? "against" : "for" )
	}
	++option[key]
	return PLUGIN_HANDLED
} 

public dropthatweapon(id) {
	if(AWPDisabled == true)
	{
		new wepi = read_data(2)
		if(wepi != 18)
			return PLUGIN_HANDLED
		client_print(id,print_chat,"[AMX]  Hey butterfingers!  Dont waste your time and money. It's no AWPs now. say: vote_awp")
		engclient_cmd(id,"drop") 
		return PLUGIN_HANDLED
	}
	else if(PistolsEnabled == true)
	{
		new wepi = read_data(2)
		if(wepi == 1 || wepi == 6 || wepi == 10 || wepi == 11 || wepi == 16 || wepi == 17 || wepi == 26 || wepi == 29 || wepi == 4 || wepi == 9 || wepi == 25 )
			return PLUGIN_HANDLED
		client_print(id,print_chat,"[AMX]  Hey butterfingers!  Dont waste your time and money. It's pistols only now. Say: vote_pistols")
		engclient_cmd(id,"drop")
		return PLUGIN_HANDLED
	}
	else if (KnifeEnabled == true)
	{
		engclient_cmd(id,"weapon_knife")
		return PLUGIN_HANDLED
	}
	else if (KnifeEnabled == true)
	{
		engclient_cmd(id,"weapon_knife")
		return PLUGIN_HANDLED
	}
	else if (ScopesDisabled == true)
	{
		new wepi = read_data(2)
		if(wepi == 3 || wepi == 8 || wepi == 13 || wepi == 18 || wepi == 24 || wepi == 27){
			client_print(id,print_chat,"[AMX]  Hey butterfingers!  Dont waste your time and money. It's no scoped weapons. Say vote_scopes")
			engclient_cmd(id,"drop")
		}
	}
	else if(RifleDisabled == true) {
		new wepi = read_data(2)
		if(wepi == 3 || wepi == 8 || wepi == 13 || wepi == 18 || wepi == 24 || wepi == 27 || wepi == 22 || wepi == 28 || wepi==14 || wepi==15){
			client_print(id,print_chat,"[AMX]  Hey butterfingers!  Dont waste your time and money. It's no rifles. Say: vote_rifles")
			engclient_cmd(id,"drop")
		}
		return PLUGIN_HANDLED
	}


	return PLUGIN_HANDLED
} 

public HandleSay(id) {
	new Speech[192]
	read_args(Speech,192)
	remove_quotes(Speech)
	if ((containi(Speech, "awp") != -1) || (containi(Speech, "pistol") != -1) || (containi(Speech, "knife") != -1) || (containi(Speech, "knives") != -1) || (containi(Speech, "scope") != -1) || (containi(Speech, "rifle") != -1))
	{
		if(PistolsEnabled == true)
		{
			client_print(id,print_chat, "[AMX]  Its Pistols only right now. To change say vote_pistols")
		}
		else if(AWPDisabled == true)
		{
			client_print(id,print_chat, "[AMX]  The AWP is disabled right now. To change say vote_awp")
		}
		else if(KnifeEnabled == true)
		{
			client_print(id,print_chat, "[AMX]  Knives only right now. To change say vote_knives")
		}
		else if(ScopesDisabled == true)
		{
			client_print(id,print_chat, "[AMX]  No Scopes right now. To change say vote_scopes")
		}
		else if(RifleDisabled == true)
		{
			client_print(id,print_chat, "[AMX]  Rifles are disabled right now. To change say vote_rifles")
		}
		else
		{
			client_print(id,print_chat, "[AMX]  All weapons enabled. To change say vote_awp, vote_pistols, vote_knives, vote_scopes, vote_rifles")
		}
	}

	return PLUGIN_CONTINUE
}

public new_round(){
	if(PistolsEnabled == true)
	{
		client_print(0,print_chat, "[AMX]  Its Pistols only right now. DON'T WASTE YOUR MONEY")
	}
	else if(AWPDisabled == true)
	{
		client_print(0,print_chat, "[AMX]  The AWP is disabled right now. DON'T WASTE YOUR MONEY!")
	}
	else if(ScopesDisabled == true)
	{
		client_print(0,print_chat, "[AMX]  No Scopes right now. DON'T WASTE YOUR MONEY!")
	}
	else if(RifleDisabled == true)
	{
		client_print(0,print_chat, "[AMX]  Rifles Disabled right now. DON'T WASTE YOUR MONEY!")
	}
	else if(KnifeEnabled == true)
	{
		client_print(0,print_chat, "[AMX]  Knives only right now. DON'T WASTE YOUR MONEY!")
	}
	
	return PLUGIN_CONTINUE

}
public plugin_init() {  
	register_plugin("Steam Weapon Voting System","1.2","Pimp Daddy (OoTOAoO)")
	register_event("CurWeapon","dropthatweapon","b","1=1")
	register_event("SendAudio","new_round","bc","2=%!MRAD_GO","2=%!MRAD_MOVEOUT","2=%!MRAD_LETSGO","2=%!MRAD_LOCKNLOAD")

	register_concmd("amx_disableawp","amx_awp",ADMIN_LEVEL_B,"<1|0> - Disable AWPs")
	register_concmd("amx_thepistols","amx_enablepistols",ADMIN_LEVEL_B,"<1|0> - pistols only mode")
	register_concmd("amx_disableRifle","amx_Rifle",ADMIN_LEVEL_B,"<1|0> - Disable Rifles")
	register_concmd("amx_enableknife","amx_enableknife",ADMIN_LEVEL_B,"<1|0> - knife only mode")
	register_concmd("amx_disablescopes","amx_disablescopes",ADMIN_LEVEL_B,"<1|0> - no scopes")


	register_clcmd("amx_knife","amx_knife2",ADMIN_LEVEL_H,"amx_awp :  toggles knife mode on and off")
	register_clcmd("amx_awp","amx_awp2",ADMIN_LEVEL_H,"amx_awp :  toggles awp mode off and on")
 	register_clcmd("amx_pistols","amx_pistols2",ADMIN_LEVEL_H,"amx_pistols :  toggles pistols only mode on and off") 
	register_clcmd("amx_scopes","amx_scopes2",ADMIN_LEVEL_H,"amx_scopes :  toggles scopes mode off and on")
	register_clcmd("amx_rifle","amx_rifle2",ADMIN_LEVEL_H,"amx_awp :  toggles rifles mode off and on")

	register_clcmd("say vote_awp","vote_awp",0,"- start voting session for no awp")
	register_clcmd("say vote_pistols","vote_pistols",0,"- start voting session for pistols only mode")
	register_clcmd("say vote_knife","vote_knife",0,"- start voting session for knives only")
	register_clcmd("say vote_knives","vote_knife",0,"- start voting session for knives only")
	register_clcmd("say vote_scopes","vote_scopes",0,"- start voting session for no scopes")
	register_clcmd("say vote_scope","vote_scopes",0,"- start voting session for no scopes")
	register_clcmd("say vote_rifles","vote_Rifle",0,"- start voting session for rifles only")
	register_clcmd("say vote_rifle","vote_Rifle",0,"- start voting session for rifles only")

	register_clcmd("say", "HandleSay")

	register_menucmd(register_menuid("Rifles?"),(1<<0)|(1<<1),"vote_count")
	register_menucmd(register_menuid("Scopes Only Mode?"),(1<<0)|(1<<1),"vote_count")
	register_menucmd(register_menuid("Pistols Only Mode?"),(1<<0)|(1<<1),"vote_count")
	register_menucmd(register_menuid("AWP?"),(1<<0)|(1<<1),"vote_count")
	register_menucmd(register_menuid("Knives Only Mode?"),(1<<0)|(1<<1),"vote_count")

	return PLUGIN_CONTINUE
}

