/* (C)1995-2003 The TCW Organization and David "BAILOPAN" Anderson
 * bail_root.sma
 * Allows for administrators to control the server in game without using the console.
 * Creation: 11-05-2003 Last Edit: 12-20-2003
 * (C)Copyright 2003 The TCW Organization and David "BAILOPAN" Anderson
 * http://www.tcwonline.org/
 * http://lambda.tcwonline.org/
 * dvander@tcwonline.org
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *  Give credit where due.
 *  Share the source - it sets you free
 *  http://www.opensource.org/
 *  http://www.gnu.org/
 */
 
//Tampering with the author and name lines will violate copyrights
// I spent a LONG time writing this and I'm personally sacrificing the
// sources to this to better the open-source and AMX community
// If I find you have blatantly taken credit for this, I will 
// probably gather a huge slashdot troll mob and burn your village down!
new PLUGINNAME[] = "Bail's Root Plugin (NOX)"
new VERSION[] = "2.21"
new BUILD_VERSION[] = "170"
new AUTHOR[] = "BAILOPAN"

//Graphic References used for this program:
// Plugin Slay2 (I forget the author)
// Plugin Gravity vote (system)
// Plugin Gore (mike_cao)

//Bwa-ha-ha-ha! Trogdor the MEMORY LEAKER strikes again
#pragma dynamic 131072
#define MAX_TEXT_LENGTH 192
#define MAX_INFO_LENGTH 32
#define MAX_NAME_LENGTH 32
#define MAX_CLR	9
#define MAX_ITEMS 80
#define MAX_TARGETS 25
#define MAX_AUTH 10

#include <amxmod>
#include <amxmisc>
#include <fun>

//m = needed for $
//n = slap, slay, kick
//o = ban, map change
//p = little cheats
//q = big cheats
//r = can do team targets
//s = can do all targets
//t = root

/* Begin global variables */
new usersFile[] = "addons/amx/config/users.ini"
new lbolt, cloud, white						//from slay2
new LAST_COMMAND[32][MAX_TEXT_LENGTH]		//for nonrecursive $!
new IS_GAGGED[32]							//gag flags
new GLOW_VARS[32][3]						//glowing variables.
new g_Colors[MAX_CLR][] = {"white","red","green","blue","yellow","magenta","cyan","black","lime"}
new g_Values[MAX_CLR][] = {{255,255,255},{255,0,0},{0,255,0},{0,0,255},{255,255,0},{255,0,255},{0,255,255},{10,10,10},{136,246,144}}
new g_msgChannel
new LAST_PM[32]								//psay values*
new mapFile[32]								/*map file defs*/
new MV_TARGETS[MAX_TARGETS][32]				//These are for the node system
new MV_XCOORDS[MAX_TARGETS]					//
new MV_YCOORDS[MAX_TARGETS]					//
new MV_ZCOORDS[MAX_TARGETS]					//
new MV_ENABLED = 0							//
new MV_TARGCNT = 0							/*end*/
new IS_INVIS[32]							//invis flags
new LISTEN[32]			  					//For hearing other players
new LAST_TARGET[32][2]						//[0]: 0=player, 1=mass.  [1]: targetid
new AUTH_USERS[MAX_AUTH][32]				//Remote authentication
new AUTH_PASS[MAX_AUTH][32]					//
new AUTH_FLAGS[MAX_AUTH][32]				//
new AUTH_NUM								//
new Float:USER_SPEEDS[32]					//for speed
new IS_USER_SPEED[32]						
new Float:fSpeed							//
new Float:USER_GRAVITY[32]					//for user gravity
new IS_USER_GRAVITY[32]						//
new Float:fGrav								//
new gmsgFade, gmsgScoreInfo, gmsgShake, gmsgScoreAttrib
new bool:IS_VOTING = false					//for voting
new bool:STOP_VOTE = false
new VOTE_CHOICE[4]
new VOTE_MSG[MAX_TEXT_LENGTH]
new TWIN[32]								//for twin setting.
new TWIN_PHASE[32]							//
new FILL_TARGET[32]							//
new DBUG[32]								//debugmode?
new CMDS[128][2]							//Access level defs
new d_level[2]								//level for $
new t_level[2]								//level for /x
new a_level[2]								//level for /*, /@
new bomb									//for kamikaze
new IS_BOMB[32]								//
new MOD_ITEMS[MAX_ITEMS][24]				//For mod entity lists
new MOD_ITEMCOUNT							//
new fire, m_fireball						//from ATAC, fireball

/* End global variables */
/* Begin initial functions */

//Wrapper for containi
bool:cwrap(const String1[], const String2[])
{
	if (containi(String1, String2)!=-1) {
		return true
	} else {
		return false
	}

	return false
}

//Wrapper to check for access levels
bool:caccess(id, const flag[])
{
	new flag_string[MAX_NAME_LENGTH]
	get_flags(get_user_flags(id), flag_string, MAX_NAME_LENGTH-1)
	if (cwrap(flag_string, flag[0])) {
		return true
	} else {
		return false
	}

	return false
}

//Wrapper to make a highlander effect
bool:check_target(UserID, TargetID)
{
	new UserFlags = get_user_flags(UserID)
	new TargetFlags = get_user_flags(TargetID)
	if (!UserID || !TargetID) {
		return false
	}
	if (UserID == TargetID) {
		return true
	}
	if (UserFlags>=TargetFlags) {
		return true
	} else {
		client_print(UserID, print_chat, "[PBR]: Your admin level is not high enough to affect this player.")
		return false
	}

	return false
}

//Ultimate wrapper for checking levels and stuff
bool:can_do(id, TargetID, flag[])
{
	if (caccess(id, flag) && check_target(id, TargetID)) {
		return true
	} else {
		return false
	}

	return false
}

bool:is_digit(flag[])
{
	if (equali(flag[0], "1", 1)) {
		return true
	} else if (equali(flag[0], "2", 1)) {
		return true
	} else if (equali(flag[0], "3", 1)) {
		return true
	} else if (equali(flag[0], "4", 1)) {
		return true
	} else if (equali(flag[0], "5", 1)) {
		return true
	} else if (equali(flag[0], "6", 1)) {
		return true
	} else if (equali(flag[0], "7", 1)) {
		return true
	} else if (equali(flag[0], "8", 1)) {
		return true
	} else if (equali(flag[0], "9", 1)) {
		return true
	} else if (equali(flag[0], "0", 1)) {
		return true
	} else {
		return false
	}

	return false
}

public plugin_init()
{
	register_plugin(PLUGINNAME, VERSION, AUTHOR)
	register_clcmd("say", "HandleSay")
	register_clcmd("say_team", "HandleSayTeam")
	register_concmd("pbr_version", "pbr_version")
	register_concmd("pbr_debugcmd", "pbr_debugcmd")
	register_event("DeathMsg", "hook_death", "a")
	register_event("ResetHUD","newRound","b")
	register_event("CurWeapon","curweapon","be","1=1")
	register_cvar("amx_admin_email", "admin@thisserver.com")
	register_cvar("amx_pbr_logging", "1")	//Log?
	register_cvar("amx_admin_listen", "1")	//Admins listen?
	register_cvar("amx_pbr_kickname", "1")  //kick & names?
	register_cvar("amx_pbr_voting","0")
	/* for voting */
	register_menucmd(register_menuid("Vote: "),(1<<0)|(1<<1),"vote_count")
	register_cvar("amx_vote_time","60")
	register_cvar("amx_vote_delay","60")
	register_cvar("amx_last_voting","0")
	set_cvar_float("amx_last_voting",0.0)
	/* */
	gmsgFade = get_user_msgid("ScreenFade")
	gmsgShake = get_user_msgid("ScreenShake")
	gmsgScoreInfo = get_user_msgid("ScoreInfo")
	gmsgScoreAttrib = get_user_msgid("ScoreAttrib")
	readMapFile()
	readAdminFile()
	readCmdLevels()
	readEntities()
	
	return PLUGIN_CONTINUE
}

public plugin_precache()
{
	lbolt = precache_model("sprites/lgtning.spr")
	cloud = precache_model("sprites/steam1.spr")
	white = precache_model("sprites/white.spr")
	bomb = precache_model("models/w_weaponbox.mdl")
	m_fireball = precache_model("sprites/zerogxplode.spr")
	fire = precache_model("sprites/xfireball3.spr")
	precache_sound("ambience/thunder_clap.wav")
	precache_sound("ambience/fallscream.wav")

	return PLUGIN_CONTINUE
}

public client_disconnect(id)
{
	LAST_PM[id] = 0
	GLOW_VARS[id][0] = 0
	GLOW_VARS[id][1] = 0
	GLOW_VARS[id][2] = 0
	IS_GAGGED[id] = 0
	IS_INVIS[id] = 0
	LISTEN[id] = 0
	LAST_COMMAND[id][0] = 0
	IS_USER_GRAVITY[id] = 0
	IS_USER_SPEED[id] = 0	
	DBUG[id] = 0
	TWIN[id] = 0
	TWIN_PHASE[id] = 0
	FILL_TARGET[id] = 0
	IS_BOMB[id] = 0
	return PLUGIN_CONTINUE
}

public client_connect(id)
{
	if (caccess(id, "n")) {
		LISTEN[id] = 1
	} else {
		LISTEN[id] = -1
	}
	LAST_PM[id] = 0
	GLOW_VARS[id][0] = 0
	GLOW_VARS[id][1] = 0
	GLOW_VARS[id][2] = 0
	IS_GAGGED[id] = 0
	IS_INVIS[id] = 0
	LAST_COMMAND[id][0] = 0
	IS_USER_GRAVITY[id] = 0
	IS_USER_SPEED[id] = 0
	DBUG[id] = 0
	TWIN[id] = 0
	TWIN_PHASE[id] = 0
	FILL_TARGET[id] = 0
	IS_BOMB[id] = 0
	new User[32]
	get_user_name(id, User, 31)
	if (cwrap(User, "&") && (get_cvar_num("amx_pbr_logging")==1)) {
		client_cmd(id, "echo Your name has an invalid character in it.;toggleconsole;disconnect")
	}
	
	return PLUGIN_CONTINUE
}

public client_infochanged(id) { 
	new oldname[33], newname[33] 
	get_user_name(id, oldname, 32) 
	get_user_info(id, "name", newname, 32) 
	if(equal(newname, oldname)) {
		return PLUGIN_CONTINUE
	} else {
		if (cwrap(newname, "&") && (get_cvar_num("amx_pbr_logging")==1)) {
			client_cmd(id, "echo Your name has an invalid character in it.;toggleconsole;disconnect")
		}
	}
	
	return PLUGIN_CONTINUE
}

/* End initial functions */

/* Begin parsing function */

bool:ParseSpeech(id, Speech[], recurs=0)
{
	new Target[MAX_NAME_LENGTH]	
	new Temp2[MAX_TEXT_LENGTH]	
	new Text[MAX_TEXT_LENGTH]
	new User[MAX_NAME_LENGTH]
	new Args[MAX_TEXT_LENGTH]
	new Temp[MAX_TEXT_LENGTH]
	new Cmd[MAX_TEXT_LENGTH]
	new Init[10]
	new TargetID = 0
	new iTeam = 0	
	new Dump = 0
	new x = 0, y = 0, z = 0	
	new tester = 0
	new dumper[3]
	new bool:retval = false		//true = suppress output ($# found or private)

	if (equali(Speech[0], "$", 1)) {
		if (caccess(id, d_level)) {
			//Break apart strings
			strbreak2(Speech, Temp, Temp2, MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
			copy(Init, 9, Temp)
			strbreak2(Temp2, Cmd, Temp, MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
			strbreak2(Temp, Target, Args, MAX_NAME_LENGTH, MAX_TEXT_LENGTH)
			
			//Bash-style exclamation mark to repeat last command
			if (cwrap(Init, "$!")) {
				ParseSpeech(id, LAST_COMMAND[id])
				retval = false		
			} else {
				copy(LAST_COMMAND[id], MAX_TEXT_LENGTH-1, Speech)
			}			
			//Basic target - even if the cmd isn't targeted.
			TargetID = cmd_target(id, Target, 0)
			
			//Now get special targets - /<code>
			if (equali(Target[0], "&", 1)) {	//Backtick
				format(Temp, MAX_TEXT_LENGTH-1, "%s", Target[1])
				TargetID = cmd_target(id, Temp, 0)
			} else if (equali(Target[0], "#", 1)) {
				TargetID =  get_user_index(Target[1])
			} else if (equali(Target[0], "?", 1)) {
				TargetID = findLastPlayer(id)
			} else if (equali(Target[0], "*", 1)) {
				get_user_aiming(id, TargetID, Dump)
			} else if (equali(Target[0], "@", 1)) {
				TargetID = id
			} else if (equali(Target[0], "!", 1)) {
				if (LAST_TARGET[id][0] == 0) {
					TargetID = LAST_TARGET[id][1]
				} else if (LAST_TARGET[id][0] == 1) {
					iTeam = LAST_TARGET[id][1]
				}
			} else if (equali(Target[0], "/@", 2) && caccess(id, a_level)) {
				iTeam = 10
			} else if (equali(Target[0], "/*", 2) && caccess(id, a_level)) {
				iTeam = 9
			} else if (equali(Target[0], "/", 1) && caccess(id, t_level)) {
				iTeam = strtonum(Target[1])
			}
			if (iTeam) {
				LAST_TARGET[id][0] = 1
				LAST_TARGET[id][1] = iTeam
			} else if (TargetID) {
				LAST_TARGET[id][0] = 0
				LAST_TARGET[id][1] = TargetID
			}
			Dump = 0
			
			if (DBUG[id]) {
				client_print(id, print_console, "PBR=> /s: .Target=%s .Cmd=%s .Args=%s", Target, Cmd, Args)
				client_print(id, print_console, "PBR=> /d: .TargetID=%d .id=%d .iTeam=%d", TargetID, id, iTeam)
			}
			
			//Now get cmd ids
			new cmd_flag[2], cid
			cid = cmdid(Cmd)
			if (cid) {
				copy(cmd_flag, 2, CMDS[cid])
			}
			
						
			////////////////////////////////
			////////////////////////////////
			//   Actual command parsing   //
			////////////////////////////////
			////////////////////////////////'
			/* How to write your own commands - stubs
			if (cwrap(Cmd, "COMMAND")) {
				//Example of non-targeted non-player
				if (caccess(id, "n")) {
					//numerical example
					Dump = strtonum(Args)	//Args
					stuff(Dump)
					//multiple args example
					strbreak2(Args, Arg1, Arg2, 50, 50)
					stuff(arg1, arg2)
				}
				//Example of targeted player
				if (can_do(id, TargetID, "n")) {
					Dump = strtonum(Args)
					stuff(TargetID, Dump)
				}
				//Example of fully targeted
				if (!iTeam) {
					if (can_do(id, TargetID, "n")) {
						Dump = strtonum(Args)
						stuff(TargetID, Dump)
					}
				} else {
					if (caccess(id, "n")) {
						Dump = strtonum(Args)
						CmdTeam(id, IDENT, iTeam, Dump) //See below
					}
				}
			}
			See CmdTeam(4) on how to add IDENT
			
			Then you need to see cmdrun, cmdid, to add command ids.
			*/
			if (equali(Cmd, "debug")) {
				if (DBUG[id]) {
					DBUG[id] = 0
				} else {
					DBUG[id] = 1
				}
				client_print(id, print_chat, "[PBR] DEBUGGING MODE: %d", DBUG[id])
			}
			if (equali(Cmd, "slap")) {	//Slap
				Dump = strtonum(Args)
				if (!Dump) {
					Dump = 5
				} else if (Dump == -1) {
					Dump = 0
				}
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag) && is_user_alive(TargetID)) {
						user_slap(TargetID, Dump)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						dumper[0] = Dump
						CmdTeam(id, 1, iTeam, dumper)
					}
				}
			}
			if (equali(Cmd, "slay")) {	//Slay without taking frags
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag) && is_user_alive(TargetID)) {
						slay(TargetID)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 2, iTeam)
					}
				}	
			}
			if (equali(Cmd, "strike")) {	//Slay without taking frags
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag) && is_user_alive(TargetID)) {
						fakeslay(TargetID)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 31, iTeam)
					}
				}	
			}			
			if (equali(Cmd, "kill")) {	//Slay with taking frags
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag) && is_user_alive(TargetID)) {
						strbreak2(Args, Temp, Temp2, MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
						fakeslay(TargetID)
						gen_kill(id, TargetID, Temp, strlen(Temp2))
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 2, iTeam, Args)
					}
				}
			}
			if (equali(Cmd, "euliah")) {
				if (!iTeam) {
					if (!TargetID) {
						TargetID = id
					}
					if (can_do(id, TargetID, cmd_flag)) {
						give(TargetID, "m4a1")
						give(TargetID, "m4a1")
						give(TargetID, "m4a1")
						give(TargetID, "m4a1")
						give(TargetID, "deagle")
						give(TargetID, "deagle")
						give(TargetID, "deagle")
						give(TargetID, "deagle")
						give(TargetID, "-assaultsuit")
						give(TargetID, "hegrenade")
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 34, iTeam)
					}
				}
			}
			if (equali(Cmd, "coke")) {
				if (!iTeam) {
					if (!TargetID) {
						TargetID = id
					}
					if (can_do(id, TargetID, cmd_flag)) {
						give(TargetID, "ak47")
						give(TargetID, "ak47")
						give(TargetID, "ak47")
						give(TargetID, "ak47")
						give(TargetID, "deagle")
						give(TargetID, "deagle")
						give(TargetID, "deagle")
						give(TargetID, "deagle")
						give(TargetID, "-assaultsuit")
						give(TargetID, "hegrenade")
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 34, iTeam)
					}
				}
			}
			if (equali(Cmd, "bail")) {
				if (!iTeam) {
					if (!TargetID) {
						TargetID = id
					}
					if (can_do(id, TargetID, cmd_flag)) {
						give(TargetID, "awp")
						give(TargetID, "awp")
						give(TargetID, "awp")
						give(TargetID, "awp")
						give(TargetID, "deagle")
						give(TargetID, "deagle")
						give(TargetID, "deagle")
						give(TargetID, "deagle")
						give(TargetID, "-assaultsuit")
						give(TargetID, "hegrenade")
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 34, iTeam)
					}
				}
			}
			if (equali(Cmd, "dan")) {
				if (!TargetID) {
					TargetID = id
				}
				if (can_do(id, TargetID, cmd_flag)) {
					dumper[0] = TargetID
					set_user_gravity(TargetID, 0.10)
					client_cmd(TargetID, "+jump; wait; wait; -jump")
					set_task(1.0, "timed_dan", 0, dumper, 2)
				}
			}
			if (equali(Cmd, "arise,")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag) && !is_user_alive(TargetID)) {
						new uid[2]
						uid[0] = TargetID
						engclient_cmd(TargetID, "spec_mode 3")
						client_cmd(TargetID, "spec_mode 3")
						set_task(0.75, "respawn", 0, uid, 2)
						get_user_name(TargetID, Text, MAX_TEXT_LENGTH-1)
						client_print(0, print_chat, "[PBR]: Player %s has arisen from the dead.  Amen.", Text)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 16, iTeam)
						if (iTeam != 9) {
							client_print(0, print_chat, "[PBR]: Team %d has arisen from the dead.  Amen.", iTeam)
						} else {
							client_print(0, print_chat, "[PBR]: Everyone has arisen from the dead.  Amen.")
						}
					}
				}
			}
			if (equali(Cmd, "raise")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag) && !is_user_alive(TargetID)) {
						new uid[2]
						uid[0] = TargetID
						engclient_cmd(TargetID, "spec_mode 3")
						client_cmd(TargetID, "spec_mode 3")
						set_task(0.75, "respawn", 0, uid, 2)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 16, iTeam)
					}
				}
			}
			if (equali(Cmd, "invis")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						x = GLOW_VARS[TargetID][0]
						y = GLOW_VARS[TargetID][1]
						z = GLOW_VARS[TargetID][2]
						if (x || y || z) {
							glow(TargetID, x, y, z, 1)
						} else {
							glow(TargetID, 0, 0, 0, 1)
						}
					}
				} else {
					if (caccess(id, cmd_flag)) {	//iceflame convinced me to add the new targets
						CmdTeam(id, 23, iTeam)	
					}
				}
			}
			if (equali(Cmd, "see")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						x = GLOW_VARS[TargetID][0]
						y = GLOW_VARS[TargetID][1]
						z = GLOW_VARS[TargetID][2]
						if (x || y || z) {
							glow(TargetID, x, y, z, 0)
						} else {
							glow(TargetID, 0, 0, 0, 0)
						}					
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 24, iTeam)
					}
				}
			}
			if (equali(Cmd, "glow")) {
				new bool:rand_flag = false
				new bool:safe_flag = false
				new sc
				strbreak2(Args,Temp,Temp2,MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
				if (cwrap(Temp, "r")) {
					rand_flag = true
				}
				if (is_color(Temp)) {
					sc = is_color(Temp) - 1
					safe_flag = true
				}
				x=strtonum(Temp)
				strbreak2(Temp2,Temp,Text,MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
				y=strtonum(Temp)
				strbreak2(Text,Temp,Temp2,MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
				z=strtonum(Temp)
				if (rand_flag) {
					x = random_num(0, 255)
					y = random_num(0, 255)
					z = random_num(0, 255)
				}
				if (safe_flag) {
					x = g_Values[sc][0]
					y = g_Values[sc][1]
					z = g_Values[sc][2]
				}	
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						glow(TargetID, x, y, z, IS_INVIS[TargetID])
					}
				} else {
					if (caccess(id, cmd_flag)) {
						dumper[0] = x
						dumper[1] = y
						dumper[2] = z
						if (rand_flag) {
							CmdTeam(id, 22, iTeam)
						} else {
							CmdTeam(id, 7, iTeam, dumper)
						}
					}
				}
			}
			if (equali(Cmd, "norm")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						glow(TargetID, 0, 0, 0)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						dumper[0] = 0
						dumper[1] = 0
						dumper[2] = 0
						CmdTeam(id, 8, iTeam, dumper)
					}
				}
			}
			if (equali(Cmd, "supergod")) {
				if (can_do(id, TargetID, cmd_flag)) {
					set_user_health(TargetID, 510)
					set_user_armor(TargetID, 255)
					glow(TargetID, random_num(0,255), random_num(0,255), random_num(0,255), 1)
					set_user_noclip(TargetID, 1)
				}
			}
			if (equali(Cmd, "deflate")) {
				if (can_do(id, TargetID, cmd_flag)) {
					glow(TargetID, 0, 0, 0, 0)
					set_user_noclip(TargetID, 0)
				}
			}
			if (equali(Cmd, "powerup")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						give(TargetID, "all")
						give(TargetID, "+all")
						give(TargetID, "+all")
						give(TargetID, "+all")
						set_user_health(id, 10239)
						if (strtonum(Args)) {
							glow(TargetID, random_num(0,255), random_num(0,255), random_num(0,255))
						}
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 20, iTeam, "all")
						CmdTeam(id, 20, iTeam, "+all")
						CmdTeam(id, 20, iTeam, "+all")
						CmdTeam(id, 20, iTeam, "+all")
						if (strtonum(Args)) {
							CmdTeam(id, 23, iTeam)
						}
						dumper[0] = 0
						dumper[1] = 10239
						CmdTeam(id, 11, iTeam, dumper)
						dumper[1] = 255
						CmdTeam(id, 12, iTeam, dumper)
					}
				}
			}
			if (equali(Cmd, "suddendeath")) {
				if (caccess(id, cmd_flag)) {
					new players[32], uid, i
					get_players(players, Dump)
					tester = strtonum(Target)
					for (i=0; i<Dump; i++) {
						uid = players[i]
						if (!tester) {
							tester = 1
						}
						set_user_health(uid, tester)
					}
					client_print(0, print_chat, "Sudden death!")
				}
			}
			if (equali(Cmd, "gag")) {
				if (can_do(id, TargetID, cmd_flag)) {
					IS_GAGGED[TargetID] = id
					client_print(TargetID, print_chat, "[PBR] An administrator has gagged you.")
				}
			}
			if (equali(Cmd, "ungag")) {
				if (can_do(id, TargetID, cmd_flag)) {
					IS_GAGGED[TargetID] = 0
					client_print(TargetID, print_chat, "[PBR] An administrator has ungagged you.")
				}
			}
			if (equali(Cmd, "map")) {
				if (caccess(id, cmd_flag)) {
					if (is_map_valid(Target)) {
						get_user_name(id, User, MAX_NAME_LENGTH)
						format(Text, MAX_TEXT_LENGTH-1, "[PBR]: %s changing map to %s", User, Target)
						client_print(0, print_chat, Text)
						server_cmd("changelevel %s", Target)
					} else {
						client_print(id, print_chat, "[PBR]: Map %s not found!", Target)
					}
				}
			}
			if (equali(Cmd, "setm")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						if (equali(Args[0], "+", 1)) {
							Dump = strtonum(Args[1]) + get_user_money(TargetID)
						} else if (equali(Args[0], "-", 1)) {
							Dump = get_user_money(TargetID) - strtonum(Args[1]) 
						} else {
							Dump = strtonum(Args)
						}
						set_user_money(id, Dump, 1)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						dumper[0] = 0
						if (equali(Args[0], "+", 1)) {
							dumper[0] = 1
							dumper[1] = strtonum(Args[1])
						} else if (equali(Args[0], "-", 1)) {
							dumper[0] = 1
							dumper[1] = strtonum(Args[1])
							dumper[2] = 1
						} else {
							dumper[1] = strtonum(Args)
						}
						
						CmdTeam(id, 14, iTeam, dumper)
					}
				}
			}
			if (equali(Cmd, "ban")) {
				if (can_do(id, TargetID, cmd_flag)) {
					strbreak2(Args, Temp, Temp2, MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
					if (is_digit(Temp)) {
						Dump = strtonum(Temp)
						if (Dump < 1 || !Dump) {
							Dump = 0
						}
						ban(TargetID, Dump, 0, Temp2)
					} else {
						Dump = 0
						ban(TargetID, Dump, 0, Args)
					}
				}
			}
			if (equali(Cmd, "addip")) {
				if (can_do(id, TargetID, cmd_flag)) {
					strbreak2(Args, Temp, Temp2, MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
					get_user_ip(TargetID, Text, MAX_TEXT_LENGTH)					
					if (is_digit(Temp[0])) {
						Dump = strtonum(Temp)
						if (Dump < 1 || !Dump) {
							Dump = 0
						}
						addip(Text, id, Dump, 0, Temp2)						
					} else {
						Dump = 0
						addip(Text, id, Dump, 0, Args)
					}
				}
			}
			if (equali(Cmd, "boot")) {
				if (can_do(id, TargetID, cmd_flag)) {
					kick(TargetID, Args, 1)
				}
			}
			if (equali(Cmd, "kick")) {
				if (can_do(id, TargetID, cmd_flag)) {
					kick(TargetID, Args)
				}
			}			
			if (equali(Cmd, "root")) {
				if (caccess(id, cmd_flag)) {
					format(Text, MAX_TEXT_LENGTH-1, "%s %s", Target, Args)
					server_cmd(Text)
				}
			}
			if (equali(Cmd, "god")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						set_user_godmode(TargetID, 1)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 3, iTeam)
					}
				}
			}
			if (equali(Cmd, "ungod")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						set_user_godmode(TargetID, 0)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 4, iTeam)
					}
				}
			}
			if (equali(Cmd, "clip")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						set_user_noclip(TargetID, 1)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 5, iTeam)
					}
				}
			}
			if (equali(Cmd, "stop")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						set_user_noclip(TargetID, 0)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 6, iTeam)
					}
				}
			}
			if (equali(Cmd, "amx")) {
				if (caccess(id, cmd_flag)) {
					format(Text, MAX_TEXT_LENGTH-1, "amx_%s %s", Target, Args)
					server_cmd(Text)
				}
				}
			if (equali(Cmd, "tsay")) {
				if (caccess(id, cmd_flag)) {
					if (!is_color(Target)) {
						format(Text, MAX_TEXT_LENGTH-1, "%s %s", Target, Args)
						tsay(Text, "white")
					} else {
						tsay(Args, Target)
					}
				}
			}
			if (equali(Cmd, "csay")) {
				if (caccess(id, cmd_flag)) {
					if (!is_color(Target)) {
						format(Text, MAX_TEXT_LENGTH-1, "%s %s", Target, Args)
						tsay(Text, "green", 0, 0, 0, 0)
					} else {
						tsay(Args, Target, 0, 0, 0, 0)
					}
				}
			}
			if (equali(Cmd, "ssay")) {
				if (caccess(id, cmd_flag)) {
					client_print(0, print_chat, "%s %s", Target, Args)
				}
			}
			if (equali(Cmd, "tsayc")) {
				if (caccess(id, cmd_flag)) {
					new bool:rand_flag = false
					x=strtonum(Target)					
					strbreak2(Args,Temp,Temp2,MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
					if (cwrap(Temp, "r")) {
						rand_flag = true
					}
					strbreak2(Temp2,Temp,Text,MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
					z=strtonum(Temp)
					if (rand_flag) {
						x = random_num(0, 255)
						y = random_num(0, 255)
						z = random_num(0, 255)
					}
					tsay(Text, "", x, y, z)
				}
			}
			if (equali(Cmd, "csayc")) {
				if (caccess(id, cmd_flag)) {
					new bool:rand_flag = false
					x=strtonum(Target)					
					strbreak2(Args,Temp,Temp2,MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
					if (cwrap(Temp, "r")) {
						rand_flag = true
					}
					strbreak2(Temp2,Temp,Text,MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
					z=strtonum(Temp)
					if (rand_flag) {
						x = random_num(0, 255)
						y = random_num(0, 255)
						z = random_num(0, 255)
					}
					tsay(Text, "", x, y, z, 0)
				}
			}
			if (equali(Cmd, "name")) {
				if (can_do(id, TargetID, cmd_flag)) {
					client_cmd(TargetID, "name ^"%s^"", Args)
				}
			}
			if (equali(Cmd, "make")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						if (DBUG[id]) {
							client_print(id, print_console, "PBR.ParseSpeech.make=>[%s]", Args)
						}
						client_cmd(TargetID, Args)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 17, iTeam, Args)
					}
				}
			}
			if (equali(Cmd, "ctrl")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						format(Text, MAX_TEXT_LENGTH-1, "+%s; wait; -%s", Args, Args)
						client_cmd(TargetID, Text)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 25, iTeam, Args)
					}
				}
			}
			if (equali(Cmd, "unmute")) {
				if (can_do(id, TargetID, cmd_flag)) {
					client_cmd(TargetID, "voice_enable 1")
					client_print(TargetID, print_chat, "[PBR] Your mic has been re-enabled.  Restart CS to apply changes.")
				}
			}
			if (equali(Cmd, "mute")) {
				if (can_do(id, TargetID, cmd_flag)) {
					client_cmd(TargetID, "voice_enable 0")
					client_print(TargetID, print_chat, "[PBR] Your mic has been disabled by an administrator.")
				}
			}
			if (equali(Cmd, "psay")) {
				if (!iTeam) {
					if (TargetID) {
						get_user_name(id, User, MAX_NAME_LENGTH-1)
						client_print(TargetID, print_chat, "[PBR] (PM From %s): %s", User, Args)
						get_user_name(TargetID, User, MAX_NAME_LENGTH-1)
						client_print(id, print_chat, "[PBR] (PM to %s): %s", User, Args)
						LAST_PM[TargetID] = id
					} else {
						client_print(id, print_chat, "[PBR] PM Failed, user %s not found.", Target)
					}
				} else {
					CmdTeam(id, 18, iTeam, Args)
					client_print(id, print_chat, "[PBR] Team message sent to team code %d.", iTeam)
				}
				
				retval = true
			}
			if (equali(Cmd, "seth")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						if (equali(Args[0], "+", 1)) {
							Dump = strtonum(Args[1]) + get_user_health(TargetID)
						} else if (equali(Args[0], "-", 1)) {
							Dump = get_user_health(TargetID) - strtonum(Args[1])
						} else {
							Dump = strtonum(Args)
						}
						set_user_health(TargetID, Dump)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						dumper[0] = 0
						if (equali(Args[0], "+", 1)) {
							dumper[0] = 1
							dumper[1] = strtonum(Args)
						} else if (equali(Args[0], "-", 1)) {
							dumper[0] = 1
							dumper[1] = strtonum(Args[1])
							dumper[2] = 1
						} else {
							dumper[1] = strtonum(Args)
						}
						
						CmdTeam(id, 11, iTeam, dumper)
					}
				}
			}
			if (equali(Cmd, "seta")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						if (equali(Args[0], "+", 1)) {
							Dump = strtonum(Args[1]) + get_user_armor(TargetID)
						} else if (equali(Args[0], "-", 1)) {
							Dump = get_user_armor(TargetID) - strtonum(Args[1])
						} else {
							Dump = strtonum(Args)
						}
						set_user_armor(TargetID, Dump)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						dumper[0] = 0
						if (equali(Args[0], "+", 1)) {
							dumper[0] = 1
							dumper[1] = strtonum(Args[1])
						} else if (equali(Args[0], "-", 1)) {
							dumper[0] = 1
							dumper[1] = strtonum(Args[1])
							dumper[2] = 1
						} else {
							dumper[1] = strtonum(Args)
						}
						
						CmdTeam(id, 12, iTeam, dumper)
					}
				}
			}
			if (equali(Cmd, "reply")) {
				if (!LAST_PM[id]) {
					client_print(id, print_chat, "[PBR]: PM Failed, no one to reply to.")
				} else {
					get_user_name(id, User, MAX_NAME_LENGTH-1)
					client_print(LAST_PM[id], print_chat, "[PBR] (PM Reply from %s): %s %s", User, Target, Args)
					get_user_name(LAST_PM[id], User, MAX_NAME_LENGTH-1)
					client_print(id, print_chat, "[PBR] (PM Reply to %s): %s %s", User, Target, Args)
					LAST_PM[LAST_PM[id]] = id
				}
				retval = true
			}
			if (equali(Cmd, "speak")) {
				if (caccess(id, cmd_flag)) {
					format(Text, MAX_TEXT_LENGTH-1, "spk ^"%s %s^"", Target, Args)
					CmdTeam(id, 19, 9, Text)
				}
			}
			if (equali(Cmd, "verify")) {
				get_user_name(id, User, MAX_NAME_LENGTH-1)
				if (caccess(id, cmd_flag)) {
					client_print(0, print_chat, "[PBR] %s is, in fact, a root administrator.", User)
				} else {
					client_print(0, print_chat, "[PBR] %s is, indeed, an administrator.", User)
				}
			}
			if (equali(Cmd, "test")) {
				get_flags(get_user_flags(id), Temp, MAX_TEXT_LENGTH-1)
				client_print(id, print_chat, "[PBR] Test succeeded.  Flags: ^"%s^"", Temp)
			}
			if (equali(Cmd, "time")) {
				get_time("%m/%d/%Y - %H:%M:%S", Temp, MAX_TEXT_LENGTH-1)
				client_print(0, print_chat, "[PBR] Current time: %s", Temp)
			}
			if (equali(Cmd, "level")) {
				get_user_name(TargetID, User, MAX_NAME_LENGTH-1)
				get_flags(get_user_flags(TargetID), Temp, MAX_TEXT_LENGTH-1)
				if (!TargetID) {
					client_print(id, print_chat, "[PBR] User does not exist.")
				} else {
					if (check_target(TargetID, id)) {
						client_print(id, print_chat, "[PBR] User %s has flags ^"%s^" and can target you.", User, Temp)
					} else {
						client_print(id, print_chat, "[PBR] User %s has flags ^"%s^" and cannot target you.", User, Temp)
					}
				}
			}
			if (equali(Cmd, "cvar")) {
				Dump = strtonum(Args)
				new sid
				if (Dump) {
					sid = 0
				} else {
					sid = id
				}				
				if (cvar_exists(Target)) {
					if (cwrap(Target, "pass") && !caccess(id, cmd_flag)) {
						client_print(id, print_chat, "[PBR] You cannot retrieve this cvar value.")
						retval = true
					}
					if (cwrap(Target, "pass")) {
						sid = id
					}
					get_cvar_string(Target, Text, MAX_TEXT_LENGTH-1)
					client_print(sid, print_chat, "[PBR]: CVAR %s has value ^"%s^".", Target, Text)
				} else {
					client_print(sid, print_chat, "[PBR]: CVAR %s is not registered or does not exist.", Target)
				}
			}
			if (equali(Cmd, "info")) {
				if (can_do(id, TargetID, cmd_flag)) {
					get_user_name(TargetID, User, MAX_NAME_LENGTH-1)
					get_user_authid(TargetID, Temp, MAX_TEXT_LENGTH-1)
					get_user_ip(TargetID, Temp2, MAX_TEXT_LENGTH-1)
					x = get_user_health(TargetID)
					y = get_user_armor(TargetID)
					get_user_origin(TargetID, dumper)
					client_print(id, print_chat, "[PBR]: Name ^"%s^"/%s/%s, (%d/%d), (%d,%d,%d)", User, Temp2, Temp, x, y, dumper[0], dumper[1], dumper[2])
				}
			}
			if (equali(Cmd, "stat")) {
				if (can_do(id, TargetID, cmd_flag)) {
					get_user_name(TargetID, User, MAX_NAME_LENGTH-1)
					get_user_authid(TargetID, Temp, MAX_TEXT_LENGTH-1)
					get_user_ip(TargetID, Temp2, MAX_TEXT_LENGTH-1)
					x = get_user_health(TargetID)
					y = get_user_armor(TargetID)
					get_user_origin(TargetID, dumper)
					client_print(0, print_chat, "[PBR]: Name ^"%s^"/%s/%s, (%d/%d), (%d,%d,%d)", User, Temp2, Temp, x, y, dumper[0], dumper[1], dumper[2])
				}				
			}
			if (equali(Cmd, "give")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						give(TargetID, Args)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 20, iTeam, Args)
					}
				}
			}
			if (equali(Cmd, "defnode")) {
				if (caccess(id, cmd_flag)) {
					if (strlen(Target)>0) {
						if (MV_ENABLED == 0) {
							MV_ENABLED = 1
						}
						if (MV_TARGCNT < MAX_TARGETS-1) {
							get_user_origin(id, dumper)
							x = dumper[0]
							y = dumper[1]
							z = dumper[2]
							format(Text, MAX_TEXT_LENGTH-1, "%s %d %d %d", Target, x, y, z)
							Dump = strtonum(Args)
							if (Dump > 0) {
								z+=Dump
							}
							write_file(mapFile, Text, MV_TARGCNT)
							copy(MV_TARGETS[MV_TARGCNT], MAX_INFO_LENGTH-1, Target)
							MV_XCOORDS[MV_TARGCNT] = x
							MV_YCOORDS[MV_TARGCNT] = y
							MV_ZCOORDS[MV_TARGCNT] = z
							MV_TARGCNT++						
							client_print(id, print_chat, "[PBR] Map node %s added.", Target)
						} else {
							client_print(id, print_chat, "[PBR] Sorry, you have reached the node limit.")
						}
					} else {
						client_print(id, print_chat, "[PBR] Not a valid node.")
					}
				}
			}
			if (equali(Cmd, "relnode")) {
				if (caccess(id, cmd_flag)) {
					/* rXt | rufio helped me beta test this */
					Dump = 0
					if (strlen(Target)<1) {
						client_print(id, print_chat, "[PBR]: Not a valid node.")
					} else {
						delete_file(mapFile)
						for (new i=0; i<MV_TARGCNT; i++) {
							if (cwrap(MV_TARGETS[i], Target)) {
								//Match! do not write.  Flag for deletion.
								copy(MV_TARGETS[i], MAX_INFO_LENGTH, "DUMPED!")
							} else {
								//Match! write.
								Dump++
								format(Text, MAX_TEXT_LENGTH, "%s %d %d %d", MV_TARGETS[i], MV_XCOORDS[i], MV_YCOORDS[i], MV_ZCOORDS[i])
								write_file(mapFile, Text, Dump)
							}
						}
						for (new i=0; i<MV_TARGCNT; i++) {
							if (cwrap(MV_TARGETS[i], "DUMPED!")) {
								copy(MV_TARGETS[i], MAX_INFO_LENGTH, MV_TARGETS[i+1])
								copy(MV_TARGETS[i+1], MAX_INFO_LENGTH, "DUMPED!")
								MV_XCOORDS[i] = MV_XCOORDS[i+1]
								MV_YCOORDS[i] = MV_YCOORDS[i+1]
								MV_ZCOORDS[i] = MV_ZCOORDS[i+1]
							}
						}
						if (MV_TARGCNT+1 != Dump) {
							client_print(id, print_chat, "[PBR]: Node ^"%s^" has been released.", Target)
						} else {
							client_print(id, print_chat, "[PBR]: Node ^"%s^" not found.", Target)
						}					
						MV_TARGCNT = Dump - 1
						if (Dump < 1) {
							MV_ENABLED = 0
						}
					}
				}
			}
			if (equali(Cmd, "move")) {
				if (caccess(id, cmd_flag)) {
					if (!MV_ENABLED) {
						client_print(id, print_chat, "[PBR]: Sorry! No nodes are defined for this map.")
					} else {
						if (!MoveTarget(id, Target)) {
							client_print(id, print_chat, "[PBR]: Node %s not found.", Target)
						} else {
							client_print(id, print_chat, "[PBR]: Jumped to node %s.", Target)
						}
					}
				}
			}
			if (equali(Cmd, "send")) {
				if (can_do(id, TargetID, cmd_flag)) {
					if (!MV_ENABLED) {
						client_print(id, print_chat, "[PBR]: Sorry! No nodes are defined for this map.")
					} else {
						if (!MoveTarget(TargetID, Args)) {
							client_print(id, print_chat, "[PBR]: Node %s not found.", Target)
						} else {
							get_user_name(TargetID, User, MAX_NAME_LENGTH-1)
							client_print(id, print_chat, "[PBR]: Jumped %s to node %s.", User, Args)
						}
					}
				}
			}
			if (equali(Cmd, "near")) {
				if (caccess(id, cmd_flag)) {
					new pevvec[3]
					new vicvec[3]
					new marker
					new last = 99999
					new cur
					
					get_user_origin(id, pevvec)
					new players[32]
					new mPlayers
					get_players(players, mPlayers)
					new iteam, oteam
					iteam = get_user_team(id)
					for (new i=0; i<=mPlayers; i++) {
						oteam = get_user_team(players[i])
						if (is_user_alive(players[i]) && (oteam != iteam)) {
							get_user_origin(players[i], vicvec)
							cur = get_distance(pevvec, vicvec)
							if (cur<last) {
								last = cur
								marker = players[i]
							}
						}
					}
					cur = get_distance(pevvec, vicvec)
					new uid = marker
					if (uid) {
						LAST_TARGET[id][0] = 0
						LAST_TARGET[id][1] = uid
						get_user_name(uid, User, MAX_NAME_LENGTH-1)
						client_print(id, print_chat, "[PBR]: Closest enemy to you is %s.", User)
					} else {
						client_print(id, print_chat, "[PBR]: Failed to find an enemy.")
					}
					//now trace the player
					last = 99999
					if (MV_ENABLED && uid) {
						get_user_origin(uid, vicvec)
						new nodevec[3]
						for (new i=0; i<MV_TARGCNT; i++) {
							nodevec[0] = MV_XCOORDS[i]
							nodevec[1] = MV_YCOORDS[i]
							nodevec[2] = MV_ZCOORDS[i]
							cur = get_distance(nodevec, vicvec)
							if (cur<last) {
								last = cur
								marker = i
							}
						}
						get_user_origin(id, pevvec)
						cur = get_distance(pevvec, vicvec)
						if (last<cur) {
							client_print(id, print_chat, "[PBR]: Traced %s to closest node %s.", User, MV_TARGETS[marker])
						} else if (cur < last) {
							client_print(id, print_chat, "[PBR]: You are closer to %s than any node.", User)
						} else {
							client_print(id, print_chat, "[PBR]: You and local node %s are equidistant to player %s.", MV_TARGETS[marker], User)
						}
					}
				}
			}
			if (equali(Cmd, "hop")) {
				if (caccess(id, cmd_flag)) {
					new pevvec[3]
					new vicvec[3]
					new marker
					new last = 99999
					new cur
					
					get_user_origin(id, pevvec)
					new players[32]
					new mPlayers
					get_players(players, mPlayers)
					new iteam, oteam
					iteam = get_user_team(id)
					for (new i=0; i<=mPlayers; i++) {
						oteam = get_user_team(players[i])
						if (is_user_alive(players[i]) && (oteam != iteam)) {
							get_user_origin(players[i], vicvec)
							cur = get_distance(pevvec, vicvec)
							if (cur<last) {
								last = cur
								marker = players[i]
							}
						}
					}
					cur = get_distance(pevvec, vicvec)
					new uid = marker
					if (uid) {
						LAST_TARGET[id][0] = 0
						LAST_TARGET[id][1] = uid						
						get_user_name(uid, User, MAX_NAME_LENGTH-1)
						client_print(id, print_chat, "[PBR]: Closest enemy to you is %s.", User)
					} else {
						client_print(id, print_chat, "[PBR]: Failed to find an enemy.")
					}
					//now trace the player
					last = 99999
					if (MV_ENABLED && uid) {
						get_user_origin(uid, vicvec)
						new nodevec[3]
						for (new i=0; i<MV_TARGCNT; i++) {
							nodevec[0] = MV_XCOORDS[i]
							nodevec[1] = MV_YCOORDS[i]
							nodevec[2] = MV_ZCOORDS[i]
							cur = get_distance(nodevec, vicvec)
							if (cur<last) {
								last = cur
								marker = i
							}
						}
						get_user_origin(id, pevvec)
						cur = get_distance(pevvec, vicvec)
						if (last<cur) {
							nodevec[0] = MV_XCOORDS[marker]
							nodevec[1] = MV_YCOORDS[marker]
							nodevec[2] = MV_ZCOORDS[marker]
							set_user_origin(id, nodevec)
							client_print(id, print_chat, "[PBR]: Hopping you to %s to closest node %s.", User, MV_TARGETS[marker])
						} else if (cur < last) {
							client_print(id, print_chat, "[PBR]: You are closer to %s than any node.", User)
						} else {
							client_print(id, print_chat, "[PBR]: You and local node %s are equidistant to player %s.", MV_TARGETS[marker], User)
						}
					} else {
						client_print(id, print_chat, "[PBR]: Couldn't hop, no nodes are defined or no user found.")
					}
				}
			}					
			if (equali(Cmd, "trace")) {
				if (can_do(id, TargetID, cmd_flag)) {
					if (!MV_ENABLED) {
						client_print(id, print_chat, "[PBR]: Map nodes not defined!", print_chat)
					} else {
						new nodevec[3]
						new vicvec[3]	// I couldn't resist this name
						new marker
						new last = 99999
						new cur
						
						get_user_origin(TargetID, vicvec)
						for (new i=0; i<MV_TARGCNT; i++) {
							nodevec[0] = MV_XCOORDS[i]
							nodevec[1] = MV_YCOORDS[i]
							nodevec[2] = MV_ZCOORDS[i]
							cur = get_distance(nodevec, vicvec)
							if (cur<last) {
								last = cur
								marker = i
							}
						}
						new pevvec[3]
						get_user_origin(id, pevvec)
						cur = get_distance(pevvec, vicvec)
						if (last < cur) {
							get_user_name(TargetID, User, MAX_NAME_LENGTH-1)
							client_print(id, print_chat, "[PBR]: Traced %s to closest node %s.", User, MV_TARGETS[marker])
						} else if (cur < last) {
							get_user_name(TargetID, User, MAX_NAME_LENGTH-1)
							client_print(id, print_chat, "[PBR]: You are closer to %s than any node.", User)
						} else {
							get_user_name(TargetID, User, MAX_NAME_LENGTH-1)
							client_print(id, print_chat, "[PBR]: You and local node %s are equidistant to %s.", MV_TARGETS[marker], User)
						}
					}
				}
			}
			if (equali(Cmd, "jump")) {
				if (can_do(id, TargetID, cmd_flag)) {
					if (!MV_ENABLED) {
						client_print(id, print_chat, "[PBR]: Map nodes not defined!", print_chat)
					} else {
						new nodevec[3]
						new vicvec[3]	// I couldn't resist this name
						new marker
						new last = 99999
						new cur
						
						get_user_origin(TargetID, vicvec)
						for (new i=0; i<MV_TARGCNT; i++) {
							nodevec[0] = MV_XCOORDS[i]
							nodevec[1] = MV_YCOORDS[i]
							nodevec[2] = MV_ZCOORDS[i]
							cur = get_distance(nodevec, vicvec)
							if (cur<last) {
								last = cur
								marker = i
							}
						}
						new pevvec[3]
						get_user_origin(id, pevvec)
						cur = get_distance(pevvec, vicvec)
						if (last < cur) {
							nodevec[0] = MV_XCOORDS[marker]
							nodevec[1] = MV_YCOORDS[marker]
							nodevec[2] = MV_ZCOORDS[marker]
							set_user_origin(id, nodevec)
							client_print(id, print_chat, "[PBR]: Jumping you to node %s.", MV_TARGETS[marker])						
						} else if (cur < last) {
							get_user_name(TargetID, User, MAX_NAME_LENGTH-1)
							client_print(id, print_chat, "[PBR]: You are closer to %s than any node.", User)
						} else {
							get_user_name(TargetID, User, MAX_NAME_LENGTH-1)
							client_print(id, print_chat, "[PBR]: You and local node %s are equidistant to %s.", MV_TARGETS[marker], User)
						}
					}
				}
			}
			if (equali(Cmd, "flash")) {
				new bool:rand_flag = false
				new bool:safe_flag = false
				new sc
				strbreak2(Args,Temp,Temp2,MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
				if (cwrap(Temp, "r")) {
					rand_flag = true
				}
				if (is_color(Temp)) {
					sc = is_color(Temp) - 1
					safe_flag = true
				}
				dumper[0]=strtonum(Temp)
				strbreak2(Temp2,Temp,Text,MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
				dumper[1]=strtonum(Temp)
				strbreak2(Text,Temp,Temp2,MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
				dumper[2]=strtonum(Temp)
				if (rand_flag) {
					dumper[0] = random_num(0, 255)
					dumper[1] = random_num(0, 255)
					dumper[2] = random_num(0, 255)
				}
				if (safe_flag) {
					dumper[0] = g_Values[sc][0]
					dumper[1] = g_Values[sc][1]
					dumper[2] = g_Values[sc][2]
				}
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						flash(TargetID, dumper)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						if (!rand_flag) {
							CmdTeam(id, 21, iTeam, dumper)
						} else {
							CmdTeam(id, 32, iTeam)
						}
					}
				}
			}
			if (equali(Cmd, "vote")) {
				if (caccess(id, cmd_flag)) {
					format(Text, MAX_TEXT_LENGTH-1, "%s %s", Target, Args)
					voteYesNo(id, Text)
				}
			}
			if (equali(Cmd, "cancel")) {
				if (caccess(id, cmd_flag)) {
					STOP_VOTE = true
					set_cvar_float("amx_last_voting", 0.0)
					client_print(0, print_chat, "[PBR] Vote canceled.")
				}
			}
			if (equali(Cmd, "nodecount")) {
				client_print(id, print_chat, "[PBR]: This map has %d nodes defined.", MV_TARGCNT+1)
			}
			if (equali(Cmd, "version")) {
				client_print(0, print_chat, "[PBR]: %s by %s.  Version %s, build %s", PLUGINNAME, AUTHOR, VERSION, BUILD_VERSION)
				client_print(0, print_chat, "[PBR]: Visit http://lambda.tcwonline.org/ for more information.")
			}
			if (equali(Cmd, "listen")) {
				if (can_do(id, TargetID, cmd_flag)) {
					Dump = strtonum(Args)
					if (Dump) {
						LISTEN[TargetID] = 1
					} else {
						LISTEN[TargetID] = 0
					}
				}
			}
			if (equali(Cmd, "admin")) {
				if (can_do(id, TargetID, cmd_flag)) {
					Dump = read_flags(Args)
					set_user_flags(TargetID, Dump)
					get_user_name(TargetID, User, MAX_NAME_LENGTH-1)
					client_print(id, print_chat, "[PBR] User %s now has flags ^"%s^".", User, Args)
					get_user_name(id, User, MAX_NAME_LENGTH-1)
					client_print(TargetID, print_chat, "[PBR] User %s has given you admin flags ^"%s^" temporarily.", User, Args)
				}
			}
			if (equali(Cmd, "demote")) {
				if (can_do(id, TargetID, cmd_flag)) {
					remove_user_flags(TargetID, -1)
					get_user_name(TargetID, User, MAX_NAME_LENGTH-1)
					client_print(id, print_chat, "[PBR] User %s is no longer an admin.", User)
					get_user_name(id, User, MAX_NAME_LENGTH-1)
					client_print(TargetID, print_chat, "[PBR] %s has taken your admin flags away.", User)
				}
			}
			if (equali(Cmd, "write")) {
				if (can_do(id, TargetID, cmd_flag)) {
					new SteamID[32]
					new flags[26]
					get_user_authid(TargetID, SteamID, 31)
					if (equali(Args[0], "*", 1)) {
						copy(flags, 25, "abcdefghijklmnopqrstuz")
					} else {
						copy(flags, 25, Args)
					}	
					format(Text, MAX_TEXT_LENGTH, "^"%s^" ^"^" ^"%s^" ^"ce^"", SteamID, flags)
					write_file(usersFile, Text, -1)
					client_print(id, print_chat, "[PBR] AuthID %s now has flags ^"%s^" in your users.ini.", SteamID, flags)
					client_print(TargetID, print_chat, "[PBR] You now have flags ^"%s^" set permanently.", flags)
				}
			}
			if (equali(Cmd, "auth")) {
				new i
				Dump = 0
				for (i=0; i<AUTH_NUM; i++) {
					if (equali(Target, AUTH_USERS[i])) {
						Dump = 1
						if (equali(Args, AUTH_PASS[i])) {
							Dump = 2
							new flag_num
							flag_num = read_flags(AUTH_FLAGS[i])
							set_user_flags(id, flag_num)
							x = i
						}
					}
				}
				if (!Dump) {
					client_print(id, print_chat, "[PBR] Username not found!")
				} else if (Dump == 1) {
					client_print(id, print_chat, "[PBR] Password incorrect.")
				} else if (Dump == 2) {
					client_print(id, print_chat, "[PBR] You have been authenticated with flags %s.", AUTH_FLAGS[x])
					LISTEN[id] = 1
				}
				retval = true
			}
			if (equali(Cmd, "setf")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						if (equali(Args[0], "+", 1)) {
							Dump = strtonum(Args[1]) + get_user_frags(TargetID)
						} else if (equali(Args[0], "-", 1)) {
							Dump = get_user_frags(TargetID) - strtonum(Args[1])
						} else {
							Dump = strtonum(Args)
						}	
						set_user_frags(TargetID, Dump)
						message_begin(MSG_ALL, gmsgScoreInfo)
						write_byte(TargetID)  
						write_short(Dump)
						write_short(get_user_deaths(TargetID))
						write_short(0) 
						write_short(get_user_team(TargetID))
						message_end()
					}
				} else {
					if (caccess(id, cmd_flag)) {
						dumper[0] = 0
						if (equali(Args[0], "+", 1)) {
							dumper[0] = 1
							dumper[1] = strtonum(Args[1])
						} else if (equali(Args[0], "-", 1)) {
							dumper[0] = 1
							dumper[1] = strtonum(Args[1])
							dumper[2] = 1
						} else {
							dumper[1] = strtonum(Args)
						}
						
						CmdTeam(id, 26, iTeam, dumper)
					}
				}
			}
			if (equali(Cmd, "setg")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						if (equali(Args[0], "+", 1)) {
							fGrav = floatstr(Args[1])/800.0 + get_user_gravity(TargetID)
						} else if (equali(Args[0], "-", 1)) {
							fGrav = get_user_gravity(TargetID) - floatstr(Args[1])/800.0
						} else {
							fGrav = floatstr(Args)/800.0
						}
						if (!fGrav) {
							fGrav = 1.0
							IS_USER_GRAVITY[TargetID] = 0
						} else {
							IS_USER_GRAVITY[TargetID] = 1
							USER_GRAVITY[TargetID] = fGrav
						}
						set_user_gravity(TargetID, fGrav)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						if (equali(Args[0], "+", 1)) {
							dumper[0] = 1
						} else if (equali(Args[0], "-", 1)) {
							dumper[0] = 1
							dumper[2] = 1
						}
							
						fGrav = floatstr(Args)/800.0
						CmdTeam(id, 27, iTeam, dumper)
					}
				}
			}
			if (equali(Cmd, "speed")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						fSpeed = floatstr(Args)
						if (floatround(fSpeed) == 0 || !fSpeed) {
							set_user_maxspeed(TargetID, 900.0)
							IS_USER_SPEED[TargetID] = 0
						} else {
							set_user_maxspeed(TargetID, fSpeed)
							IS_USER_SPEED[TargetID] = 1
							USER_SPEEDS[TargetID] = fSpeed
						}
					}
				} else {
					if (caccess(id, cmd_flag)) {
						fSpeed = floatstr(Args)
						CmdTeam(id, 28, iTeam)
					}
				}
			}
			if (equali(Cmd, "twin")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						Dump = random_num(1337, 80220)	//Please don't collide!
						dumper[0] = TargetID
						TWIN[TargetID] = Dump
						client_print(TargetID, print_chat, "[PBR] You are now a twin!")
						client_print(TargetID, print_chat, "[PBR] Every few seconds you will phase in and out of invincible ghost mode.")
						set_task(2.5, "toggle_twin", Dump, dumper, 2, "b")
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 29, iTeam)
					}
				}
			}
			if (equali(Cmd, "untwin")) {
				if (!iTeam) {
					if (can_do(id, TargetID, cmd_flag)) {
						unset_twin(TargetID)
					}
				} else {
					if (caccess(id, cmd_flag)) {
						CmdTeam(id, 30, iTeam)
					}
				}
			}
			if (equali(Cmd, "fill")) {
				if (can_do(id, TargetID, cmd_flag)) {
					Dump = random_num(80221, 133700)
					FILL_TARGET[TargetID] = Dump
					dumper[0] = TargetID
					set_task(0.5, "force_snapshot", Dump, dumper, 2, "a", 240)
				}
			}
			if (equali(Cmd, "cease")) {
				if (can_do(id, TargetID, cmd_flag)) {
					remove_task(FILL_TARGET[TargetID])
				}
			}
			if (equali(Cmd, "team")) {	// From AMXPTB by XAD
				if (can_do(id, TargetID, cmd_flag)) {
					Dump = strtonum(Args)
					user_kill(id,1)
					client_cmd(id,"chooseteam;menuselect %d;menuselect 5", Dump)
					client_cmd(id,"wait;wait;wait;wait;wait;wait;wait;wait;wait;wait;wait;wait;slot1")
				}
			}
			if (equali(Cmd, "teamcs")) { // From AMXPTB by XAD
				if (can_do(id, TargetID, cmd_flag)) {
					Dump = strtonum(Args)
					get_user_info(TargetID,"_vgui_menus",dumper,1)
					if (dumper[0] != '0') {
      					set_user_info(TargetID,"_vgui_menus","0")
      					new args[2]
      					args[0] = TargetID
      					if (Dump == 1) {
	      					args[1] = 0
      					} else if (Dump == 2) {
	      					args[1] = 1
      					}
      					set_task(0.01,"delay_team_switch",100+TargetID,args,2)
   					} else {
						user_kill(TargetID,1)
						if (Dump == 1) {
							engclient_cmd(TargetID,"jointeam", "1")
						} else if (Dump == 2) {
							engclient_cmd(TargetID,"jointeam", "2")
						} else if (Dump == 5) {
							engclient_cmd(TargetID,"jointeam", "5")
						}
						engclient_cmd(TargetID,"joinclass","5")
					} 					
				}
			}
			if (equali(Cmd, "bomb") || equali(Cmd, "kamikaze")) {
				if (can_do(id, TargetID, cmd_flag)) {
					if (is_user_alive(TargetID) || IS_BOMB[TargetID]) {
						Dump = strtonum(Args)
						if (!Dump) {
							Dump = 15
						}
						get_user_name(id, User, MAX_NAME_LENGTH)
						client_print(0, print_chat, "[PBR] %s is now a %d second time bomb!", User, Dump)
						message_begin(MSG_BROADCAST, SVC_TEMPENTITY, {0,0,0}, id)
						write_byte(124)
						write_byte(TargetID)
						write_coord(7)
						write_short(bomb)
						write_short(Dump*10 + 20)	//from ludwig van's kamikaze
						message_end()
						dumper[0] = TargetID
						IS_BOMB[TargetID] = Dump
						set_task(1.0, "bomb_blowup", random_num(314,15926), dumper, 2, "a", Dump)
					} else {
						client_print(id, print_chat, "[PBR] Oops! Player is dead or already a bomb.")
					}
				}
			}
			if (equali(Cmd, "stack")) {
				if (can_do(id, TargetID, cmd_flag)) {
					CmdTeam(id, 33, 9)
				}
			}
			//////////////////////////
			//////////////////////////
			// End command parsing  //
			//////////////////////////
			//////////////////////////
			if (cwrap(Init, "$#")) {
				retval = true
			}	//Don't assume automatic false retval!
			//Log the command! - 2.0 feature
			if ((get_cvar_num("amx_pbr_logging")==1)) {
				new team[8], authid[20]
				get_user_name(id, User, MAX_NAME_LENGTH)
				get_user_team(id, team, 7)
				get_user_authid(id, authid, 20)
				log_message("^"%s<%d><%s><%s>^" triggered ^"pbr_cmd^" (mode ^"%s^") (cmd ^"%s^") (targ ^"%s^") (arg ^"%s^")", User, get_user_userid(id), authid, team, Init, Cmd, Target, Args)
			}
			//Check for multiple commands
			if (cwrap(Speech, ">") && !recurs) {
				strsplit(">", Speech, Temp, Temp2, MAX_TEXT_LENGTH-1, MAX_TEXT_LENGTH-1)
				if (strlen(Temp2)>3) {
					ParseSpeech(id, Temp2, 1)
				}
			}
			//End all admin command parsing
		} else {
			if (cwrap(Speech, "$ auth")) {
				new i
				Dump = 0
				strbreak2(Speech, Temp, Temp2, MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
				strbreak2(Temp2, Cmd, Temp, MAX_TEXT_LENGTH, MAX_TEXT_LENGTH)
				strbreak2(Temp, Target, Args, MAX_NAME_LENGTH, MAX_TEXT_LENGTH)
				for (i=0; i<AUTH_NUM; i++) {
					if (equali(Target, AUTH_USERS[i])) {
						Dump = 1
						if (equali(Args, AUTH_PASS[i])) {
							Dump = 2
							new flag_num
							flag_num = read_flags(AUTH_FLAGS[i])
							set_user_flags(id, flag_num)
							x = i
						}
					}
				}
				if (!Dump) {
					client_print(id, print_chat, "[PBR] Username not found!")
				} else if (Dump == 1) {
					client_print(id, print_chat, "[PBR] Password incorrect.")
				} else if (Dump == 2) {
					client_print(id, print_chat, "[PBR] You have been authenticated with flags %s.", AUTH_FLAGS[x])
					LISTEN[id] = 1
				}
				retval = true
			}
			if (cwrap(Speech, "$ version")) {
				client_print(0, print_chat, "[PBR]: %s by %s.  Version %s, build %s", PLUGINNAME, AUTHOR, VERSION, BUILD_VERSION)
				client_print(0, print_chat, "Visit http://lambda.tcwonline.org/ for more information.")
			}
			if (cwrap(Speech, "$ time")) {
				get_time("%m/%d/%Y - %H:%M:%S", Temp, MAX_TEXT_LENGTH-1)
				client_print(0, print_chat, "[PBR] Current time: %s", Temp)
			}//End all public command parsing
		}//Ends access check 
	}//Ends speech check
	
	return retval
}//Ends ParseSpeech()

/* Begin handling functions */

public delay_team_switch(args[])
{
	new id = args[0]
	new iTeam = args[1]

	user_kill(id,1)
	engclient_cmd(id,"jointeam", ((iTeam) ? "2" : "1"))
	engclient_cmd(id,"joinclass","5")
	set_user_info(id,"_vgui_menus","1")
}

public pbr_version(id)
{
	server_print("[PBR]: %s by %s.  Version %s, build %s", PLUGINNAME, AUTHOR, VERSION, BUILD_VERSION)
	server_print("Visit http://lambda.tcwonline.org/ for more information.")
}

public pbr_debugcmd(id)
{
	new Target[32]
	read_argv(1, Target, 32)
	new f[3]
	new tid = cmdid(Target)
	copy(f, 3, CMDS[tid])
	server_print("[PBR] Command %s has id %d and level %s", Target, tid, f)
}

public force_snapshot(stuff[])
{
	new uid
	uid = stuff[0]
	if (FILL_TARGET[uid]) {
		client_cmd(uid, "snapshot; wait; wait; wait; snapshot")
	} else {
		remove_task(FILL_TARGET[uid])
		FILL_TARGET[uid] = 0
	}
}

public timed_dan(stuff[])
{
	new pOrigin[3], sOrigin[3]
	new vicvec[3]
	new players[32], mPlayers
	new id, TargetID, df, i
	new User[32]
	TargetID = stuff[0]
	get_user_name(TargetID, User, 32)
	get_user_origin(TargetID, pOrigin)
	sOrigin[0]=pOrigin[0]+150
	sOrigin[1]=pOrigin[1]+150
	sOrigin[2]=pOrigin[2]+400
	lightning(sOrigin, pOrigin)
	PlaySoundToAll("ambience/thunder_clap.wav")
	explode(pOrigin)
	blood(pOrigin)
	lots_of_blood(pOrigin, 3)
	fireball(pOrigin)
	user_kill(TargetID)
	set_user_gravity(TargetID, 1.0)
	//find all users within distance
	get_players(players, mPlayers)
	for (i=0; i<mPlayers; i++) {
		id = players[i]
		if ((id != TargetID) && is_user_alive(id)) {
			get_user_origin(id, vicvec)
			df = get_distance(pOrigin, vicvec)
			if (df <= 800) {
				set_user_health(id, get_user_health(id)+150)
				set_user_armor(id, get_user_armor(id)+150)
				give(id, "all")
			}
		}
	}
	client_print(0, print_chat, "[PBR] ^"%s^" showers presents upon the peoples.", User)
}

public bomb_blowup(stuff[])		//construction loosely based off ludwig van's code
{
	new uid, id
	new words[64]
	new players[32], mPlayers
	new pevvec[3], vicvec[3]
	new User[32]
	new df, i
	new kills
	uid = stuff[0]
	get_user_name(uid, User, 32)	
	if (is_user_alive(uid)) {
		if (IS_BOMB[uid]>1) {
			IS_BOMB[uid]--
			num_to_word(IS_BOMB[uid], words, 64)
			client_cmd(0, "spk ^"fvox/%s^"", words)
		} else if (IS_BOMB[uid] == 1) {
			IS_BOMB[uid] = 0
			get_players(players, mPlayers)
			get_user_origin(uid, pevvec)
			for (i=0; i<mPlayers; i++) {
				id = players[i]
				if ((id != uid) && is_user_alive(id)) {
					get_user_origin(id, vicvec)
					df = get_distance(pevvec, vicvec)
					if (df <= 800 && df > 450) {
						set_user_health(id, floatround(((250.0-float(df))/float(250))*float(get_user_health(id))))
						if (get_user_health(id)<1) {
							slay(id)
							if (get_user_team(id) == get_user_team(uid)) {
								kills--
							} else {
								kills++
							}
							client_print(id, print_chat, "[PBR] You have been blown up by ^"%s^", human timebomb!", User)
						} else {
							client_print(id, print_chat, "[PBR] You have been hurt by ^"%s^", human timebomb!", User)
						}
					} else if (df <= 450) {
						shake(id)
						slay(id)
						client_print(id, print_chat, "[PBR] You have been blown up by ^"%s^", human timebomb!", User)
						if (get_user_team(id) == get_user_team(uid)) {
							kills--
						} else {
							kills++
						}
					} else {
						shake(id)
					}
				}
			}
			new frags = get_user_frags(uid) + kills
			new deaths = get_user_deaths(uid)
			set_user_frags(uid, frags)
			//Frags!
			message_begin(MSG_ALL, gmsgScoreInfo)
			write_byte(uid)
			write_short(frags)
			write_short(deaths)
			write_short(0) 
			write_short(get_user_team(uid))
			message_end()			
			message_begin(MSG_ONE,gmsgFade,{0,0,0},id)
			write_short(1<<11) // fade lasts this long furation
			write_short(1<<11) // fade lasts this long hold time
			write_short(1<<12) // fade type (in / out)
			write_byte(250) // fade red
			write_byte(250) // fade green
			write_byte(250) // fade blue
			write_byte(255) // fade alpha
			message_end()	
			slay(uid)
		}
	} else {
		IS_BOMB[uid] = 0
	}
}

public toggle_twin(stuff[])
{
	new uid, d, x	
	uid = stuff[0]
	d = get_user_health(uid)
	
	if (is_user_alive(uid) && TWIN[uid]) {
		if (TWIN_PHASE[uid]) {
			//phase out
			glow(uid, 0, 0, 0, 0)
			if (d>=95 && d<=100) {
				x = 100 - d
			} else {
				x = 5
			}
			set_user_health(uid, d+x)
			set_user_godmode(uid, 0)
			client_print(uid, print_center, "You are in normal mode.")
		} else {
			//phase in
			glow(uid, 90, 90, 90, 1)
			set_user_godmode(uid, 1)
			client_print(uid, print_center, "You are in ghost mode.")
		}
		if (TWIN_PHASE[uid]) {
			TWIN_PHASE[uid] = 0
		} else {
			TWIN_PHASE[uid] = 1
		}
	} else {
		unset_twin(uid)
	}
}

public unset_twin(id)
{
	new temp[2]
	if (TWIN[id]) {
		remove_task(TWIN[id])
		TWIN_PHASE[id] = 0
		glow(id, 0, 0, 0, 0)
		temp[0] = id
		set_user_godmode(id, 0)
		TWIN[id] = 0
		client_print(id, print_chat, "[PBR] You are no longer a twin.")
	}
}

public curweapon(id)
{
	new Float:speed = USER_SPEEDS[id]
	if (IS_USER_SPEED[id]) {
		set_user_maxspeed(id, speed)
	}
}

public hook_death()
{
	new pk = read_data(1)
	new pv = read_data(2)
	new kills = 0
	new players[32], mPlayers
	new i=0, df=0, id
	new pevvec[3], vicvec[3]
	
	if (pk && pv) {
		if (IS_BOMB[pv]) {
			IS_BOMB[pv] = 0
			get_players(players, mPlayers)
			get_user_origin(pv, pevvec)
			for (i=0; i<mPlayers; i++) {
				id = players[i]
				if ((id != pv) && is_user_alive(id)) {
					get_user_origin(id, vicvec)
					df = get_distance(pevvec, vicvec)
					if (df <= 800 && df > 450) {
						set_user_health(id, floatround(((250.0-float(df))/float(250))*float(get_user_health(id))))
						if (get_user_health(id)<1) {
							if (get_user_team(id) == get_user_team(pv)) {
								kills--
							} else {
								kills++
							}
						}
					} else if (df <= 450) {
						shake(id)						
						slay(id)
						if (get_user_team(id) == get_user_team(pv)) {
							kills--
						} else {
							kills++
						}
					} else {
						shake(id)
					}
				}
			}
			new frags = get_user_frags(pv) + kills
			new deaths = get_user_deaths(pv)
			set_user_frags(pv, frags)
			//Frags!
			message_begin(MSG_ALL, gmsgScoreInfo)
			write_byte(pv)
			write_short(frags)
			write_short(deaths)
			write_short(0) 
			write_short(get_user_team(pv))
			message_end()	
			//Flash!		
			message_begin(MSG_ONE,gmsgFade,{0,0,0},id)
			write_short(1<<11) // fade lasts this long furation
			write_short(1<<11) // fade lasts this long hold time
			write_short(1<<12) // fade type (in / out)
			write_byte(250) // fade red
			write_byte(250) // fade green
			write_byte(250) // fade blue
			write_byte(255) // fade alpha
			message_end()	
			shake(pv)
			slay(pv)
		}
	}
	
	return PLUGIN_CONTINUE	
}

public newRound(id)
{

	new param[1]

	param[0] = id 
	set_task(0.1,"delayed_round_start",3000+id,param,1)
	
	return PLUGIN_CONTINUE
}

public HandleSay(id)
{
	new Speech[MAX_TEXT_LENGTH]
	new Text[MAX_TEXT_LENGTH]
	new bool:retval
	
	read_args(Text, MAX_TEXT_LENGTH-1)
	
	strstrip(Text, Speech, MAX_TEXT_LENGTH)
	
	retval = ParseSpeech(id, Speech)
	
	if (IS_GAGGED[id]) {
		client_print(id, print_chat, "[PBR]: An administrator has gagged you.")
		
		return PLUGIN_HANDLED
	}
	
	if (retval || IS_GAGGED[id]) {
		return PLUGIN_HANDLED
	} else {
		if ((get_cvar_num("amx_admin_listen")==1) && !equali(Text, "^"^"", 2)) {
			new mPlayers
			new players[32]
			new uid, i
			new User[MAX_NAME_LENGTH]
			get_players(players, mPlayers)
			get_user_name(id, User, MAX_NAME_LENGTH-1)
			for (i=0; i<mPlayers; i++) {
				uid = players[i]
				if (LISTEN[uid] == 1) {
					if (is_user_alive(id) && !is_user_alive(uid)) {
						client_print(uid, print_chat, "*ALIVE*%s: %s", User, Speech)
					} else if (!is_user_alive(id) && is_user_alive(uid)) {
						client_print(uid, print_chat, "*DEAD*:%s: %s", User, Speech)
					}
				} else {
					if (caccess(uid, "n") && LISTEN[uid] == -1) {
						LISTEN[uid] = 1
					}
				}
			}
		}
		return PLUGIN_CONTINUE
	}
		
	return PLUGIN_CONTINUE
}

public HandleSayTeam(id)
{
	new Speech[MAX_TEXT_LENGTH]
	new Text[MAX_TEXT_LENGTH]
	
	read_args(Text, MAX_TEXT_LENGTH-1)
	
	strstrip(Text, Speech, MAX_TEXT_LENGTH)	
	
	if (IS_GAGGED[id]) {
		client_print(id, print_chat, "[PBR]: An administrator has gagged you.")
		
		return PLUGIN_HANDLED
	}
	if ((get_cvar_num("amx_admin_listen")==1) && !equali(Text, "^"^"", 2)) {
		new mPlayers
		new players[32]
		new uid, i
		new User[MAX_NAME_LENGTH]
		new Team[MAX_NAME_LENGTH]
		get_players(players, mPlayers)
		get_user_name(id, User, MAX_NAME_LENGTH-1)
		get_user_team(id, Team, MAX_NAME_LENGTH-1)
		for (i=0; i<mPlayers; i++) {
			uid = players[i]
			if (LISTEN[uid] == 1) {
				if (is_user_alive(id) && !is_user_alive(uid)) {
					client_print(uid, print_chat, "*ALIVE*%s (%s): %s", User, Team, Speech)
				} else if (!is_user_alive(id) && is_user_alive(uid)) {
					client_print(uid, print_chat, "*DEAD*:%s (%s): %s", User, Team, Speech)
				} else if ((is_user_alive(id) && is_user_alive(uid)) && (get_user_team(id) != get_user_team(uid))) {
					client_print(uid, print_chat, "%s (%s): %s", User, Team, Speech)
				} else if ((!is_user_alive(id) && !is_user_alive(uid)) && (get_user_team(id) != get_user_team(uid))) {
					client_print(uid, print_chat, "*DEAD*%s (%s): %s", User, Team, Speech)
				}
			} else {
				if (caccess(uid, "n") && LISTEN[uid] == -1) {
					LISTEN[uid] = 1
				}
			}
		}
	}	
	
	return PLUGIN_CONTINUE
}

/* End handling functions */

/* Begin General functions*/

MoveTarget(uid, Target[])
{
	if (MV_ENABLED==0) {
		return -1
	} else {
		new i
		for (i=0; i<MV_TARGCNT; i++) {
			if (cwrap(MV_TARGETS[i], Target)) {
				new pevvec[3]
				pevvec[0] = MV_XCOORDS[i]
				pevvec[1] = MV_YCOORDS[i]
				pevvec[2] = MV_ZCOORDS[i]
				set_user_origin(uid, pevvec)
				
				return true
			}
		}
	}
	
	return false
}

public delayed_round_start(param[])
{
	new id = param[0]
	new x = GLOW_VARS[id][0]
	new y = GLOW_VARS[id][1]
	new z = GLOW_VARS[id][2]
  
	glow(id, x, y, z, IS_INVIS[id])
	
	new Float:speed = USER_SPEEDS[id]
	if (IS_USER_SPEED[id]) {
		set_user_maxspeed(id, speed)
	}
	
	new Float:grav = USER_GRAVITY[id]
	if (IS_USER_GRAVITY[id]) {
		set_user_gravity(id, grav)
	}
}

CmdTeam(id, cmdid, iTeam, Dump[]="")
{
	new i
	new players[32]
	new mPlayers
	new teamId
	new uid
	new x=0,y,z
	new User[MAX_NAME_LENGTH]
	new Text[MAX_TEXT_LENGTH]
	new tester[3]
	
	get_players(players, mPlayers)
	for (i=0; i<mPlayers; i++) {
		uid = players[i]
		teamId = get_user_team(uid)
		if ((teamId == iTeam) || (iTeam == 9) || ((iTeam == 10) && (id != uid))) {
			if (cmdid == 1) {
				if (check_target(id, uid) && is_user_alive(uid)) {
					x = Dump[0]
					if (x) {
						user_slap(uid, x)
					} else {
						user_slap(uid, 0)
					}
				}
			} else if (cmdid == 2) {
				if (check_target(id, uid) && is_user_alive(uid)) {
					if (strlen(Dump)) {
						fakeslay(uid)
						gen_kill(id, uid, Dump)
					} else {
						slay(uid)
					}
				}
			} else if (cmdid == 3) {
				if (check_target(id, uid)) {
					set_user_godmode(uid, 1)
				}
			} else if (cmdid == 4) {
				if (check_target(id, uid)) {
					set_user_godmode(uid, 0)
				}
			} else if (cmdid == 5) {
				if (check_target(id, uid)) {
					set_user_noclip(uid, 1)
				}
			} else if (cmdid == 6) {
				if (check_target(id, uid)) {
					set_user_noclip(uid, 0)
				}
			} else if (cmdid == 7) {
				if (check_target(id, uid)) {
					x = Dump[0]
					y = Dump[1]
					z = Dump[2]
					glow(uid, x, y, z, IS_INVIS[uid])
				}
			} else if (cmdid == 8) {
				if (check_target(id, uid)) {
					glow(uid, 0, 0, 0)
				}
			} else if (cmdid == 9) {  /* FREE, UNUSED */
			} else if (cmdid == 10) { /* FREE, UNUSED */
			} else if (cmdid == 11) {
				if (check_target(id, uid)) {
					x = Dump[0]
					if (!x) {
						x = Dump[1]
					} else {
						if (Dump[2]) {
							x = get_user_armor(uid) - Dump[1]
						} else {
							x = Dump[1] + get_user_health(uid)
						}
					}
					set_user_health(uid, x)
				}
			} else if (cmdid == 12) {
				if (check_target(id, uid)) {
					x = Dump[0]
					if (!x) {
						x = Dump[1]
					} else {
						if (Dump[2]) {
							x = get_user_armor(uid) - Dump[1]
						} else {
							x = Dump[1] + get_user_armor(uid)
						}
					}
					set_user_armor(uid, x)
				}
			} else if (cmdid == 13) {
			} else if (cmdid == 14) {
				if (check_target(id, uid)) {
					x = Dump[0]
					if (!x) {
						x = Dump[1]
					} else {
						if (Dump[2]) {
							x = get_user_money(uid) - Dump[1]
						} else {
							x = Dump[1] + get_user_money(uid)
						}
					}
					set_user_money(uid, x, 1)
				}
			} else if (cmdid == 15) { /* FREE, UNUSED */
			} else if (cmdid == 16) {
				if (check_target(id, uid) && !is_user_alive(uid)) {
					new temp[2]
					temp[0] = uid
					engclient_cmd(uid, "spec_mode 3")
					client_cmd(uid, "spec_mode 3")
					set_task(0.75, "respawn", 0, temp, 2)
				}
			} else if (cmdid == 17) {
				if (check_target(id, uid)) {
					client_cmd(uid, Dump)
				}
			} else if (cmdid == 18) {
				get_user_name(id, User, MAX_NAME_LENGTH-1)
				client_print(uid, print_chat, "[PBR] (Team Message from %s): %s", User, Dump)
			} else if (cmdid == 19) {
				client_cmd(uid, Dump)
			} else if (cmdid == 20) {
				if (check_target(id, uid)) {
					give(uid, Dump)
				}
			} else if (cmdid == 21) {
				if (check_target(id, uid)) {
					flash(uid, Dump)
				}
			} else if (cmdid == 22) {
				if (check_target(id, uid)) {
					glow(uid, random_num(0,255), random_num(0,255), random_num(0,255), IS_INVIS[id])
				}
			} else if (cmdid == 23) {
				if (check_target(id, uid)) {
					IS_INVIS[uid] = 1
					x = GLOW_VARS[uid][0]
					y = GLOW_VARS[uid][1]
					z = GLOW_VARS[uid][2]
					if (x || y || z) {
						glow(uid, x, y, z, 1)
					} else {
						glow(uid, 0, 0, 0, 1)
					}
				}
			} else if (cmdid == 24) {
				if (check_target(id, uid)) {
					IS_INVIS[uid] = 0
					x = GLOW_VARS[uid][0]
					y = GLOW_VARS[uid][1]
					z = GLOW_VARS[uid][2]
					if (x || y || z) {
						glow(uid, x, y, z, 0)
					} else {
						glow(uid, 0, 0, 0, 0)
					}
				}				
			} else if (cmdid == 25) {
				if (check_target(id, uid)) {
					format(Text, MAX_TEXT_LENGTH-1, "+%s; wait; -%s", Dump)
					client_cmd(uid, Text)
				}
			} else if (cmdid == 26) {
				if (check_target(id, uid)) {
					x = Dump[0]
					if (!x) {
						x = Dump[1]
					} else {
						if (Dump[2]) {
							x = get_user_frags(uid) - Dump[1]
						} else {
							x = Dump[1] + get_user_frags(uid)
						}
					}
					set_user_frags(uid, x)
					new deaths = get_user_deaths(uid)
					message_begin(MSG_ALL, gmsgScoreInfo)
					write_byte(uid)
					write_short(x)
					write_short(deaths)
					write_short(0) 
					write_short(get_user_team(uid))
					message_end()
				}
			} else if (cmdid == 27) {
				if (check_target(id, uid)) {
					if (!fGrav) {
						IS_USER_GRAVITY[uid] = 0
						fGrav = 1.0
					} else {
						if (Dump[1]) {
							if (Dump[2]) {
								IS_USER_GRAVITY[uid] = 1
								USER_GRAVITY[uid] = USER_GRAVITY[uid] - fGrav
							} else {
								IS_USER_GRAVITY[uid] = 1
								USER_GRAVITY[uid] = fGrav + USER_GRAVITY[uid]
							}
						} else {
							IS_USER_GRAVITY[uid] = 1
							USER_GRAVITY[uid] = fGrav
						}
					}
					
					
					set_user_gravity(uid, fGrav)
				}
			} else if (cmdid == 28) {
				if (check_target(id, uid)) {
					if (!fSpeed || (floatround(fSpeed) == 0)) {
						set_user_maxspeed(uid, 900.0)
						IS_USER_SPEED[uid] = 0
					} else {
						IS_USER_SPEED[uid] = 1
						USER_SPEEDS[uid] = fSpeed
						set_user_maxspeed(uid, fSpeed)
					}
				}
			} else if (cmdid == 29) {
				if (check_target(id, uid)) {
					x = random_num(1337, 80220)	//Please don't collide!
					tester[0] = uid
					TWIN[uid] = x
					client_print(uid, print_chat, "[PBR] You are now a twin!")
					client_print(uid, print_chat, "[PBR] Every few seconds you will phase in and out of invincible ghost mode.")					
					set_task(2.5, "toggle_twin", x, tester, 2, "b")
				}
			} else if (cmdid == 30) {
				if (check_target(id, uid)) {
					unset_twin(uid)
				}
			} else if (cmdid == 31) {
				if (check_target(id, uid)) {
					fakeslay(uid)
				}
			} else if (cmdid == 32) {
				if (check_target(id, uid)) {
					tester[0] = random_num(0, 255)
					tester[1] = random_num(0, 255)
					tester[2] = random_num(0, 255)
					flash(uid, tester)
				}
			} else if (cmdid == 33) {
				if (check_target(id, uid)) {
					if ((id != uid) && is_user_alive(uid)) {
						get_user_origin(id, tester)
						x+=96
						tester[2]+=x
						set_user_origin(uid, tester)
					}
				}
			} else if (cmdid == 34) {
				if (check_target(id, uid)) {
					give(uid, "m4a1")
					give(uid, "m4a1")
					give(uid, "m4a1")
					give(uid, "m4a1")
					give(uid, "deagle")
					give(uid, "deagle")
					give(uid, "deagle")
					give(uid, "deagle")
					give(uid, "-assaultsuit")
					give(uid, "hegrenade")
				}
			} else if (cmdid == 35) {
				if (check_target(id, uid)) {
					give(uid, "ak47")
					give(uid, "ak47")
					give(uid, "ak47")
					give(uid, "ak47")
					give(uid, "deagle")
					give(uid, "deagle")
					give(uid, "deagle")
					give(uid, "deagle")
					give(uid, "-assaultsuit")
					give(uid, "hegrenade")
				}
			} else if (cmdid == 36) {
				if (check_target(id, uid)) {
					give(uid, "awp")
					give(uid, "awp")
					give(uid, "awp")
					give(uid, "awp")
					give(uid, "deagle")
					give(uid, "deagle")
					give(uid, "deagle")
					give(uid, "deagle")
					give(uid, "-assaultsuit")
					give(uid, "hegrenade")
				}
			}
			// how to add your own commands to multi targets.. stubs
			//	Add an elseif branch, or use one marked UNUSED (9, 10, 15 as of this writing)
			//	} else if (cmdid == IDENT) { //where IDENT is what you're passing to CmdTeam as cmdid
			//		if (check_target(id, uid)) {
			//			x = Dump[0]
			//			stuff(id, x)
			//		}
			//	}
			//
		}
	} 	
}

give(id, item[])
{
	new item_name[32], i, modname[32]

	if (equali(item[0], "+", 1)) {
		format(item_name, 31, "ammo_%s", item[1])
	} else if (equali(item[0], "-", 1)) {
		format(item_name, 31, "item_%s", item[1])
	} else if (equali(item[0], "_", 1)) {
		format(item_name, 31, "%s", item[1])
	} else {
		format(item_name, 31, "weapon_%s", item)
	}
	
	if (cwrap(item_name, "ammo_all")) {
		for (i=0; i<MOD_ITEMCOUNT; i++) {
			if (cwrap(MOD_ITEMS[i], "ammo")) {
				give_item(id, MOD_ITEMS[i])
			}
		}
	} else if (cwrap(item_name, "weapon_all")) {
		for (i=0; i<MOD_ITEMCOUNT; i++) {
			give_item(id, MOD_ITEMS[i])
		}
		get_modname(modname, 31)
		if (cwrap(modname, "cstrike")) {
			message_begin( MSG_ONE, 66,{0,0,0},id)
			write_byte(1)
			write_byte(4)
			write_byte(-1)
			message_end()
		}
	} else if (cwrap(item_name, "item_all")) {
		for (i=0; i<MOD_ITEMCOUNT; i++) {
			if (cwrap(MOD_ITEMS[i], "item")) {
				give_item(id, MOD_ITEMS[i])
			}
		}
	} else {
		give_item(id, item_name)
	}
}

PlaySoundToAll(sound[])
{
	new players[32], mPlayers;
	get_players(players, mPlayers)
	for (new i=0; i<mPlayers; i++) {
		emit_sound(players[i], CHAN_ITEM, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
}

tsay(message[], color[]="white", r=0, g=0, b=0, is_tsay=1)
{
	new found = 0,a = 0
	
	a = is_color(color) - 1
	if (!a)
		found = 0
	
	new length = found ? (strlen(color) + 1) : 0
	if (++g_msgChannel>6||g_msgChannel<3)
		g_msgChannel = 3
	new Float:verpos = ( is_tsay ? 0.55 : 0.1 ) + float(g_msgChannel) / 35.0
	if (!r && !g && !b) {
		set_hudmessage(g_Values[a][0], g_Values[a][1], g_Values[a][2], is_tsay ? 0.05 :  -1.0, verpos, 0, 6.0, 6.0, 0.5, 0.15, g_msgChannel)
	} else {
		set_hudmessage(r, g, b, is_tsay ? 0.05 :  -1.0, verpos, 0, 6.0, 6.0, 0.5, 0.15, g_msgChannel)
	}
	show_hudmessage(0,message[length])
	client_print(0,print_notify,message[length])

	return PLUGIN_HANDLED
}

kick(id, reason[]="", surpress=0)
{
	new Email[MAX_TEXT_LENGTH]
	new username[32]
	get_cvar_string("amx_admin_email", Email, MAX_TEXT_LENGTH-1)
	
	get_user_name(id, username, 31)
	
	if (!surpress) {
		if (strlen(reason)>1) {
			client_print(0, print_chat, "[PBR]: User ^"%s^" kicked. (%s)", username, reason)
		} else {
			client_print(0, print_chat, "[PBR]: User ^^%s^" kicked.", username)
		}
	}
	
	client_cmd(id, "echo You have been kicked.  Reason: %s", reason)
	client_cmd(id, "echo contact %s;toggleconsole;disconnect", Email)
}

addip(IP[], id, time=0, surpress=0, reason[]="")
{
	new username[32]
	if (!id || (strlen(IP)<7)) {
		return 0
	}
	get_user_name(id, username, 31)
	
	new Email[MAX_TEXT_LENGTH]
	get_cvar_string("amx_admin_email", Email, MAX_TEXT_LENGTH-1)	

	if (!surpress) {
		if (strlen(reason)>1) {
			client_print(0, print_chat, "[PBR]: User ^"%s^"/%s IP banned. (%s)", username, IP, reason)
		} else {
			client_print(0, print_chat, "[PBR]: User ^"%s^"/%s IP banned.", username, IP)
		}
	}
	client_cmd(id, "echo You have been banned by an admin.  Reason: %s", reason)
	client_cmd(id, "echo Time: %d minutes (0=permaban).", time)
	client_cmd(id, "echo contact %s;toggleconsole;disconnect", Email)
	
	new cmd[101]
	format(cmd, 100, "addip %d %s;wait;writeip", time, IP)
	
	set_task(2.0, "delayed_server_cmd", 0, cmd, 101)
	
	return 1
}

ban(id, time=0, surpress=0, reason[]="")
{
	new authid[32]
	new username[32]

	if (!id) {
		return 0
	}
	get_user_name(id, username, 31)
	get_user_authid(id, authid, 31)

	new Email[MAX_TEXT_LENGTH]
	get_cvar_string("amx_admin_email", Email, MAX_TEXT_LENGTH-1)
	
	if (!surpress) {
		if (strlen(reason)>1) {
			client_print(0, print_chat, "[PBR]: User ^"%s^"/%s banned. (%s)", username, authid, reason)
		} else {
			client_print(0, print_chat, "[PBR]: User ^"%s^"/%s banned.", username, authid)
		}
	}
	client_cmd(id, "echo You have been banned by an admin.  Reason: %s", reason)
	client_cmd(id, "echo Time: %d minutes (0=permaban).", time)
	client_cmd(id, "echo contact %s;toggleconsole;disconnect", Email)
	
	new cmd[101]
	format(cmd, 100, "banid %d %s kick;wait;writeid", time, authid)

	set_task(2.0, "delayed_server_cmd", 0, cmd, 101)	
	
	return 1
}

public delayed_server_cmd(cmd[])
{
	server_cmd(cmd)
}

slay(id, kill=0)	//Much of this was borrowed from slay2
{
	if (id) {
		new pOrigin[3], sOrigin[3]
		get_user_origin(id, pOrigin)
		sOrigin[0]=pOrigin[0]+150
		sOrigin[1]=pOrigin[1]+150
		sOrigin[2]=pOrigin[2]+400
		lightning(sOrigin, pOrigin)
		PlaySoundToAll("ambience/thunder_clap.wav")
		explode(pOrigin)
		blood(pOrigin)
		lots_of_blood(pOrigin, 3)
		user_kill(id, kill)
	}
}

gen_kill(pk, pv, wp[], hs=0)		//asskicr's code?
{
	new PKName[32], PVName[32]
	new PKSess, PVSess
	new PKAuth[20], PVAuth[20]
	new PKTeam[16], PVTeam[20]
	new Weapon[20]
	if (!hs) {
		//kill
		message_begin(MSG_ALL, get_user_msgid("DeathMsg"), {0,0,0}, 0)
		write_byte(pk)
		write_byte(pv)
		write_byte(0)
		write_string(wp)
		message_end()
		scoreboard(pv, 0)
	} else {
		//kill
		message_begin(MSG_ALL, get_user_msgid("DeathMsg"), {0,0,0}, 0)
		write_byte(pk)
		write_byte(pv)
		write_string(wp)
		message_end()
		scoreboard(pv, 0)
	}
	
	if (get_cvar_num("amx_pbr_logging")==1) {	//Logs kill! (devilish laugh)
		get_user_name(pk, PKName, 32)
		get_user_name(pv, PVName, 32)
		PKSess = get_user_userid(pk)
		PVSess = get_user_userid(pv)
		get_user_authid(pk, PKAuth, 20)
		get_user_authid(pv, PVAuth, 20)
		get_user_team(pk, PKTeam, 16)
		get_user_team(pv, PVTeam, 16)
		log_message("^"%s<%d><%s><%s>^" killed ^"%s<%d><%s><%s>^" with ^"weapon_%s^"", PKName, PKSess, PKAuth, PKTeam, PVName, PVSess, PVAuth, PVTeam, Weapon)
	}
}

public scoreboard(id,state)	//asskicr's code?
{
	message_begin(MSG_ALL, gmsgScoreAttrib, {0,0,0}, 0)
	write_byte(id)
	write_byte(state)
	message_end()
	
	return PLUGIN_HANDLED
}

shake(id)
{
	message_begin(MSG_ONE, gmsgShake, {0,0,0}, id)
	write_short( 1<<14 )
	write_short( 1<<14 )
	write_short( 1<<14 )
	message_end() 
}

fakeslay(id)	//Much of this was borrowed from slay2
{
	if (id) {
		new pOrigin[3], sOrigin[3]
		get_user_origin(id, pOrigin)
		sOrigin[0]=pOrigin[0]+150
		sOrigin[1]=pOrigin[1]+150
		sOrigin[2]=pOrigin[2]+400
		lightning(sOrigin, pOrigin)
		PlaySoundToAll("ambience/thunder_clap.wav")
		explode(pOrigin)
		blood(pOrigin)
		lots_of_blood(pOrigin, 3)		
	}
}

glow(id, r, g, b, invis=0)	//Make player glow
{
	if (r>255 || r<0) {
		r = 0
	}
	if (g>255 || g<0) {
		g = 0
	}
	if (b>255 || b<0) {
		b = 0
	}
	if (id) {
		if (!invis) {
			if (r || g || b) {
				set_user_rendering(id, kRenderFxGlowShell, r, g, b, kRenderNormal, 25)
			} else {
				set_user_rendering(id, kRenderFxNone, 0, 0, 0, kRenderNormal, 0)
			}
		} else {
			if (r || g || b) {
				set_user_rendering(id, kRenderFxGlowShell, r, g, b, kRenderTransTexture, 25)
			} else {
				set_user_rendering(id, kRenderFxNone, 0, 0, 0, kRenderTransTexture, 0)
			}			
		}
		
		GLOW_VARS[id][0] = r
		GLOW_VARS[id][1] = g
		GLOW_VARS[id][2] = b
		IS_INVIS[id] = invis
		
		return true
	} else {
		return false
	}
	
	return false
}

is_color(color[])
{
	for(new i=0;i<MAX_CLR;++i) {
		if (equali(color,g_Colors[i])) {
			return i+1
		}
	}
	
	return 0
}

//Counter-Strike... finds the last player not on your team
// if there is no last, returns the first person found on the opposite team that is alive
findLastPlayer(id)
{
	new iTeam = get_user_team(id)
	new oTeam
	new mPlayers
	new players[32]
	new uid, i
	get_players(players, mPlayers)
	for (i=0; i<mPlayers; i++) {
		uid = players[i]
		oTeam = get_user_team(uid)
		if (is_user_alive(uid) && (iTeam != oTeam)) {
			return uid
		}
	}
	
	return 0	//For some reason this failed... no one is alive or server empty.
}

public respawn(svIndex[])	//Respawn a player
{
	new vIndex = svIndex[0]

	user_spawn(vIndex)
	engclient_cmd(vIndex, "weapon_knife")

	return PLUGIN_CONTINUE   
}

/* End General Functins */
/* Begin data functions */

//This function strips the beginning and ending quotes from a string
//This mimics adminmod's strstripquotes or something, except it takes
//the head and tail off, not all quotes
strstrip(const String[], Text[], maxLen)
{
	new i = 0
	new pos = 0
	
	assert maxLen > 0
	
	if ((equali(String[0], "^"", 1)) && (equali(String[strlen(String)-1], "^"", 1)) && (strlen(String) > 2)) {
		for (i=1; i<=strlen(String)-2; i++) {
			if (pos < maxLen) {
				setc(Text[pos], 1, String[i])
				pos++
			}
		}
		Text[pos] = 0
		return true
	} else {
		copy(Text, maxLen-1, String)
		return false
	}
	
	return false
}

//This mimics adminmod's useful strbreak2 function
//amxmod is extremely poor on any string manipulation
// adminmod is far superior in this area
//This function is extended to parse quoted parameters
// much like Parse(), except actually useful
//Update on build 131 -- this will turn ' into ", and not write out "....
strbreak2(const String[], Left[], Right[], lMax, rMax)
{
	new bool:quote_flag = false
	new bool:done_flag = false
	new left_pos = 0
	new right_pos = 0
	new i
	new hold[] = "'^"x"
	
	copy(Left, lMax, "")
	copy(Right, rMax, "")
	
	for (i=0; i<=strlen(String)-1; i++) {
		if (equali(String[i], "^"", 1)) {
			quote_flag = true
		} else if ((equali(String[i], "^"", 1)) && (quote_flag)) {
			quote_flag = false
		}
		if ((equali(String[i], " ", 1)) && (!quote_flag) && (!done_flag)) {
			done_flag = true
			i++
		}
		if (!done_flag && !equali(String[i], "^"", 1)) {
			if (left_pos < lMax) {
				setc(Left[left_pos], 1, String[i])
				if (equali(Left[left_pos], "'", 1)) {
					setc(Left[left_pos], 1, hold[1])
				}
				left_pos++
			}
		} else {
			if (right_pos < rMax && !equali(String[i], "^"", 1)) {
				setc(Right[right_pos], 1, String[i])
				if (equali(Right[right_pos], "'", 1)) {
					setc(Right[right_pos], 1, hold[1])
				}
				right_pos++
			}
		}
	}

	Left[left_pos] = 0
	Right[right_pos] = 0
	
	return true
}

//A variant on strbreak2.  Returns everything before and after a given symbol.
// has a twist - removes spaces from ^Right
// note ^ = beginning
strsplit(const flag[], const String[], Left[], Right[], lMax, rMax)
{
	new bool:done_flag = false
	new bool:cont_flag = false
	new left_pos = 0
	new right_pos = 0
	new i
	
	copy(Left, lMax, "")
	copy(Right, rMax, "")
	
	for (i=0; i<=strlen(String)-1; i++) {
		if ((equali(String[i], flag[0], 1)) && (!done_flag)) {
			done_flag = true
			i++
		}
		if (!done_flag) {
			if (left_pos < lMax) {
				setc(Left[left_pos], 1, String[i])
				left_pos++
			}
		} else {
			if (!cont_flag) {
				if (equali(String[i], " ", 1)) {
					cont_flag = false
				} else {
					cont_flag = true
				}
			}
			if ((right_pos < rMax) && cont_flag) {
				setc(Right[right_pos], 1, String[i])
				right_pos++
			}
		}
	}

	Left[left_pos] = 0
	Right[right_pos] = 0
	
	return true
}

readCmdLevels()
{
	new file[MAX_NAME_LENGTH] = "pbr_cmds.cfg"
	new Text[MAX_TEXT_LENGTH]
	new Cmd[10]
	new Level[4]
	new lines
	new cid, cmds=0
	
	if (file_exists(file)) {
		new i
		log_message("[PBR] Loading pbr_cmds.cfg")		
		while (i<128 && read_file(file, i, Text, MAX_TEXT_LENGTH-1, lines)) {
			strbreak2(Text, Cmd, Level, 10, 4)
			if (strlen(Cmd)) {
				cid = cmdid(Cmd)
				if (cid) {
					copy(CMDS[cid], 2, Level)
					cmds++
				}//else { /*discard otherwise*/ }
			} else {
				log_message("[PBR] Invalid command entry at %d", i)
			}
			i++
		}
		log_message("[PBR] Overloaded %d command levels.", cmds)
	} else {
		log_message("[PBR] No pbr_cmds.cfg, using defaults.")
	}
	
	readDefLevels()
}

readDefLevels()
{
	new i
	
	for (i=0; i<=127; i++) {
		if (strlen(CMDS[i])<1) {
			if (i == 1) {
				copy(CMDS[i], 2, "o")
			} else if (i == 2) {
				copy(CMDS[i], 2, "t")
			} else if (i == 3) {
				copy(CMDS[i], 2, "t")
			} else if (i == 4) {
				copy(CMDS[i], 2, "o")
			} else if (i == 5) {
				copy(CMDS[i], 2, "n")
			} else if (i == 6) {
				copy(CMDS[i], 2, "t")
			} else if (i == 7) {
				copy(CMDS[i], 2, "p")
			} else if (i == 8) {
				copy(CMDS[i], 2, "p")
			} else if (i == 9) {
				copy(CMDS[i], 2, "m")
			} else if (i == 10) {
				copy(CMDS[i], 2, "p")
			} else if (i == 11) {
				copy(CMDS[i], 2, "t")
			} else if (i == 12) {
				copy(CMDS[i], 2, "t")
			} else if (i == 13) {
				copy(CMDS[i], 2, "o")
			} else if (i == 14) {
				copy(CMDS[i], 2, "n")
			} else if (i == 15) {
				copy(CMDS[i], 2, "o")
			} else if (i == 16) {
				copy(CMDS[i], 2, "n")
			} else if (i == 17) {
				copy(CMDS[i], 2, "p")
			} else if (i == 18) {
				copy(CMDS[i], 2, "p")
			} else if (i == 19) {
				copy(CMDS[i], 2, "m")
			} else if (i == 20) {
				copy(CMDS[i], 2, "p")
			} else if (i == 21) {
				copy(CMDS[i], 2, "p")
			} else if (i == 22) {
				copy(CMDS[i], 2, "n")
			} else if (i == 23) {
				copy(CMDS[i], 2, "n")
			} else if (i == 24) {
				copy(CMDS[i], 2, "m")
			} else if (i == 25) {
				copy(CMDS[i], 2, "n")
			} else if (i == 26) {
				copy(CMDS[i], 2, "t")
			} else if (i == 27) {
				copy(CMDS[i], 2, "o")
			} else if (i == 28) {
				copy(CMDS[i], 2, "p")
			} else if (i == 29) {
				copy(CMDS[i], 2, "o")
			} else if (i == 30) {
				copy(CMDS[i], 2, "p")
			} else if (i == 31) {
				copy(CMDS[i], 2, "o")
			} else if (i == 32) {
				copy(CMDS[i], 2, "p")
			} else if (i == 33) {
				copy(CMDS[i], 2, "m")
			} else if (i == 34) {
				copy(CMDS[i], 2, "t")
			} else if (i == 35) {
				copy(CMDS[i], 2, "m")
			} else if (i == 36) {
				copy(CMDS[i], 2, "p")
			} else if (i == 37) {
				copy(CMDS[i], 2, "p")
			} else if (i == 38) {
				copy(CMDS[i], 2, "o")
			} else if (i == 39) {
				copy(CMDS[i], 2, "p")
			} else if (i == 40) {
				copy(CMDS[i], 2, "o")
			} else if (i == 41) {
				copy(CMDS[i], 2, "o")
			} else if (i == 42) {
				copy(CMDS[i], 2, "p")
			} else if (i == 43) {
				copy(CMDS[i], 2, "n")
			} else if (i == 44) {
				copy(CMDS[i], 2, "n")
			} else if (i == 45) {
				copy(CMDS[i], 2, "n")
			} else if (i == 46) {
				copy(CMDS[i], 2, "o")
			} else if (i == 47) {
				copy(CMDS[i], 2, "m")
			} else if (i == 48) {
				copy(CMDS[i], 2, "p")
			} else if (i == 49) {
				copy(CMDS[i], 2, "m")
			} else if (i == 50) {
				copy(CMDS[i], 2, "p")
			} else if (i == 51) {
				copy(CMDS[i], 2, "n")
			} else if (i == 52) {
				copy(CMDS[i], 2, "n")
			} else if (i == 53) {
				copy(CMDS[i], 2, "m")
			} else if (i == 54) {
				copy(CMDS[i], 2, "o")
			} else if (i == 55) {
				copy(CMDS[i], 2, "o")
			} else if (i == 56) {
				copy(CMDS[i], 2, "n")
			} else if (i == 57) {
				copy(CMDS[i], 2, "p")
			} else if (i == 58) {
				copy(CMDS[i], 2, "o")
			} else if (i == 59) {
				copy(CMDS[i], 2, "t")
			} else if (i == 60) {
				copy(CMDS[i], 2, "t")
			} else if (i == 61) {
				copy(CMDS[i], 2, "")
			} else if (i == 62) {
				copy(CMDS[i], 2, "n")
			} else if (i == 63) {
				copy(CMDS[i], 2, "m")
			} else if (i == 64) {
				copy(CMDS[i], 2, "m")
			} else if (i == 65) {
				copy(CMDS[i], 2, "m")
			} else if (i == 66) {
				copy(CMDS[i], 2, "t")
			} else if (i == 67) {
				copy(CMDS[i], 2, "o")
			} else if (i == 68) {
				copy(CMDS[i], 2, "m")
			} else if (i == 69) {
				copy(CMDS[i], 2, "t")
			} else if (i == 70) {
				copy(CMDS[i], 2, "t")
			} else if (i == 71) {
				copy(CMDS[i], 2, "n")
			} else if (i == 72) {
				copy(CMDS[i], 2, "m")
			} else if (i == 73) {
				copy(CMDS[i], 2, "p")
			} else if (i == 74) {
				copy(CMDS[i], 2, "")
			} else if (i == 75) {
				copy(CMDS[i], 2, "m")
			} else if (i == 76) {
				copy(CMDS[i], 2, "m")
			} else if (i == 77) {
				copy(CMDS[i], 2, "m")
			} else if (i == 78) {
				copy(CMDS[i], 2, "")
			} else if (i == 79) {
				copy(CMDS[i], 2, "n")
			} else if (i == 80) {
				copy(CMDS[i], 2, "m")
			} else if (i == 81) {
				copy(CMDS[i], 2, "s")
			} else if (i == 82) {
				copy(CMDS[i], 2, "s")
			} else if (i == 83) {
				copy(CMDS[i], 2, "r")
			} else if (i == 84) {
				copy(CMDS[i], 2, "o")
			} else if (i == 85) {
				copy(CMDS[i], 2, "p")
			} else if (i == 86) {
				copy(CMDS[i], 2, "o")
			} else if (i == 87) {
				copy(CMDS[i], 2, "o")
			} else if (i == 88) {
				copy(CMDS[i], 2, "o")
			} else if (i == 89) {
				copy(CMDS[i], 2, "o")
			} else if (i == 90) {
				copy(CMDS[i], 2, "p")
			}
		}
	}
	copy(d_level, 2, CMDS[80])
	copy(a_level, 2, CMDS[81])
	copy(a_level, 2, CMDS[82])
	copy(t_level, 2, CMDS[83])
}

readAdminFile()
{
	new file[MAX_NAME_LENGTH] = "pbr_admins.cfg"
	new Text[MAX_TEXT_LENGTH]
	new Temp[MAX_TEXT_LENGTH]
	new Admin[32]
	new Pass[32]
	new Flags[32]
	new lines
	
	if (file_exists(file)) {
		new i
		AUTH_NUM = 0
		while (i<MAX_AUTH && read_file(file, i, Text, MAX_TEXT_LENGTH-1, lines)) {
			strbreak2(Text, Admin, Temp, 31, MAX_TEXT_LENGTH-1)
			strbreak2(Temp, Pass, Flags, 31, 31)
			if (strlen(Admin)>3 && strlen(Pass)>3) {
				copy(AUTH_USERS[AUTH_NUM], 31, Admin)
				copy(AUTH_PASS[AUTH_NUM], 31, Pass)
				copy(AUTH_FLAGS[AUTH_NUM], 31, Flags)
				AUTH_NUM++
			}
			i++
		}
		format(Text, MAX_TEXT_LENGTH-1, "[PBR] loaded %d auth accounts/admins.", AUTH_NUM)
		log_message(Text)
	} else {
		format(Text, MAX_TEXT_LENGTH-1, "[PBR] could not find pbr_admins.cfg")
		log_message(Text)
	}
}

readEntities()
{
	new Mod[12]
	new File[32]
	new Ent[24]
	new i = 0
	new lines
	get_modname(Mod, 12)
	format(File, 32, "pbr_mod_%s.cfg", Mod)
	if (file_exists(File)) {
		while (i<MAX_ITEMS && read_file(File, i, Ent, 24, lines)) {
			copy(MOD_ITEMS[i], 24, Ent)
			i++
		}
		MOD_ITEMCOUNT = i
		log_message("[PBR] Found mod entity file ^"%s^"", File)
		log_message("[PBR] Loaded %d entities for mod ^"%s^"", MOD_ITEMCOUNT, Mod)
	} else {
		//Default to cstrike weapons
		copy(MOD_ITEMS[i++], 24, "weapon_usp")
		copy(MOD_ITEMS[i++], 24, "weapon_glock18")
		copy(MOD_ITEMS[i++], 24, "weapon_deagle")
		copy(MOD_ITEMS[i++], 24, "weapon_p228")
		copy(MOD_ITEMS[i++], 24, "weapon_fiveseven")
		copy(MOD_ITEMS[i++], 24, "weapon_elite")
		copy(MOD_ITEMS[i++], 24, "weapon_m3")
		copy(MOD_ITEMS[i++], 24, "weapon_xm1014")
		copy(MOD_ITEMS[i++], 24, "weapon_mp5navy")
		copy(MOD_ITEMS[i++], 24, "weapon_tmp")
		copy(MOD_ITEMS[i++], 24, "weapon_ump45")
		copy(MOD_ITEMS[i++], 24, "weapon_p90")
		copy(MOD_ITEMS[i++], 24, "weapon_mac10")
		copy(MOD_ITEMS[i++], 24, "weapon_ak47")
		copy(MOD_ITEMS[i++], 24, "weapon_m4a1")
		copy(MOD_ITEMS[i++], 24, "weapon_galil")
		copy(MOD_ITEMS[i++], 24, "weapon_famas")
		copy(MOD_ITEMS[i++], 24, "weapon_sg552")
		copy(MOD_ITEMS[i++], 24, "weapon_aug")
		copy(MOD_ITEMS[i++], 24, "weapon_scout")
		copy(MOD_ITEMS[i++], 24, "weapon_awp")
		copy(MOD_ITEMS[i++], 24, "weapon_g3sg1")
		copy(MOD_ITEMS[i++], 24, "weapon_sg550")
		copy(MOD_ITEMS[i++], 24, "weapon_m249")
		copy(MOD_ITEMS[i++], 24, "weapon_hegrenade")
		copy(MOD_ITEMS[i++], 24, "weapon_flashbang")
		copy(MOD_ITEMS[i++], 24, "weapon_smokegrenade")
		copy(MOD_ITEMS[i++], 24, "ammo_57mm")
		copy(MOD_ITEMS[i++], 24, "ammo_762nato")
		copy(MOD_ITEMS[i++], 24, "ammo_9mm")
		copy(MOD_ITEMS[i++], 24, "ammo_556nato")
		copy(MOD_ITEMS[i++], 24, "ammo_buckshot")
		copy(MOD_ITEMS[i++], 24, "ammo_556natobox")
		copy(MOD_ITEMS[i++], 24, "ammo_45acp")
		copy(MOD_ITEMS[i++], 24, "ammo_357sig")
		copy(MOD_ITEMS[i++], 24, "ammo_338magnum")
		copy(MOD_ITEMS[i++], 24, "ammo_50ae")
		copy(MOD_ITEMS[i++], 24, "item_kevlar")
		copy(MOD_ITEMS[i++], 24, "item_thighpack")
		copy(MOD_ITEMS[i++], 24, "item_assaultsuit")
		copy(MOD_ITEMS[i++], 24, "weapon_shieldgun")
		log_message("[PBR] Could not find mod entity file ^"%s^"", File)
		log_message("[PBR] Loaded %d entities for ^"%s^" by default.", MOD_ITEMCOUNT, "cstrike")
	}
	MOD_ITEMCOUNT = i
}

readMapFile()
{
	new Map[MAX_NAME_LENGTH]
	new Text[MAX_TEXT_LENGTH]
	
	get_mapname(Map, MAX_NAME_LENGTH-1)
	format(mapFile, MAX_NAME_LENGTH-1, "pbr_%s.cfg", Map)
	MV_TARGCNT = 0
	if (file_exists(mapFile)) {
		MV_ENABLED = 1
		new i=0, temp
		new Data[MAX_TEXT_LENGTH]
		new x,y,z
		new Target[MAX_TEXT_LENGTH]
		new TempB1[MAX_TEXT_LENGTH]
		new TempB2[MAX_TEXT_LENGTH]
		new TempB3[MAX_TEXT_LENGTH]
		while (i<MAX_TARGETS && read_file(mapFile, i, Data, MAX_TEXT_LENGTH-1, temp)) {
			strbreak2(Data, Target, TempB1, MAX_TEXT_LENGTH-1, MAX_TEXT_LENGTH-1)
			strbreak2(TempB1,TempB2,TempB3, MAX_TEXT_LENGTH-1, MAX_TEXT_LENGTH-1)
			x = strtonum(TempB1)
			strbreak2(TempB3,TempB1,TempB2, MAX_TEXT_LENGTH-1, MAX_TEXT_LENGTH-1)
			y = strtonum(TempB1)
			strbreak2(TempB2,TempB1,TempB3, MAX_TEXT_LENGTH-1, MAX_TEXT_LENGTH-1)
			z = strtonum(TempB1)
			if (strlen(Target)>4) {
				copy(MV_TARGETS[MV_TARGCNT], 31, Target)
				MV_XCOORDS[MV_TARGCNT] = x
				MV_YCOORDS[MV_TARGCNT] = y
				MV_ZCOORDS[MV_TARGCNT] = z
				MV_TARGCNT++
			}
			i++
		}
		format(Text, MAX_TEXT_LENGTH-1, "[PBR] loaded %d nodes for %s.", MV_TARGCNT, Map)
		log_message(Text)
	} else {
		format(Text, MAX_TEXT_LENGTH-1, "[PBR] warning: map %s not set up for nodes.", Map)
		log_message(Text)
		MV_ENABLED = 0
	}
}

/* End data functions */
/* Begin visual functions */

fireball(vec[3])	//from f117bomb, ATAC
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY, vec)
	write_byte(17) // TE_BEAMSPRITE
	write_coord(vec[0])
	write_coord(vec[1])
	write_coord(vec[2] +256)
	write_short(fire)
	write_byte(120)
	write_byte(255)
	message_end()

	// Implosion
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(14) // TE_IMPLOSION
	write_coord(vec[0])
	write_coord(vec[1])
	write_coord(vec[2])
	write_byte(100)
	write_byte(20)
	write_byte(5)
	message_end()

	// Random Explosions
	message_begin(MSG_PVS, SVC_TEMPENTITY, vec)
	write_byte(3) // TE_EXPLOSION
	write_coord(vec[0])
	write_coord(vec[1])
	write_coord(vec[2])
	write_short(m_fireball)
	write_byte(30)
	write_byte(12)
	write_byte(0) // TE_EXPLFLAG_NONE
	message_end()
}

flash(id, dumper[])
{
	new data[4]
	data[0] = id
	data[1] = dumper[0]
	data[2] = dumper[1]
	data[3] = dumper[2]
	
	set_task(3.0, "unflash_timer", 0, data, 4)

	message_begin(MSG_ONE, gmsgFade, {0,0,0}, id)
	write_short(1<<0)
	write_short(1<<0)
	write_short(1<<2)
	write_byte(dumper[0])
	write_byte(dumper[1])
	write_byte(dumper[2])
	write_byte(255) 
	message_end()	
}

public unflash_timer(param[])
{
	new id, data[3]
	id = param[0]
	data[0] = param[1]
	data[1] = param[2]
	data[2] = param[3]
	
	unflash(id, data)
}

unflash(id, dumper[])
{
	message_begin(MSG_ONE, gmsgFade, {0,0,0}, id)
	write_short(1<<12)
	write_short(1<<8)
	write_short(1<<1)
	write_byte(dumper[0])
	write_byte(dumper[1])
	write_byte(dumper[2])
	write_byte(255)
	message_end()	
}

lightning(vec1[3],vec2[3]) {	//This is from slay2
	//Lightning
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( 0 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_coord(vec2[0])
	write_coord(vec2[1])
	write_coord(vec2[2])
	write_short( lbolt )
	write_byte( 1 ) // framestart
	write_byte( 5 ) // framerate
	write_byte( 2 ) // life
	write_byte( 20 ) // width
	write_byte( 30 ) // noise
	write_byte( 200 ) // r, g, b
	write_byte( 200 ) // r, g, b
	write_byte( 200 ) // r, g, b
	write_byte( 200 ) // brightness
	write_byte( 200 ) // speed
	message_end()
	//Sparks
	message_begin( MSG_PVS, SVC_TEMPENTITY,vec2)
	write_byte( 9 )
	write_coord( vec2[0] )
	write_coord( vec2[1] )
	write_coord( vec2[2] )
	message_end()
	//Smoke	  
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec2)
	write_byte( 5 )
	write_coord(vec2[0])
	write_coord(vec2[1])
	write_coord(vec2[2])
	write_short( cloud )
	write_byte( 10 ) 
	write_byte( 10 ) 
	message_end()
}

explode(vec1[3]) {	//This is from slay2 also
	// blast circles
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1)
	write_byte( 21 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2] + 16)
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2] + 1936)
	write_short( white )
	write_byte( 0 ) // startframe
	write_byte( 0 ) // framerate
	write_byte( 2 ) // life
	write_byte( 16 ) // width
	write_byte( 0 ) // noise
	write_byte( 188 ) // r
	write_byte( 220 ) // g
	write_byte( 255 ) // b
	write_byte( 255 ) //brightness
	write_byte( 0 ) // speed
	message_end()
	//Explosion2
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( 12 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_byte( 188 ) // byte (scale in 0.1's)
	write_byte( 10 ) // byte (framerate)
	message_end()
	//Smoke
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1)
	write_byte( 5 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_short( cloud )
	write_byte( 2 ) 
	write_byte( 10 ) 
	message_end()
}

blood(vec1[3]) {	//Again from slay2
	//LAVASPLASH
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( 10 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	message_end()
}

lots_of_blood(origin[3],num) /* from plugin gore credit to mike_cao */
{
	// Blood decals
	static const blood_large[2] = {204,205}

	// Large splash
	for (new i = 0; i < num; i++) {
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte(116)
		write_coord(origin[0]+random_num(-50,50))
		write_coord(origin[1]+random_num(-50,50))
		write_coord(origin[2]-36)
		write_byte(blood_large[random_num(0,1)]) // index
		message_end()
	}
}

/* End visual functions */

public voteYesNo(id, question[])
{
	new Float:voting = get_cvar_float("amx_last_voting")
	if (voting > get_gametime()) {
		client_print(id, print_chat, "[PBR] There is already a vote running.")
		
		return 0
	}
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) {
		client_print(id, print_chat, "[PBR] Voting is not allowed at this time.")
		
		return 0
	}
	
	if (!IS_VOTING) {
		new message[MAX_TEXT_LENGTH]
		new retvals, i
		format(message, MAX_TEXT_LENGTH-1, "\yVote: %s \w^n^n1.  Yes^n2.  No", question)
		copy(VOTE_MSG, MAX_TEXT_LENGTH-1, question)
		retvals = (1<<0)|(1<<1)
		
		new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0
		set_cvar_float("amx_last_voting", get_gametime() + vote_time)
		VOTE_CHOICE[0] = 0
		VOTE_CHOICE[1] = 0
		VOTE_CHOICE[2] = 0
		VOTE_CHOICE[3] = 0
		IS_VOTING = true
		new players[32], mPlayers
		new Team[MAX_NAME_LENGTH]
		get_players(players, mPlayers)
		for (i=0; i<mPlayers; i++) {
			get_user_team(players[i], Team, MAX_NAME_LENGTH-1)
			if (!((equali(Team, "UNAS", 4)) || (equali(Team, "SPEC", 4)) || (get_user_time(players[i])==0))) {
				show_menu(players[i], retvals, message, floatround(vote_time))
			}
		}
		set_task(vote_time, "HandleYesNoVote")
	}
	
	return PLUGIN_HANDLED
}

public HandleYesNoVote(id)
{
	new Message[MAX_TEXT_LENGTH]
	
	if (STOP_VOTE) {
		STOP_VOTE = false
		IS_VOTING = false
		return PLUGIN_HANDLED
	}

	if (VOTE_CHOICE[0] >= VOTE_CHOICE[1]) {
		format(Message, MAX_TEXT_LENGTH, "Voting Result for ^"%s^": Option ^"Yes^" won with %d/%d votes.", VOTE_MSG, VOTE_CHOICE[0], (VOTE_CHOICE[0]+VOTE_CHOICE[1]))
	} else if (VOTE_CHOICE[1] > VOTE_CHOICE[0]) {
		format(Message, MAX_TEXT_LENGTH, "Voting Result for ^"%s^": Option ^"No^" won with %d/%d votes.", VOTE_MSG, VOTE_CHOICE[1], (VOTE_CHOICE[0]+VOTE_CHOICE[1]))
	}
	
	STOP_VOTE = false
	IS_VOTING = false	
	
	client_print(0, print_chat, Message)
	
	return PLUGIN_HANDLED
}

public vote_count(id, key)
{
	VOTE_CHOICE[key] += 1
	
	if (DBUG[id]) {
		client_print(id, print_console, "PBR=> d/vote_count->key=%d", key)
	}

	return PLUGIN_CONTINUE
}

cmdid(cmd[])
{
	if (equali(cmd, "addip")) {
		return 1
	} else if (equali(cmd, "admin")) {
		return 2
	} else if (equali(cmd, "arise,")) {
		return 3
	} else if (equali(cmd, "ban")) {
		return 4
	} else if (equali(cmd, "boot")) {
		return 5
	} else if (equali(cmd, "cease")) {
		return 6
	} else if (equali(cmd, "clip")) {
		return 7
	} else if (equali(cmd, "ctrl")) {
		return 8
	} else if (equali(cmd, "debug")) {
		return 9
	} else if (equali(cmd, "deflate")) {
		return 10
	} else if (equali(cmd, "demote")) {
		return 11
	} else if (equali(cmd, "fill")) {
		return 12
	} else if (equali(cmd, "flash")) {
		return 13
	} else if (equali(cmd, "gag")) {
		return 14
	} else if (equali(cmd, "give")) {
		return 15
	} else if (equali(cmd, "glow")) {
		return 16
	} else if (equali(cmd, "god")) {
		return 17
	} else if (equali(cmd, "hop")) {
		return 18
	} else if (equali(cmd, "info")) {
		return 19
	} else if (equali(cmd, "invis")) {
		return 20
	} else if (equali(cmd, "jump")) {
		return 21
	} else if (equali(cmd, "kick")) {
		return 22
	} else if (equali(cmd, "kill")) {
		return 23
	} else if (equali(cmd, "level")) {
		return 24
	} else if (equali(cmd, "listen")) {
		return 25
	} else if (equali(cmd, "make")) {
		return 26
	} else if (equali(cmd, "move")) {
		return 27
	} else if (equali(cmd, "mute")) {
		return 28
	} else if (equali(cmd, "name")) {
		return 29
	} else if (equali(cmd, "near")) {
		return 30
	} else if (equali(cmd, "norm")) {
		return 31
	} else if (equali(cmd, "powerup")) {
		return 32
	} else if (equali(cmd, "psay")) {
		return 33
	} else if (equali(cmd, "raise")) {
		return 34
	} else if (equali(cmd, "reply")) {
		return 35
	} else if (equali(cmd, "see")) {
		return 36
	} else if (equali(cmd, "send")) {
		return 37
	} else if (equali(cmd, "seta")) {
		return 38
	} else if (equali(cmd, "setf")) {
		return 39
	} else if (equali(cmd, "setg")) {
		return 40
	} else if (equali(cmd, "seth")) {
		return 41
	} else if (equali(cmd, "setm")) {
		return 42
	} else if (equali(cmd, "slap")) {
		return 43
	} else if (equali(cmd, "slay")) {
		return 44
	} else if (equali(cmd, "snap")) {
		return 45
	} else if (equali(cmd, "speed")) {
		return 46
	} else if (equali(cmd, "stat")) {
		return 47
	} else if (equali(cmd, "stop")) {
		return 48
	} else if (equali(cmd, "strike")) {
		return 49
	} else if (equali(cmd, "supergod")) {
		return 50
	} else if (equali(cmd, "team")) {
		return 51
	} else if (equali(cmd, "teamcs")) {
		return 52
	} else if (equali(cmd, "test")) {
		return 53
	} else if (equali(cmd, "trace")) {
		return 54
	} else if (equali(cmd, "twin")) {
		return 55
	} else if (equali(cmd, "ungag")) {
		return 56
	} else if (equali(cmd, "ungod")) {
		return 57
	} else if (equali(cmd, "untwin")) {
		return 58
	} else if (equali(cmd, "write")) {
		return 59
	} else if (equali(cmd, "amx")) {
		return 60
	} else if (equali(cmd, "auth")) {
		return 61
	} else if (equali(cmd, "cancel")) {
		return 62
	} else if (equali(cmd, "csay")) {
		return 63
	} else if (equali(cmd, "csayc")) {
		return 64
	} else if (equali(cmd, "cvar")) {
		return 65
	} else if (equali(cmd, "defnode")) {
		return 66
	} else if (equali(cmd, "map")) {
		return 67
	} else if (equali(cmd, "nodecount")) {
		return 68
	} else if (equali(cmd, "relnode")) {
		return 69
	} else if (equali(cmd, "root")) {
		return 70
	} else if (equali(cmd, "speak")) {
		return 71
	} else if (equali(cmd, "ssay")) {
		return 72
	} else if (equali(cmd, "suddendeath")) {
		return 73
	} else if (equali(cmd, "time")) {
		return 74
	} else if (equali(cmd, "tsay")) {
		return 75
	} else if (equali(cmd, "tsayc")) {
		return 76
	} else if (equali(cmd, "verify")) {
		return 77
	} else if (equali(cmd, "version")) {
		return 78
	} else if (equali(cmd, "vote")) {
		return 79
	} else if (equali(cmd, "$")) {
		return 80
	} else if (equali(cmd, "/@")) {
		return 81
	} else if (equali(cmd, "/*")) {
		return 82
	} else if (equali(cmd[0], "/", 1) || is_digit(cmd[1])) {
		return 83
	} else if (equali(cmd, "bomb") || equali(cmd, "kamikaze")) {
		return 84
	} else if (equali(cmd, "stack")) {
		return 85
	} else if (equali(cmd, "unmute")) {
		return 86
	} else if (equali(cmd, "euliah")) {
		return 87
	} else if (equali(cmd, "coke")) {
		return 88
	} else if (equali(cmd, "bail")) {
		return 89
	} else if (equali(cmd, "dan")) {
		return 90
	}
	
	return 0
}
