/* AMX Mod script. 
* 
*  Cat and Mouses
*  by Ridiculous[BAGOM]
*  Contact via www.bagom.com 
*
*  Viva Team BAGOM ! [Argh, Blade, C.S.M, DeusExNihilo, DrManahattan, Fodda, Inigo, Jet, Loafer, MCA,
*  MikeMurder, Nelly, Obi-1, Oldking, Shadow Dancer, TerrorGirl, Tman]
*
*  Credits : Thanks to OLO for AMX, SpaceDude for the invisibility, Botman for the Radar and why
*  you can't have one, Ludwig van for the beeps, f117bomb for respawns, tcquest78 for limited weapons 
*  and voting.
*
*  'Lo ! - 22nd, Bunny, DAS, Dragon, Evil, KIA, LBS, Muppets, 22nd, SAS, Tnb, u2o
*
*  Original Idea : The "Cat and Mouse" mp game type comes from Red Storm's Ghost Recon (included
*  in the Island Thunder extension pack). Ghost Recon is based upon Tom Clancy's ideas (who will
*  will hopefully stop writting soon for the sake of good literature and start doing games only).
*
*  - Description : 
*
*  This plug-in separates the players in two categories : The Cat and the Mouses.
*  When the plugin is started all players are mouses and are given an usp with ammos. They
*  cannot buy any weapon. The first player to kill an enemy becomes the Cat. The obective 
*  is to survive as Cat as long as you can and score as many points as possible. Winning the
*  round as Cat brings back more points for the team. A mouse who kills the Cat becomes Cat. 
*  
*  Killed players (Cat or Mouses) always respawn as mouses. Among the enemy team, a sniffer 
*  is created. Sniffers act like radar and give indication of how far the cat is from you. The more
*  beeps you hear, the closer the Cat is. 
*
*  Cat----- : Health 150, Kevlar Yes,  Weapon  Para, Run  Slower, Jump Highest, Glow Red
*  Mouse--- : Health 100, Kevlar  No,  Weapon   Usp, Run  Faster, Jump  Normal, Glow None
*  Sniffer- : Health  75, Kevlar  No,  Weapon Knife, Run Fastest, Jump  Higher, Invisible
*
*  - Points as Cat -
*
*  Killed an enemy mouse	+ 3  frags
*  Killed a friend mouse	- 2  frags
*
*  - Points as Mouse -
*
*  Becoming the first Cat	+ 15 frags
*  Becoming the Cat		+ 5  frags
*  Killed an enemy mouse	+ 1  frag
*  Killed a friend mouse	- 1  frag
*  Killed a friend cat		- 10 frags
*  First kill is a TK		- 15 frags
*
*  - Team Points for win on roundtime -
*
*  Team with Cat		+ 5 team-points
*  Team without Cat		+ 10 team-points
*
*  - Team Points for killing/loosing the Cat -
*
*  Team with Cat		- 3 team-points
*  Team without Cat		+ 5 team-points
*
*  - Team Points with Objectives completed -
*
*  Team with Cat		+ 15 team-points
*  Team without Cat		+ 25 team-points         
*
*  - Team Points at end of Cat time -
*
*  Team with Cat		+ 10 team-points
*  Team without Cat		- 5 team-points         
*
*  - Console Commands :
*
*  sv_catmouse - allows you to enable/disable the plugin, default is 0.
*
*  Revision History
*
*  v0.6: - Depending on his speed the sniffer will be more or less invisible
*	 - Sniffer ping is now a function of distance 
*	 - Added help for scoring and roles
*	 - Modified team rules for scores (completing objectives without
*	   Cat brings more points than with it)
*
*  v0.5: - Added Sniffer(s)
*	 - Modify functions (all lines called more than once are 
*	   put in functions) - easier to track program's behaviour
*	 - Added Help
*	 - Added Sounds for events
*	 - Added vote on/off and amx admin command
*
*  v0.4: - Gravity is now set for Cat
*        - Maxspeed is now set for Mouses
*
*  v0.3: - Check Weapons more often 
*        - Players force to drop weapons when plugin starts
*        - Added Score Rules for teams
*
*  v0.2: - Added Weapon Restrictions
*        - Give weapons to cat (para) and mouses (usp)
*        - Added Score Rules for cat and mouses
*        - Modified cat glow (more solid - visible for mouses)
*
*  v0.1: - Initial Version
*        
*
*  To Do 
*
*  - allow vote
*  - allow modification : new sniffer create auto or not
*  - allow - start with/without cat
*  - allow specified number of respawn
*
*  Check
*
*  - throw usp end of round and bomb at start
*  - voice vox/ must get the cap
*  - voice vox/ kill the rads
*  - sound for one person only - client_cmd(player,"spk %s",sound) 
*/ 

// Include - minimum needed is amxmod
// We will use functions from amxmisc (for vote and amx commands)
#include <amxmod>
#include <amxmisc>
#include <fun>

// Define constants
#define Distance_Timer 		5
#define Countdown_Timer 	50
#define Tteam 			1
#define CTteam 			2
#define SpectatorTeam		3

// Needed for managing the Cat
new bool:cat_exist
new cat_id

// Needed for managing the Cat
new bool:sniffer_exist
new sniffer_id

// Needed for managing the plugin 
new bool:amx_started

// Needed to manage start of rounds and team scoring
// Start of round - no respawn allowed
new bool:restarting_round
// Deal with the double envoy of TeamScore (will be considered once only)
new bool:team_score_passage
new bool:first_passage
// How many points scored with plugin ON
new Tmodifier 
new CTmodifier
// How many points scored with plugin OFF
new initTScore
new initCTScore
// How many points in Total
new TScore
new CTScore

// Needed to modify sniffer invisibility
new invisibility
new previous_position[3]

// Needed to define best team
// Which team tend to loose its Cats a lot ?
new TlooseCat
new CTlooseCat
// Which team completed more objectives ?
new TObjectives
new CTObjectives
// Which team has best protected its Cats
new TCatprotection
new CTCatprotection

// Need to manage special case where
// Cat is Terro and countdown reach zero, 
// But bomb planted did Not explode yet
new bool:bomb_planted

// Needed for the plugin's activation vote
// Text displayed during the vote
new vote_text[] = "\y %s the Cat and Mouses Game Type ?\w^n^n1. Yes^n2. No"
// Used to get the number of yes and of no
new option[2]

// Manage the amx admin command to start the plugin
public amx_start_catmouse(id, level, cid)
{
	// If the admin level is is too low - dont modify anything
	if (!cmd_access(id,level,cid,1))
	{
		return PLUGIN_HANDLED
	}

	// else read the value given with the command (0/OFF or 1/ON)

	new arg1[4]
	read_argv(1,arg1,3)
	
	// If it is put ON, modify the cvar 
	if (equal(arg1,"1")||equali(arg1,"on"))
	{
		amx_started = true
		set_cvar_num("sv_catmouse", 1)
		
	}
	// If it is put OFF, modify the cvar (DEFAULT)
	else if (equal(arg1,"0")||equali(arg1,"off"))
	{
		amx_started = false
		set_cvar_num("sv_catmouse", 0)
	}
	// Else just show what the command does
	else 
	{
		console_print(id, "Cat and Mouses Game Type is %s", amx_started ? "enabled" : "disabled")
		return PLUGIN_HANDLED
	}

	// Give feedback once the command has been executed - for the admin and for all
	console_print(id, "Cat and Mouses Game Type is %s", amx_started ? "enabled" : "disabled")

	client_print(0, print_center, "Cat and Mouses Game Type Has Been %s!", amx_started ? "Enabled" : "Disabled")
	set_hudmessage(0, 100, 0, 0.05, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)	
	show_hudmessage(0, amx_started ? "Cat and Mouses Game Type ON" : "Cat and Mouses Game Type OFF" )
	return PLUGIN_HANDLED
}  

public vote_catmouse(id)
{
	// Check that the vote is allowed at this time 
	new Float:voting = get_cvar_float("amx_last_voting")

	if (voting > get_gametime())
	{ 
		client_print(id, print_chat, "There is already a vote in progress.") 
		return PLUGIN_HANDLED
	} 
	
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) 
	{ 
		client_print(id, print_chat, "Please wait a bit more before casting that vote.") 
		return PLUGIN_HANDLED
	}
	
	// Else prepare the message to display

	new menu_msg[256]
	format(menu_msg, 255, vote_text, amx_started ? "Disable" : "Enable")

	// Define voting time

	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting",  get_gametime() + vote_time )

	// Show the message with the keys 1 and 2 to be recognise as valid votes
	show_menu(0,(1<<0)|(1<<1), menu_msg, floatround(vote_time))

	// At end of vote time, check the votes of the players
	set_task(vote_time,"check_votes")

	// Inform the vote's caster that the vote is in progress
	client_print(0, print_chat, "Voting is in progress.") 
	
	// At this very moment neither Yes or No has a number of votes
	option[0]=option[1]=0
	return PLUGIN_HANDLED
}

// Count the votes
public vote_count(id, key)
{ 
	if ( get_cvar_float("amx_vote_answers")) 
	{ 
		// Display which players voted for which options
		new name[32] 
		get_user_name(id, name, 31)
		client_print(0,print_chat,"* %s voted %s", name, key ? "against" : "for" )
	}

	// The key (1 or 2) gets one more vote 
	// by the player in argument
	++option[key]

	return PLUGIN_HANDLED
} 

// Check what happens now (ON or OFF)
public check_votes(id)
{
	// More YES ?
	if (option[0] > option[1])
	{
		// Inverse the amx_catmouse command (on to off / off to on)
		server_cmd("amx_catmouse %s", amx_started ? "off" : "on" )
		// Display statistics
		client_print(0,print_chat,"Vote successful (yes ^"%d^") (no ^"%d^").",option[0],option[1])
	}

	// So its No ?
	else
	{
		// Display statistics
		client_print(0,print_chat,"Vote failed (yes ^"%d^") (no ^"%d^").",option[0],option[1])
	}
	return PLUGIN_CONTINUE
}

// Precache the sound to use in the game
public plugin_precache()
{ 
	// Sniffer's radar
	precache_sound("buttons/blip1.wav")  
	// Create sniffer
	precache_sound("houndeye/he_alert1.wav")  
	// Create Cat
	precache_sound("x/nih_die2.wav")  
	// Mouse dies
	precache_sound("squeek/sqk_die1.wav")  
	// Create Mouse
	precache_sound("squeek/sqk_hunt1.wav")  
	return PLUGIN_CONTINUE 
}

// Manage the cases where a player 
// who can be cat or sniffer leave 
// the server
public client_disconnect(id)
{
	// If plugin is off just ignore this function
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}

	// Otherwise check who left
	else
	{
		// If it's the cat
		
		if (id == cat_id)
		{
			// There is no cat anymore
			cat_exist = false
			cat_id = -10
			remove_task(650)
			remove_task(755)

			// And the sniffer becomes useless
		    	sniffer_become_normal(sniffer_id)
			display_no_cat()
		}

		// If it's the sniffer
		else if (id == sniffer_id)
		{	
			remove_task(755)
    			sniffer_exist = false
			sniffer_id = -10

			// If there is a cat, create a new sniffer
			if (cat_exist == true)	
			{
				create_sniffer()
			}
		}

		// Otherwise, we do not care
	        return PLUGIN_CONTINUE 
	}
	return PLUGIN_CONTINUE
} 

// This is the main functions which 
//define the program's behaviour
public plugin_init()
{
	// Identify the plugin
	register_plugin("Cat_and_Mouses","0.6","Ridiculous")

	// Check the weapons each time a weapon is selected 
	register_event("CurWeapon","check_weapons","be","1=1")

	// When the audio end of round is launched, define end of round actions
	register_event("SendAudio","end_round","a","2=%!MRAD_terwin","2=%!MRAD_ctwin","2=%!MRAD_rounddraw")

	// When the hud is reset at start of new round or after respawn, perform actions
	register_event("ResetHUD", "start_round", "b")

	// When a death message is issued, manage the cat/sniffer/mouse relation
	register_event("DeathMsg", "death_management","a")

	// When the scores are sent (start of round), perform actions
	register_event("TeamScore", "retrieve_scores", "a")

	// Modify the score the score modifiers at 
	// objectives completed
	register_event("TextMsg","not_rescued","a","2&#Hostages_N") 
	register_event("TextMsg","all_rescued","a","2&#All_Hostages_R") 
	register_event("SendAudio", "planted", "a", "2&%!MRAD_BOMBPL") 
   	register_event("SendAudio", "defused", "a", "2&%!MRAD_BOMBDEF") 
	register_event("TextMsg","assassinated","a","2&#VIP_A") 
	register_event("TextMsg","not_escaped","a","2&#VIP_N") 
	register_event("TextMsg","escaped","a","2&#VIP_E") 

	// Modifiers again - based on time
	register_logevent("saved", 5, "2=Target_Saved") 
	register_logevent("time_cts_win",5, "3=CTs_Win") 
	register_logevent("time_ts_win",5, "3=Terrorists_Win") 

	// Define the state of the plugin at start - activated or not (OFF is default)
	register_cvar("sv_catmouse","0",0)

	// Register the menu displayed for the vote and defined useable keys (1 and 2)
	register_menucmd(register_menuid("Cat and Mouses Game Type ?"), (1<<0)|(1<<1), "vote_count")

	// Define help the messages and the command to write in chat to have them displayed 
	register_clcmd("say /cmhelp","help_description")
	register_clcmd("say /cmscoring","help_scoring")
	register_clcmd("say /cmsniffer","help_sniffer")
	register_clcmd("say /cmcat","help_cat")
	register_clcmd("say /cmmouse","help_mouse")
	
	// Players vote command - via chat 
	register_clcmd("say /cmvote", "vote_catmouse", 0, "- Cat and Mouses Game Type")

	// Amx admin command that starts the plugin
	register_concmd("amx_catmouse","amx_start_catmouse", ADMIN_LEVEL_B, "<1|0> - Cat and Mouses")

	return PLUGIN_CONTINUE
}

// Ensure the previous Cat is not Cat anymore
public cat_become_normal(id)
{
	// If plugin is off or there is no cat anyway just ignore this function
	if (get_cvar_num("sv_catmouse")==0 || cat_exist == false)
	{
		return PLUGIN_CONTINUE
	}

	// Stop the glow, remove counter, and reinitialise variables
	else
	{
		set_user_rendering(id)
		cat_exist = false
		cat_id = -10
		remove_task(650)

		set_user_gravity(id, 0.1)
		set_user_maxspeed(id, 280.0)

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

// Ensure the previous sniffer is no sniffer anymore
public sniffer_become_normal(id)
{
	// If plugin is off or there is no sniffer anyway just ignore this function
	if (get_cvar_num("sv_catmouse")==0 || sniffer_exist == false)
	{
		return PLUGIN_CONTINUE
	}

	// Else stop the glow, remove distance checker and reinitialise variables
	else
	{
		set_user_rendering(id)
		sniffer_exist = false
		sniffer_id = -10
		remove_task(755)

		set_user_gravity(id, 0.1)
		set_user_maxspeed(id, 280.0)

		
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE

}

// A cat has just been created
public become_cat(id)
{
	// If plugin is off just ignore this function
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}

	// Else create a Cat
	else
	{
		// The id received by the function is the new cat_id
		// and there is a Cat now
		cat_exist = true
		cat_id = id
		
		// Emit a sound to signal everyone that there is a new Cat
		emit_sound(0, CHAN_ITEM, "x/nih_die2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

		// Take all money from Cat 
		new current_money = get_user_money(id)
		set_user_money(id, (current_money-current_money), 0)

		// Increases cat health 
		new health = 150

		// Increases cat total by 5 (1 automatic by HL engine and 4 by us)
		new total_frags = get_user_frags(id)
		set_user_frags(id, total_frags+4)
		set_user_health(id, health)

		// Make the Cat glows Red (R: 255, G: 0, B: 0)
		set_user_rendering(id, kRenderFxGlowShell, 255, 0, 0, kRenderNormal, 16)

		// Give a kevlar to the Cat
		give_item(id, "item_kevlar")

		// Give a para and ammos
		give_item(id, "weapon_m249")
		give_item(id, "ammo_556nato")
		give_item(id, "ammo_556nato")
		give_item(id, "ammo_556nato")
		give_item(id, "ammo_556nato")
		give_item(id, "ammo_556nato")
		give_item(id, "ammo_556nato")
		give_item(id, "ammo_556nato")
		give_item(id, "ammo_556nato")
		give_item(id, "ammo_556nato")
		give_item(id, "ammo_556nato")

		// Change gun to para
		engclient_cmd(id,"weapon_m249")

		// Decreases his personnal gravity from 1.0 to 0.4
		// Decreases his speed from his Mouse/Sniffer's speed
		// To the minimum 
		set_user_gravity(id, 0.40)
		set_user_maxspeed(id, 250.0)

		// Prepare the parameter for the time function 
		new parameter[1]
		parameter[0] = Countdown_Timer

		// Start the countdown in 5 secons from now (Process 650)
		set_task(5.0, "cat_countdown", 650, parameter, 2)

		return PLUGIN_CONTINUE
	} 
	return PLUGIN_CONTINUE
}

// A sniffer has just been created
public create_sniffer()
{
	// If plugin is off or the round is going to end or
	// there is already a sniffer or there is no cat (no sniffer needed then 
	// so previous condition redundant) then just ignore this function
	if (get_cvar_num("sv_catmouse")==0 || restarting_round == true || sniffer_exist == true || cat_exist == false)
	{
		return PLUGIN_CONTINUE
	}

	// Else create a sniffer
	else 
	{
		// Take all alive players 		
		new players_array[32], total_players
		get_players(players_array,total_players,"a")

		// Take a random number between 1 and all the players alive
		// This is the new sniffer if he is not a spectator or from the Cat's team
		do
		{
                        sniffer_id = random_num(1, total_players)
		}  while (get_user_team(sniffer_id) == get_user_team(cat_id) || get_user_team(sniffer_id) == 3)

		// Emit sound to signal that a sniffer was created
		emit_sound(sniffer_id, CHAN_ITEM, "houndeye/he_alert1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			
		// Ensure that his money is still at zero
		new current_money = get_user_money(sniffer_id)
		set_user_money(sniffer_id, (current_money-current_money), 0)

		// Reduce his health
		new health = 50
		set_user_health(sniffer_id, health)

		// Make him invisible
		set_user_rendering(sniffer_id, kRenderFxNone, 0,0,0, kRenderTransTexture, 100)

		// Give him max speed and lower gravity
		set_user_gravity(sniffer_id, 0.55)
		set_user_maxspeed(sniffer_id, 320.0)

		// Inform the player that he is the new sniffer and should 
		// help his team to kill the Cat
		set_hudmessage(255, 100, 100, -1.0, 0.40, 0, 3.0, 2.0, 2.5, 1.5, 1)
		show_hudmessage(sniffer_id,"You are the new Sniffer")
		set_hudmessage(255, 100, 100, -1.0, 0.45, 0, 3.0, 2.0, 2.5, 1.5, 2)
		show_hudmessage(sniffer_id,"Lead your team to the Cat !")
		
		// Sniffer now officially exists
		sniffer_exist = true
		
		// Force the sniffer to knife
		engclient_cmd(sniffer_id,"weapon_knife")

		// Prepare the distance to Cat checker and start it
		new parameters[1]
		parameters[0] = 5
		
		get_user_origin(sniffer_id, previous_position)
		check_sniffer_movement()
		check_distance(parameters)

		return PLUGIN_CONTINUE
	} 
	return PLUGIN_CONTINUE
}

// Create mouses (all players untill a Cat is created)
public become_mouse(id)
{
	// If plugin is off just ignore this function
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}

	// Else let make them all very small
	else
	{
		// Emit sound to signal that a mouse has spawned
		emit_sound(id, CHAN_ITEM, "squeek/sqk_hunt1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

		// Put mouse's money to zero
		new current_money = get_user_money(id)
		set_user_money(id, (current_money-current_money), 0)

		// If it is a terrorist mouse, make him throw his glock
		// And give him usp and ammos
		if (get_user_team(id) == Tteam)
		{
			engclient_cmd(id, "weapon_glock18")
			engclient_cmd(id, "drop")
			give_item(id, "weapon_usp")
		}
		
		give_item(id, "ammo_45acp")
		give_item(id, "ammo_45acp")
		give_item(id, "ammo_45acp")
		give_item(id, "ammo_45acp")

		// Force him to use usp
		engclient_cmd(id, "weapon_usp")

		// Put gravity to normal gravity but 
		// Allow better speed than Cat
		set_user_gravity(id, 1.0)
		set_user_maxspeed(id, 280.0)

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

// Round is restarting after a 
// win by a team 
// Or a mouse respawn
public start_round(id)
{
	// If plugin is off just ignore this function
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}

	// Otherwise check that what situation we are in
	else
	{
		// If it's a new round for all
		// Just display the messsage "No Cat"
		if (restarting_round == true)
		{
			set_task(3.0, "display_no_cat", 950, "", 0)
		}
	
		// Else stop the "No Cat" from being displayed
		restarting_round = false
	
		// Avoid buy of any weapons by putting 
		// money of the one who respawn to zero 
		// (Redundant with become_cat, become_mouse and create_sniffer)
		new current_money = get_user_money(id)
		set_user_money(id, (current_money-current_money), 0)

		// Give usp and ammos - if respawnee is a terrorist
		// drop glock and give him an usp
		// Not redundant with become mouse : this here happens 
		// once per round only
		if (get_user_team(id) == 1)
		{
			engclient_cmd(id, "weapon_glock18")
			engclient_cmd(id, "drop")
			give_item(id, "weapon_usp")
		}

		// Give ammos
		give_item(id, "ammo_45acp")
		give_item(id, "ammo_45acp")
		give_item(id, "ammo_45acp")
		give_item(id, "ammo_45acp")
		give_item(id, "ammo_45acp")
		give_item(id, "ammo_45acp")
		give_item(id, "ammo_45acp")
		give_item(id, "ammo_45acp")

		// Force to usp
		engclient_cmd(id, "weapon_usp")

		// We want to receive the TeamScore message
		team_score_passage = false
		
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

// Spawn a mouse after a player has been killed
public spawn_mouse(parm[])
{
	// If plugin is off or the round is going to restart soon anyway
	// just ignore this function
	if (get_cvar_num("sv_catmouse")==0 || restarting_round == true)
	{
		return PLUGIN_CONTINUE
	}

	// Else respawn the player
	else
	{
		// Get the id of the player (argument of this function)
		new victim = parm[0]

		// Respawn the victim
		user_spawn(victim)

		// Transform the victim in mouse
		become_mouse(victim)

		// After a respawn the player recieves the scores
		// from the server without the modifiers from the plugin
		// So we send him the scores ourselves just after the respawn
		scores_post_respawn()

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE

}

// Inform the players that there is no cat 
// and what they have to do
public display_no_cat()
{
	// If plugin is off skip this function
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		// Show the message on a vertical offset the 0.05 and on
		// two different channel (1 and 2 at end of set) to get the two lines
		// displayed at same time for same period
		set_hudmessage(255, 100, 100, -1.0, 0.20, 0, 3.0, 2.0, 0.5, 1.5, 1)
		show_hudmessage(0,"There is no Cat yet")
		set_hudmessage(255, 100, 100, -1.0, 0.25, 0, 3.0, 2.0, 0.5, 1.5, 2)
		show_hudmessage(0,"The first to kill becomes Cat !")

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

// Inform everyone that this Cat was a bit unlucky or dumb
// and killed himself (might me helped with the bomb though)
public display_cat_dead()
{
	// If plugin is off or the round is going to restart soon anyway
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		// Show the message on a vertical offset the 0.05 and on
		// two different channel (1 and 2 at end of set) to get the two lines
		// displayed at same time for same period
		set_hudmessage(255, 100, 100, -1.0, 0.20, 0, 3.0, 2.0, 0.5, 1.5, 1)
		show_hudmessage(0,"The Cat is Dead")
		set_hudmessage(255, 100, 100, -1.0, 0.25, 0, 3.0, 2.0, 0.5, 1.5, 2)
		show_hudmessage(0,"The next to kill becomes Cat !")

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

// Inform the players that there is a new Cat
public display_cat_name(id)
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		// Show everyone that there is a new Cat, give his name

		new cat_name[32]
		get_user_name(id, cat_name, 32)
		set_hudmessage(255, 100, 100, -1.0, 0.15, 0, 3.0, 3.0, 0.5, 1.5, 3)
		show_hudmessage(0,"%s is now the cat !", cat_name)
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

// Real name of this function : HEADACHE
// Test all cases when a DeathMessage is received
// Anyone to optimise it with comments please ?
public death_management()
{
	// If the plugin is on and the round is not over yet, check how and who died
	// Depending on the case manage creation-replacement of sniffer, cat, mouse
	if (get_cvar_num("sv_catmouse") == 1 && restarting_round == false)
	{
		// Get the id for the killer and the victim
		new enemy = read_data(1)
		new victim = read_data(2)
		
		// Prepare parameters for respawn of the victim
		new parameter[1]
		parameter[0] = victim

		// Player is dead - emit a sound
		emit_sound(victim, CHAN_ITEM, "squeek/sqk_die1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			
		// If the killer is the bomb or self whatever the victim
		if (enemy == 0 || enemy == victim)
		{
			// Then if the victim is the cat, sniffer and cat disappears
			if (victim == cat_id)
			{ 
				cat_become_normal(victim)
				sniffer_become_normal(sniffer_id)
				set_task(1.0, "display_cat_dead", 1050, "", 0)
			}

			// Then if the victim is the sniffer, sniffer disappears
			else if (victim == sniffer_id)
			{ 
				sniffer_become_normal(victim)
			
				// And sniffer is recreated if the cat exists
				if  (cat_exist == true)
				{
					set_task(2.0, "create_sniffer", 450, "", 0)
				}
			}

			// respawn victim
			set_task(0.5, "spawn_mouse", 850, parameter, 2)		
			return PLUGIN_CONTINUE
		}

		// If not a suicide or bomb and if there is a cat
		else if (cat_exist == true)
		{
			// And if the Cat is the victim of another player

			if (victim == cat_id)
			{ 
				sniffer_become_normal(sniffer_id)
				set_task(2.0, "create_sniffer", 450, "", 0)
		
				// Then the killer is now the cat and the victim becomes normal 
				// and the sniffer does not exist any more
				cat_become_normal(victim)
				cat_id = enemy
				become_cat(enemy)
				display_cat_name(enemy)

				// Punish the killer if he is a teammate
				if (get_user_team(enemy) == get_user_team(victim))
				{
					new total_frags=get_user_frags(enemy)
					set_user_frags(enemy, total_frags-9)
				}
					
				if (get_user_team(enemy) == Tteam)
				{
					Tmodifier = Tmodifier + 5
					CTmodifier = CTmodifier - 3
					TlooseCat = TlooseCat + 1
				}
				else
				{
					CTmodifier = CTmodifier + 5
					Tmodifier = Tmodifier - 3
					CTlooseCat = CTlooseCat + 1
				}
		
				set_task(0.5, "spawn_mouse", 850, parameter, 2)		
				return PLUGIN_CONTINUE
			}

			// Else if the Cat is the killer
			else if (enemy == cat_id)
			{
				// If it's a tk then punish the cat
				if (get_user_team(enemy) == get_user_team(victim))
				{
					new total_frags=get_user_frags(enemy)
					set_user_frags(enemy, total_frags-1)
				}
			
				else
				{
					// if not a tk check if cat killed sniffer
					// If yes then remove sniffer
					if (victim == sniffer_id)
					{ 
						sniffer_become_normal(victim)
						set_task(2.0, "create_sniffer", 450, "", 0)
					}

					// Add points to cat
					new total_frags=get_user_frags(enemy)
					set_user_frags(enemy, total_frags + 2)
				}
				
				// respawn the victim
				set_task(0.5, "spawn_mouse", 850, parameter, 2)		
				return PLUGIN_CONTINUE
			}
	
			// If the killer is not the cat
			else if (enemy != cat_id)
			{

				// And the victim is the sniffer, recreate sniffer
				if (victim == sniffer_id)
				{ 
					sniffer_become_normal(victim)
					set_task(2.0, "create_sniffer", 450, "", 0)
				}

				set_task(0.5, "spawn_mouse", 850, parameter, 2)		
				return PLUGIN_CONTINUE
			}
			else 
			{
				// If simple Tk or simple kill then simply respawn the victim
				set_task(0.5, "spawn_mouse", 850, parameter, 2)		
				return PLUGIN_CONTINUE
			}
		}

		// If there is no Cat
		else if (cat_exist == false)
		{
	
			// Then the killer is now the cat - respawn victim in 0.5 second
			display_cat_name(enemy)
			become_cat(enemy)

			new total_frags = get_user_frags(enemy)

			// Punish him if he killed a teammate to become Cat
			if (get_user_team(enemy) == get_user_team(victim))
			{
				set_user_frags(enemy, total_frags-18)
			}
			else
			{
				set_user_frags(enemy, total_frags+9)
			}

			// create sniffer, respawn victim, start cat countdown
			set_task(0.5, "spawn_mouse", 850, parameter, 2)
			set_task(2.0, "create_sniffer", 450, "", 0)

			return PLUGIN_CONTINUE
		}

		// In all other cases, respawn the victim
		else
		{
			set_task(0.5, "spawn_mouse", 852, parameter, 2)		
			return PLUGIN_CONTINUE
		}
		
	}

	// If plugin not started or death occurs after end of round conditions
	return PLUGIN_CONTINUE
}

public check_weapons(id)
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		// Read the number of the active weapon

		new weapon_number=read_data(2)

		// then if he is the cat force him to para
	
		if (id == cat_id && cat_exist==true)
		{
			if (weapon_number!=20 && weapon_number!=6 && weapon_number!=29)
			{	
				engclient_cmd(id, "drop")	
				engclient_cmd(id,"weapon_m249")
				return PLUGIN_CONTINUE
			}
		}
		else if (id == sniffer_id && sniffer_exist==true)
		{
			if (weapon_number!=6)
			{	
				engclient_cmd(id, "drop")	
				return PLUGIN_CONTINUE
			}
		}

		// then if he is not the cat nor the sniffer force him to usp

		else
		{
			if (weapon_number!=16 && weapon_number!=6 && weapon_number!=29)
			{
				engclient_cmd(id, "drop")
				engclient_cmd(id,"weapon_usp")
				return PLUGIN_CONTINUE
			}
		}
	}
	return PLUGIN_CONTINUE
}

public cat_countdown(parameter[])
{
	if (get_cvar_num("sv_catmouse")==0)
	{
			return PLUGIN_CONTINUE
	}
	else
	{
		// If there is a cat

		if (cat_exist==true)
		{
			new cat_name[32]
			get_user_name(cat_id, cat_name, 31)
			new team_name[32]
			get_user_team(cat_id, team_name, 31)
			
			if (bomb_planted == true)
			{
				parameter[0] = parameter[0] + get_cvar_num("mp_c4timer")
				bomb_planted = false

				set_hudmessage(255, 100, 100, -1.0, 0.30, 0, 1.0, 1.0, 0.1, 0.2, 3)
				show_hudmessage(0, "Bomb Planted - Added %d secs", get_cvar_num("mp_c4timer"))
			}

			// And the countdown is not at zero 

			if (parameter[0] > 5)
			{
				// Display message with time remaining

				set_hudmessage(255, 100, 100, -1.0, 0.25, 0, 1.0, 1.0, 0.1, 0.2, 4)
				show_hudmessage(0, "%d secs to go...", parameter[0])
				parameter[0] = parameter[0] - 5
				set_task(5.0, "cat_countdown", 650, parameter[0], 2)
			}

			else if (parameter[0] <= 5 && parameter[0]!=0)
			{
				// Display message with time remaining
	
				set_hudmessage(255, 100, 100, -1.0, 0.25, 0, 1.0, 1.0, 0.1, 0.2, 4)
				show_hudmessage(0, "%s win in : %d seconds", team_name, parameter[0])
				parameter[0] --
				set_task(1.0, "cat_countdown", 650, parameter[0], 2)
			}

			// And the countdown reaches zero

			else
			{
				remove_task(650)
				remove_task(755)

				// Get all players from enemy team and kill them all
				new players_array[32], total_players
				get_players(players_array,total_players,"a")
				
				sniffer_become_normal(sniffer_id)

				for (new i = 0; i < total_players; ++i)
				{
					if (get_user_team(cat_id) != get_user_team(players_array[i]))
					{
						user_kill(players_array[i])
						new total_frags = get_user_frags(players_array[i])
						set_user_frags(players_array[i], total_frags+1)
					}
				}

				cat_become_normal(cat_id)
				restarting_round = true

				if (get_user_team(cat_id) == Tteam)
				{
					Tmodifier = Tmodifier + 10
					CTmodifier = CTmodifier - 5
					TCatprotection = TCatprotection + 1
				}
				else
				{
					CTmodifier = CTmodifier + 10
					Tmodifier = Tmodifier - 5
					CTCatprotection = CTCatprotection + 1
				}
			}		
		}
	}
	return PLUGIN_CONTINUE
}

public end_round(id)
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		// Stop the cat now a mouse from glowing at new round

		if (cat_exist == true && id == cat_id)
		{ 
			engclient_cmd(id, "weapon_m249")
			engclient_cmd(id, "drop")
			set_user_rendering(id)
		}

		team_score_passage = false
		cat_become_normal(cat_id)
		sniffer_become_normal(sniffer_id)
		restarting_round = true
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

public scores_post_respawn()
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		TScore = initTScore + Tmodifier
		CTScore = initCTScore + CTmodifier

		message_begin(MSG_ALL, 87)
		write_string("TERRORIST")
		write_short(TScore)
		message_end()

		message_begin(MSG_ALL, 87)
		write_string("CT")
		write_short(CTScore)
		message_end()
		
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

public update_scores()
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		TScore = initTScore + Tmodifier
		CTScore = initCTScore + CTmodifier

		message_begin(MSG_ALL, 87)
		write_string("TERRORIST")
		write_short(TScore)
		message_end()

		message_begin(MSG_ALL, 87)
		write_string("CT")
		write_short(CTScore)
		message_end()

		
		sniffer_become_normal(sniffer_id)

		if (first_passage == true)
		{
			set_hudmessage(255, 100, 100, -1.0, 0.35, 0, 1.0, 0.5, 0.1, 0.2, 4)
			show_hudmessage(0, "Teams Scores Updated !")
		}
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

public retrieve_scores(id)
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		new team_name[32] 
		read_data(1,team_name,32) 

		if (first_passage == false)
		{
			if (equal(team_name,"CT"))
			{ 
				initCTScore = read_data(2) 
	   		} 
			else 
			{ 
				initTScore = read_data(2) 
		   	}	 
			first_passage = true
		}
	
		if (team_score_passage == true)
		{
			set_task(6.0, "update_scores", 355, "", 0)
		}
	
		team_score_passage = true
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

public not_rescued()
{ 
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		if (get_user_team(cat_id) == Tteam)
		{
			Tmodifier = Tmodifier + 15
			TObjectives = TObjectives + 1
		}
		else
		{
			Tmodifier = Tmodifier + 25
			TObjectives = TObjectives + 1

		}
		
		team_score_passage = false
		remove_task(650)
		remove_task(755)

		if (cat_exist == true)
		{
			cat_become_normal(cat_id)
		}
		if (sniffer_exist == true)
		{
			sniffer_become_normal(sniffer_id)
		}

		restarting_round = true

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
} 

public all_rescued()
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		if (get_user_team(cat_id) == CTteam)
		{
			CTmodifier = CTmodifier + 15
			CTObjectives = CTObjectives + 1
		}
		else
		{
			CTmodifier = CTmodifier + 25
			CTObjectives = CTObjectives + 1
		} 

		team_score_passage = false
		remove_task(650)
		remove_task(755)

		if (cat_exist == true)
		{
			cat_become_normal(cat_id)
		}
		if (sniffer_exist == true)
		{
			sniffer_become_normal(sniffer_id)
		}

		restarting_round = true


		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
} 

public time_ts_win()
{ 
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		if (get_user_team(cat_id) == Tteam)
		{
			Tmodifier = Tmodifier + 5
			TObjectives = TObjectives + 1
		}
		else
		{
			Tmodifier = Tmodifier + 10
			TObjectives = TObjectives + 1

		}
		
		team_score_passage = false
		remove_task(650)
		remove_task(755)

		if (cat_exist == true)
		{
			cat_become_normal(cat_id)
		}
		if (sniffer_exist == true)
		{
			sniffer_become_normal(sniffer_id)
		}

		restarting_round = true

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
} 

public time_cts_win()
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		if (get_user_team(cat_id) == CTteam)
		{
			CTmodifier = CTmodifier + 5
			CTObjectives = CTObjectives + 1
		}
		else
		{
			CTmodifier = CTmodifier + 10
			CTObjectives = CTObjectives + 1
		} 

		team_score_passage = false
		remove_task(650)
		remove_task(755)

		if (cat_exist == true)
		{
			cat_become_normal(cat_id)
		}
		if (sniffer_exist == true)
		{
			sniffer_become_normal(sniffer_id)
		}

		restarting_round = true


		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
} 

public planted()
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		new parameter[1]
		parameter[0] = get_cvar_num("mp_c4timer") - 1

		bomb_planted = true

		set_task(1.0, "check_bomb", 150, parameter, 2)
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
} 

public check_bomb(parameter[])
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		if (parameter[0] == 0)
		{
			remove_task(150)
			exploded()
			return PLUGIN_CONTINUE
		}
		else
		{
			parameter[0]--
			set_task(1.0, "check_bomb", 150, parameter, 2)
			return PLUGIN_CONTINUE
		}
	}
	return PLUGIN_CONTINUE
} 


public exploded()
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		if (get_user_team(cat_id) == Tteam)
		{
			Tmodifier = Tmodifier + 15
			TObjectives = TObjectives + 1
		}
		else
		{
			Tmodifier = Tmodifier + 25
			TObjectives = TObjectives + 1
		} 

		team_score_passage = false
		remove_task(650)
		remove_task(755)

		if (cat_exist == true)
		{
			cat_become_normal(cat_id)
		}
		if (sniffer_exist == true)
		{
			sniffer_become_normal(sniffer_id)
		}

		restarting_round = true


		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
} 

public defused()
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		remove_task(150)

		if (get_user_team(cat_id) == CTteam)
		{
			CTmodifier = CTmodifier + 15
			CTObjectives = CTObjectives + 1
		}
		else
		{
			CTmodifier = CTmodifier + 25
			CTObjectives = CTObjectives + 1
		} 
		team_score_passage = false
		remove_task(650)
		remove_task(755)

		if (cat_exist == true)
		{
			cat_become_normal(cat_id)
		}
		if (sniffer_exist == true)
		{
			sniffer_become_normal(sniffer_id)
		}

		restarting_round = true

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
} 

public saved()
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		remove_task(150)

		if (get_user_team(cat_id) == CTteam)
		{
			CTmodifier = CTmodifier + 15
			CTObjectives = CTObjectives + 1
		}
		else
		{
			CTmodifier = CTmodifier + 25
			CTObjectives = CTObjectives + 1
		} 
		team_score_passage = false
		remove_task(650)
		remove_task(755)

		if (cat_exist == true)
		{
			cat_become_normal(cat_id)
		}
		if (sniffer_exist == true)
		{
			sniffer_become_normal(sniffer_id)
		}

		restarting_round = true

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
} 

public escaped()
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		if (get_user_team(cat_id) == CTteam)
		{
			CTmodifier = CTmodifier + 15
			CTObjectives = CTObjectives + 1
		}
		else
		{
			CTmodifier = CTmodifier + 25
			CTObjectives = CTObjectives + 1
		} 
		
		team_score_passage = false
		remove_task(650)
		remove_task(755)

		if (cat_exist == true)
		{
			cat_become_normal(cat_id)
		}
		if (sniffer_exist == true)
		{
			sniffer_become_normal(sniffer_id)
		}

		restarting_round = true

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
} 

public assassinated()
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		if (get_user_team(cat_id) == Tteam)
		{
			Tmodifier = Tmodifier + 15
			TObjectives = TObjectives + 1
		}
		else
		{
			Tmodifier = Tmodifier + 25
			TObjectives = TObjectives + 1
		} 
		
		team_score_passage = false
		remove_task(650)
		remove_task(755)

		if (cat_exist == true)
		{
			cat_become_normal(cat_id)
		}
		if (sniffer_exist == true)
		{
			sniffer_become_normal(sniffer_id)
		}

		restarting_round = true

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
} 

public not_escaped()
{
	if (get_cvar_num("sv_catmouse")==0)
	{
		return PLUGIN_CONTINUE
	}
	else
	{
		if (get_user_team(cat_id) == Tteam)
		{
			Tmodifier = Tmodifier + 15
			TObjectives = TObjectives + 1
		}
		else
		{	
			Tmodifier = Tmodifier + 25
			TObjectives = TObjectives + 1
		} 
		
		team_score_passage = false
		remove_task(650)
		remove_task(755)

		if (cat_exist == true)
		{
			cat_become_normal(cat_id)
		}
		if (sniffer_exist == true)
		{
			sniffer_become_normal(sniffer_id)
		}

		restarting_round = true

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
} 

public check_distance(parameters[])
{
	if (get_cvar_num("sv_catmouse")==1 && sniffer_exist == true && cat_exist == true && is_user_alive(sniffer_id) == 1)
	{

		new cat_origin[3] 
		get_user_origin(cat_id, cat_origin)
		
		new sniffer_origin[3] 
		get_user_origin(sniffer_id, sniffer_origin)
 	
		new Float:distance = float(get_distance(cat_origin, sniffer_origin))
		distance = distance/40.0
	
		client_cmd(sniffer_id, "speak buttons/blip1.wav") 
		set_task(distance/40.0, "check_distance", 755, "", 0) 
	

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

public help_description(id)
{
	new help_description_text[1300]
	new textstart[500]
	new textmiddle[500]
	new textfinish[500]

	textstart = "^nThis plug-in separates the players in two categories : The Cat and the Mouses.^n^n\
	When a round starts all players are mouses and are given an usp with ammos. \
	They cannot buy any weapon. The first player to kill an enemy becomes the Cat. The objective \
	is to survive as Cat as long as you can and score as many points as possible. Winning the \
	round as Cat brings back more points for the team. A mouse who kills the Cat becomes Cat.^n^n"

	add(help_description_text, 1299, textstart)

	textmiddle = "Killed players (Cat or Mouses) always respawn as mouses. Among the enemy\
	team, a sniffer is created. Sniffers act like radar and give indication of how far the\
	cat is from them. The more beeps they hear, the closer the Cat is to them. They can use \
	this advantage to lead their team to the cat !" 

	add(help_description_text, 1299, textmiddle)

	textfinish ="^n^nCommands :^n^n\
	/cmhelp	: this help^n\
	/cmscoring : how are counted the frags and team-points^n\
	/cmcat : what is the Cat ?^n\
	/cmsniffer : what is the Sniffer ?^n\
	/cmmouse : what is a Mouse ?^n"

	add(help_description_text, 1299, textfinish)
	show_motd(id, help_description_text, "Cat and Mouses - Rules :")

	return PLUGIN_CONTINUE
}

public help_scoring(id)
{
	new help_description_text[1300]
	new textstart[500]
	new textmiddle[500]

	textstart = "^t- Points as Cat -^n^n\
	Killed an enemy mouse^t+ 3  frags^n\
	Killed a friend mouse^t- 2  frags^n^n\
	^t- Points as Mouse -^n^n\
	Becoming the first Cat^t+ 15 frags^n\
	Becoming the Cat^t+ 5  frags^n\
	Killed an enemy mouse^t+ 1 frag^n\
	Killed a friend mouse^t- 1 frag^n\
	Killed a friend Cat^t- 10 frags^n\
	First kill is a TK^t- 15 frags^n^n\
	^t- Team Points loosing the Cat -^n^n\
	Team with the Cat^t- 5 team-points^n\
	Team without Cat^t+ 3 team-points^n^n\ "

	add(help_description_text, 1299, textstart)

	textmiddle ="^t- Team Points with Objectives completed -^n^n\
	Team with the Cat^t+ 35 team-points^n\
	Team without Cat^t+ 15 team-points^n^n\
	^t- Team Points at end of Cat time -^n^n\
	Team with the Cat^t+ 15 team-points^n\
	Team without Cat^t- 5 team-points"
	
	add(help_description_text, 1299, textmiddle)

	show_motd(id, help_description_text, "Cat and Mouses - Scoring :")

	return PLUGIN_CONTINUE
}


public help_sniffer(id)
{
	new help_description_text[1300]
	new textstart[500]
	new textmiddle[500]

	textstart = "^nYou are the sniffer !^n^nYou run faster than anyone \
	and you can jump higher than a normal mouse. However, you are not \
	really resistant (50 hps) and your only weapon is a knife.^n^nYour \
	goal is not to kill but to help your team find the Cat before the \
	end of the Countdown. To help you in this task you are partially \
	invisible (you can become completely invisible if you move slowly)\ 
	and an audio ping indicates you the Cat''s position."

	add(help_description_text, 1299, textstart)

	textmiddle ="The closer you are to the Cat \
	the more pings you will hear.^n^nIt is your job \
	to find the Cat and spread the news of his position to your team ! \
	If you die a new sniffer is created so do your job well and your \
	teammates will consider giving you a good cover..."
	
	add(help_description_text, 1299, textmiddle)

	show_motd(id, help_description_text, "Cat and Mouses - Sniffer :")

	return PLUGIN_CONTINUE
}

public help_cat(id)
{
	new help_description_text[1300]
	new textstart[500]
	new textmiddle[500]
	new textfinish[500]

	textstart = "^nYou are the Cat !^n^nYou run slower than anyone else \ 
	but you can jump higher than any player and reach perfect ambush spots.^n^n\
	Your resistance is high (150 hps) and your kevlar will protect you against \ 
	any mouse\'s\ ridiculous Usp. Also, you received a machine-gun and 100 ammos \ 
	which shall help you building up a huge score in a minimum of time.^n^n\
	Your goal is double. "

	add(help_description_text, 1299, textstart)

	textmiddle = "First, you must stay alive for 55 seconds to make your \ 
	team win by auto-destruction of all enemy mouses. Second, using your huge \
	advantage of Cat, help your team complete the objectives by taking the risks \  
	and protecting your teammates.^n^n\"
	
	add(help_description_text, 1299, textmiddle)

	textfinish ="To put some fairness in the chase you are not only perfectly visible to all \
	players : you also glow	of a nice vivid Red which means that any mouses in your \  
	surroundings will not miss you.^n^n\ While you are the strongest in the game, \
	do not forget to stay close to some teammates : one mouse cannot hurt you but \
	a wave of mouses will eat you alive !"

	add(help_description_text, 1299, textfinish)

	show_motd(id, help_description_text, "Cat and Mouses - Cat :")

	return PLUGIN_CONTINUE
}

public help_mouse(id)
{
	new help_description_text[1300]
	new textstart[500]
	new textmiddle[500]

	textstart = "^nYou are a Mouse !^n^nYou run fast but not as fast as the Sniffer \
	and your weak legs will not allow you to jump higher than a normal player. \
	To take the piss someone gave you an usp with some ammos and send you chasing a \
	monstrous creature : The Cat.^n^nYour goal is not only to survive but also to become \
	yourself the Cat and start terrorising the enemy team !^n^n\ 
	Few things may help you accomplish this mission.^n^nFirst of all, stick together. "

	add(help_description_text, 1299, textstart)

	textmiddle = "If you panic and start running alone the Cat will get you and your teammates one \
	by one. But if you act as a group of tiny brains you may well show him who are the \
	masters over here.^n^nSecond, under no circumstances stop listening to your Sniffer ! \
	Much more skilled than any mouse, a good Sniffer can tell you where and especially \
	when to attack. Do not forget to cover him and the victory is yours !"
	
	add(help_description_text, 1299, textmiddle)

	show_motd(id, help_description_text, "Cat and Mouses - Mouse :")

	return PLUGIN_CONTINUE
}

public check_best_team()
{
	if (TObjectives > CTObjectives)
	{
		set_hudmessage(255, 100, 100, -1.0, 0.20, 0, 1.0, 1.5, 0.1, 0.2, 1)
		show_hudmessage(0, "Completed most Objectives : Terrorists")
	}
	else
	{
		set_hudmessage(255, 100, 100, -1.0, 0.20, 0, 1.0, 1.5, 0.1, 0.2, 1)
		show_hudmessage(0, "Completed most Objectives : CTs")
	}

	if (TlooseCat + TCatprotection > CTlooseCat + CTCatprotection)
	{
		set_hudmessage(255, 100, 100, -1.0, 0.25, 0, 1.0, 1.5, 0.1, 0.2, 2)
		show_hudmessage(0, "Best Cat Protection : Terrorists")
		
	}
	else
	{
		set_hudmessage(255, 100, 100, -1.0, 0.25, 0, 1.0, 1.5, 0.1, 0.2, 2)
		show_hudmessage(0, "Best Cat Protection : CTs")
	}

	if (TScore > CTScore)
	{
		set_hudmessage(255, 100, 100, -1.0, 0.35, 0, 1.0, 1.5, 0.1, 0.2, 3)
		show_hudmessage(0, "Terrorists beat CTs, %d to %d", TScore, CTScore)
		
	}
	else if (CTScore > TScore)
	{
		set_hudmessage(255, 100, 100, -1.0, 0.35, 0, 1.0, 1.5, 0.1, 0.2, 3)
		show_hudmessage(0, "CTs beat Terrorists, %d to %d", CTScore, TScore)
	}
	else 
	{
		set_hudmessage(255, 100, 100, -1.0, 0.35, 0, 1.0, 1.5, 0.1, 0.2, 3)
		show_hudmessage(0, "Match Draw", CTScore, TScore)
	}


}

public initialisation()
{
	check_best_team()
	cat_id = -10
	sniffer_id = -10
	cat_exist = false
	sniffer_exist = false
	TScore = 0
	Tmodifier = 0
	CTScore = 0
	CTmodifier = 0
	bomb_planted = false
	first_passage = false
}

public plugin_end()
{
	initialisation()
}


public check_sniffer_movement()
{
	if (get_cvar_num("sv_catmouse")==1 && sniffer_exist == true && cat_exist == true && is_user_alive(sniffer_id) == 1)
	{
		new current_position[3] 
		get_user_origin(sniffer_id, current_position)

		if (get_distance(current_position, previous_position) > 300) 
		{
			invisibility = 100	
			set_user_rendering(sniffer_id, kRenderFxNone, 0,0,0, kRenderTransTexture, invisibility)
		 	return PLUGIN_CONTINUE
		}
		else 
		{
			invisibility = 50	
			set_user_rendering(sniffer_id, kRenderFxNone, 0,0,0, kRenderTransTexture, invisibility)
		 	return PLUGIN_CONTINUE		
		}

		previous_position = current_position
		set_task(5.0, "check_sniffer_movement", 950, "", 0)

	 	return PLUGIN_CONTINUE
	}
 	return PLUGIN_CONTINUE
} 

