
/*
* AMX Mod script.
*
* (c) Copyright 2002, OLO
* This file is provided as is (no warranties).
*
*/

/*
 * Displays in CS how many enemies remaining.
*/

#include <amxmod>

public display_remaining() {

	new team[32]
	get_user_team(read_data(2),team,31)
	
	new ppl[32], pplnum
	get_players(ppl,pplnum,"e", (team[0]=='C') ? "TERRORIST" : "CT" )
	
	if (pplnum) {
		new eppl[32], epplnum
		get_players(eppl,epplnum,"ae",team)
		
		if (epplnum) {
			new message[128]
			format(message,127,"%d %s%s remaining...",epplnum,team,(epplnum==1)?"":"s" )
			set_hudmessage(255,255,255,0.02,0.9,2, 1.5, 3.0, 0.02, 5.0, 1)
	
			for(new a=0; a<pplnum; ++a)	{
				show_hudmessage(ppl[a],message)
				/*client_print(ppl[a],print_chat,message)*/
			}
		}
	}
	return PLUGIN_CONTINUE
}

public plugin_init() {
	register_plugin("Enemy remaining","0.8.7","default")
	register_event("DeathMsg","display_remaining","a")
	return PLUGIN_CONTINUE
}

