
/*__  __ ___ ____      _   __  _    
*|  \/  | _ \__ / __ _/ | /  \| |__ 
*| |\/| |  _/|_ \ \ V / || () | '_ \
*|_|  |_|_| |___/  \_/|_(_)__/|_.__/
*                                   
* MP3 v1.0Beta - Steam
* This file is provided as is (no warranties). 
* 
* Play MP3's on your clients.
* Usage:
* amx_playmp3 <mp3file> - Plays a MP3 file on the client
* amx_repeatmp3 <mp3file> - Repeats a MP3 file on the client
* amx_stopmp3 - Stop all MP3's
*
* The MP3 player will look for it's files in ModDir\valve\
*
* IMPORTANT: You will need to remove the three lines above "public plugin_precache()"
* and the line under under } in that block to enable Precaching of MP3 files.
* (Not tested yet)
*
* There allready a few MP3's in your HL, which will be listed in the thread also.
* (No precache required at all) 
*/ 

#include <amxmod> 
#include <amxmisc> 

public admin_playmp3(id,level,cid) {
   if (!cmd_access(id,level,cid,2)) 
      return PLUGIN_HANDLED 
   new mp3var[1024] 
   read_argv(1,mp3var,1023) 
   client_cmd(0,"echo ^"Playing MP3.. Type mp3 stop to stop it.^";mp3 play ^"%s^"",mp3var) 
   return PLUGIN_HANDLED 
}

public admin_loopmp3(id,level,cid) {
   if (!cmd_access(id,level,cid,2)) 
      return PLUGIN_HANDLED 
   new mp3loopvar[1024] 
   read_argv(1,mp3loopvar,1023) 
   client_cmd(0,"echo ^"Playing MP3 with Repeat on.. Type mp3 stop to stop it.^";mp3 loop ^"%s^"",mp3loopvar) 
   return PLUGIN_HANDLED 
}

public admin_stopmp3(id,level,cid) {
   client_cmd(0,"echo ^"MP3 disabled..^";mp3 stop")
   return PLUGIN_HANDLED 
}

/*
*  Precache - Just replace the filenames but keep in mind
*  the mp3 player only has access to ModDir/valve/
public plugin_precache() 
{  
  precache_model("valve/media/Britney.mp3")
  precache_model("valve/media/Shakira.mp3")
}
*/

public plugin_init(){ 
   register_plugin("MP3","1.0b","DutchTiger") 
   register_concmd("amx_mp3","admin_playmp3",ADMIN_LEVEL_A,"mp3 - Play a MP3 on their computer")
   register_concmd("amx_repeatmp3","admin_loopmp3",ADMIN_LEVEL_A,"mp3 - Repeat a MP3 on their computer")
   register_concmd("amx_stopmp3","admin_stopmp3",ADMIN_LEVEL_A,"Stops ALL MP3 files playing.")
   return PLUGIN_CONTINUE
}

