# phpMyAdmin MySQL-Dump
# version 2.5.0-rc2
# http://www.phpmyadmin.net/ (download page)
#
# Serveur: localhost
# Gnr le : Jeudi 01 Mai 2003  10:36
# Version du serveur: 3.23.49
# Version de PHP: 4.2.0
# Base de donnes: `amx`
# --------------------------------------------------------

#
# Structure de la table `admins`
#
# Cration: Vendredi 22 Novembre 2002  21:34
# Dernire modification: Samedi 14 Dcembre 2002  15:44
# Dernire vrification: Samedi 14 Dcembre 2002  15:44
#

CREATE TABLE `admins` (
  `auth` varchar(32) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `access` varchar(32) NOT NULL default '',
  `flags` varchar(32) NOT NULL default ''
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `amx_bans`
#
# Cration: Samedi 19 Avril 2003  10:32
# Dernire modification: Samedi 19 Avril 2003  10:32
#

CREATE TABLE `amx_bans` (
  `player_id` varchar(30) NOT NULL default '',
  `player_name` varchar(40) NOT NULL default '',
  `reason` varchar(128) NOT NULL default '',
  `admin_id` varchar(40) NOT NULL default '',
  `admin_name` varchar(30) NOT NULL default '',
  `length` int(10) unsigned NOT NULL default '0',
  `time_created` timestamp(14) NOT NULL,
  `server` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`player_id`)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `cvars`
#
# Cration: Vendredi 22 Novembre 2002  21:51
# Dernire modification: Samedi 21 Dcembre 2002  17:10
# Dernire vrification: Lundi 23 Dcembre 2002  15:04
#

CREATE TABLE `cvars` (
  `cvar` varchar(32) NOT NULL default '',
  `value` varchar(32) NOT NULL default ''
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `files`
#
# Cration: Samedi 14 Dcembre 2002  16:15
# Dernire modification: Jeudi 13 Mars 2003  19:53
# Dernire vrification: Jeudi 13 Mars 2003  19:53
#

CREATE TABLE `files` (
  `file` varchar(64) NOT NULL default '',
  `content` mediumtext NOT NULL,
  UNIQUE KEY `files` (`file`)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `maps`
#
# Cration: Mercredi 11 Dcembre 2002  21:38
# Dernire modification: Samedi 14 Dcembre 2002  15:37
# Dernire vrification: Samedi 14 Dcembre 2002  15:44
#

CREATE TABLE `maps` (
  `map` varchar(32) NOT NULL default ''
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `p2`
#
# Cration: Jeudi 01 Mai 2003  10:07
# Dernire modification: Jeudi 01 Mai 2003  10:28
# Dernire vrification: Jeudi 01 Mai 2003  10:28
#

CREATE TABLE `p2` (
  `id` tinyint(4) NOT NULL auto_increment,
  `wonid` mediumint(9) NOT NULL default '0',
  `ip` varchar(12) NOT NULL default '',
  `name` varchar(64) NOT NULL default '',
  UNIQUE KEY `id` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=3 ;
# --------------------------------------------------------

#
# Structure de la table `players`
#
# Cration: Mercredi 18 Dcembre 2002  21:22
# Dernire modification: Jeudi 13 Mars 2003  19:53
# Dernire vrification: Jeudi 13 Mars 2003  19:53
#

CREATE TABLE `players` (
  `srv` tinyint(4) NOT NULL default '0',
  `id` varchar(16) NOT NULL default '0',
  `name` varchar(32) NOT NULL default ''
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `plugins`
#
# Cration: Jeudi 13 Mars 2003  19:45
# Dernire modification: Jeudi 13 Mars 2003  20:14
# Dernire vrification: Samedi 19 Avril 2003  10:48
#

CREATE TABLE `plugins` (
  `plugin` varchar(32) NOT NULL default '',
  `on` tinyint(1) NOT NULL default '1'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `rcon`
#
# Cration: Jeudi 26 Dcembre 2002  13:15
# Dernire modification: Samedi 19 Avril 2003  10:48
# Dernire vrification: Samedi 19 Avril 2003  10:48
#

CREATE TABLE `rcon` (
  `srv` tinyint(4) NOT NULL default '0',
  `cmd` varchar(255) NOT NULL default ''
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `say`
#
# Cration: Lundi 23 Dcembre 2002  15:51
# Dernire modification: Mercredi 25 Dcembre 2002  18:21
# Dernire vrification: Mercredi 25 Dcembre 2002  18:21
#

CREATE TABLE `say` (
  `srv` tinyint(4) NOT NULL default '0',
  `player_name` varchar(32) NOT NULL default '',
  `say` varchar(128) NOT NULL default ''
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `servers`
#
# Cration: Dimanche 15 Dcembre 2002  12:07
# Dernire modification: Lundi 23 Dcembre 2002  19:15
# Dernire vrification: Mercredi 25 Dcembre 2002  18:21
#

CREATE TABLE `servers` (
  `id` int(11) NOT NULL default '0',
  `host` varchar(32) NOT NULL default '',
  `port` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `numero_2` (`id`)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `srvid_files`
#
# Cration: Mercredi 25 Dcembre 2002  18:29
# Dernire modification: Jeudi 13 Mars 2003  19:53
# Dernire vrification: Jeudi 13 Mars 2003  19:53
#

CREATE TABLE `srvid_files` (
  `srv` tinyint(5) NOT NULL default '0',
  `content` mediumtext NOT NULL,
  UNIQUE KEY `srv` (`srv`)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Structure de la table `status`
#
# Cration: Lundi 23 Dcembre 2002  18:52
# Dernire modification: Samedi 19 Avril 2003  10:48
# Dernire vrification: Samedi 19 Avril 2003  10:48
#

CREATE TABLE `status` (
  `srv` tinyint(4) NOT NULL default '0',
  `hostname` varchar(64) NOT NULL default '',
  `map` varchar(32) NOT NULL default '',
  `nextmap` varchar(32) NOT NULL default '',
  `maxplayers` tinyint(3) NOT NULL default '0',
  UNIQUE KEY `srv` (`srv`)
) TYPE=MyISAM;

