#include <translator>
#include <amxmod>
#include <amxmisc>

new RECDEMO_VERSION[] = "v2.1"

new client_demoname[128]
new rec_pl[33]
new bool:g_cstrikeRunning 


// Menu

// ============================================================================
// ================================= INIT =====================================
// ============================================================================

public plugin_init() {
	load_translations("recorddemo")
	register_plugin(_T("AMX Record Demo"), RECDEMO_VERSION, "KWo & KaszpiR")

        register_clcmd("say recdemo","rec_demo",0)
        register_clcmd("say_team recdemo","rec_demo",0)
        register_clcmd("say scr","rec_ss",0)
        register_clcmd("say_team scr","rec_ss",0)

	register_clcmd("amx_recorddemo","rec_demo",ADMIN_MENU,"- displays record demo ask")
	register_clcmd("amx_screenshot","rec_ss",ADMIN_MENU,"- displays screenshot ask")

	// Menu
	register_menucmd(register_menuid("Screenshot"),1023,"rec_ss_action")
	register_menucmd(register_menuid("Record Demo"),1023,"rec_demo_action")
	register_menucmd(register_menuid("Stop Recording"),1023,"rec_demo_off_action")
	register_event("TextMsg","eRestart","a","2&#Game_C","2&#Game_w")
	g_cstrikeRunning = ( is_running("cstrike") || is_running("czero") ) 
}

	
public rec_demo(id) {
	if ( rec_pl[id] == 1 ) {
                rec_demo_off(id)
		return PLUGIN_HANDLED
	}
	else {
		new menu_body[512],curmap[32]
		new pl_name[32]
        	get_user_name(id,pl_name,31)
		new keys = (1<<0)|(1<<1)
		get_mapname(curmap,32) 
		new dem_num = 1
	
		format(client_demoname,256,"%s_%s_%d.dem",pl_name,curmap,dem_num) 
		while(replace(client_demoname,64,"/","-")) {}
		while(replace(client_demoname,64,"\","-")) {}
		while(replace(client_demoname,64,":","-")) {}
		while(replace(client_demoname,64,"*","-")) {}
		while(replace(client_demoname,64,"?","-")) {}
		while(replace(client_demoname,64,">","-")) {}
		while(replace(client_demoname,64,"<","-")) {}
		while(replace(client_demoname,64,"|","-")) {}
	
		while ( file_exists(client_demoname) ){
			dem_num++
			format(client_demoname,256,"%s_%s_%d.dem",pl_name,curmap,dem_num) 
			while(replace(client_demoname,64,"/","-")) {}
			while(replace(client_demoname,64,"\","-")) {}
			while(replace(client_demoname,64,":","-")) {}
			while(replace(client_demoname,64,"*","-")) {}
			while(replace(client_demoname,64,"?","-")) {}
			while(replace(client_demoname,64,">","-")) {}
			while(replace(client_demoname,64,"<","-")) {}
			while(replace(client_demoname,64,"|","-")) {}
		}
		format(menu_body,511,g_cstrikeRunning ? _T("\yRecord Demo to %s^n\w^n1. Yes^n2. No", id ) : 
		_T("Record Demo to %s^n^n1. Yes^n2. No", id ) ,client_demoname)
		show_menu(id,keys,menu_body,-1,"Record Demo") //ask if client wants to record a demo		
	}
	return PLUGIN_HANDLED	
}

public rec_demo_action(id,key) {
	if(key == 0) {
		client_cmd(id,"stop;record ^"%s^"",client_demoname)
		rec_pl[id]=1
		rec_demo_off(id)
	}
	return PLUGIN_HANDLED
}

public rec_demo_off(id) {
	new menu_body[512]
	new keys = (1<<0)
	format(menu_body,511,g_cstrikeRunning ? _T("\yStop Recording\w^n1. Yes", id ) : _T("Stop Recording^n1. Yes", id ))
	show_menu(id,keys,menu_body,-1,"Stop Recording") //ask to stop recording	
	return PLUGIN_HANDLED
}

public rec_demo_off_action(id,key) {
	switch(key) {
		case 0: {
			client_cmd(id,"stop")
			rec_pl[id]=0
			}
	}
	return PLUGIN_HANDLED
}

// takes scoreboard screenshot on clients
public rec_ss2(id[]) client_cmd(id[0],"snapshot")
public rec_ss3(id[]) client_cmd(id[0],"-showscores")

public rec_ss(id) {
	new menu_body[512]
	new keys = (1<<0)|(1<<1)
	format(menu_body,511,g_cstrikeRunning ? _T("\yScreenshot^n\dDo you wish to take^na scoreboard screenshot?^n\w^n1. Yes^n2. No", id) :
	_T("Screenshot^n\dDo you wish to take^na scoreboard screenshot?^n^n1. Yes^n2. No", id) )
	show_menu(id,keys,menu_body,-1,"Screenshot")	
	return PLUGIN_HANDLED
}

public rec_ss_action(id,key) {
	new params[1]
	params[0] = id
	switch(key) {
		case 0: {
			client_cmd(id,"+showscores")
			set_task(0.3,"rec_ss2",0,params,1)
			set_task(0.6,"rec_ss3",0,params,1)
		}
	}
	return PLUGIN_HANDLED
}

public eRestart(){
	for (new i = 0; i < 32; ++i) {		
		if ( rec_pl[i] != 0 ){
			rec_pl[i] = 0
			client_cmd(i,"stop")
		}
 	}
}
