/* AMX Mod Script
* Script Name: Simple Sounds (Simple Sound Management System) 
* Coded By: DynAstY
* This file is provided as is (no warranties).
* 
* simplesounds.sma - simplesounds.amx 
* 
* To install drop AMX file in to plugins directory and add line to plugins.ini. 
* 
*/ 

#include <amxmod> 

public plugin_init() { 
   register_plugin("Simple Sounds","1.0.1","DynAstY") 
   return PLUGIN_CONTINUE 
} 

public plugin_precache() 
{ 
    precache_sound( "misc/monsterkill.wav") 
    precache_sound( "misc/multikill.wav") 
    precache_sound( "misc/killingspree.wav") 
    precache_sound( "misc/humiliation.wav") 
    precache_sound( "misc/ultrakill.wav") 
    precache_sound( "misc/headshot.wav") 
    precache_sound( "misc/doublekill.wav") 
    precache_sound( "misc/firstblood.wav") 
    precache_sound( "misc/rampage.wav") 
    precache_sound( "misc/unstoppable.wav") 
    precache_sound( "misc/dominating.wav") 
    precache_sound( "misc/perfect.wav") 
    precache_sound( "misc/godlike.wav") 
    precache_sound( "misc/prepare.wav") 
    return PLUGIN_CONTINUE 
}
