


/* AMX Mod script.
*
* Slots reservation by IP (reserveslotsip.sma)
*
* (c) Copyright 2002, SYZo
* This file is provided as is (no warranties).
- 
* Slots reservation by IP (reserveslotsip.amx) working only with Slots reservation (adminslots.amx)
* 
* MySQL Modifications done by Rouven <rouven@kiez-clan.de>
*

CREATE TABLE amx_reserveip (
  sipmask varchar(16) NOT NULL default '',
  sipaddr varchar(16) NOT NULL default ''
) TYPE=MyISAM;

Now you can insert IP and subnet like this

INSERT INTO `amx_reserveip` ( `sipmask` , `sipaddr` ) VALUES ('255.255.255.255', '192.168.76.97');

WARNING:
* Correct plugin.ini
* insert "slot_reservation_by_ip_from_mysql.amx" before adminslots.amx
* For example:
* welcome.amx
* admin.amx
* adminslay2.amx
* slot_reservation_by_ip_from_mysql.amx
* adminslots.amx
* adminvote.amx
* amx_atac.amx
* 
*/

#include <amxmod>
#include <string>
#include <mysql>

ip_to_number(userip[16]) 
{
    new ipb1[12]
    new ipb2[12]
    new ipb3[12]
    new ipb4[12]
    new ip
    new nipb1
    new nipb2
    new nipb3
    new nipb4
    new uip[16]
    copy(uip, 16, userip)
    while(replace(uip, 16, ".", " ")){}
    parse(uip, ipb1, 12, ipb2, 12, ipb3, 12, ipb4, 12)
    nipb1 = strtonum(ipb1)
    nipb2 = strtonum(ipb2)
    nipb3 = strtonum(ipb3)
    nipb4 = strtonum(ipb4)
    ip = ((((nipb1 * 256) + nipb2) * 256) + nipb3) + ((((((nipb1 * 256) + nipb2) * 256) + nipb3) * 255) + nipb4)    
    return ip
}

net_hi_num(addr, mask) 
{
    return addr+4294967296-mask
}

net_belongs(ipaddr, ipmask, ipaddrin, ipmaskin) 
{
    if (ipaddr >= ipaddrin && net_hi_num(ipaddr, ipmask) <= net_hi_num(ipaddrin, ipmaskin))  {
	return 1
    }
    return 0
}

public client_connect(id){
	new sipaddr[16]
	new sipmask[16]
	new userip[16]
	new mysql, cnt
	new error[257]
	new host[65]
	new user[33]
	new pass[33]
	new db[33]
	get_user_ip(id,userip,16,1)
	get_cvar_string("amx_mysql_host",host,64)
	get_cvar_string("amx_mysql_user",user,32)
	get_cvar_string("amx_mysql_pass",pass,32)
	get_cvar_string("amx_mysql_db",db,32)
	
	mysql = mysql_connect(host,user,pass,db,error,256)
	if(mysql>0)
	{
		if(mysql_query(mysql,"SELECT * FROM amx_reserveip")>0)
		{
		cnt = 0
		while(mysql_nextrow(mysql)>0)
			{
				mysql_getfield(mysql,1,sipmask,16)
				mysql_getfield(mysql,2,sipaddr,16)
				cnt++
				if (net_belongs(ip_to_number(userip), ip_to_number("255.255.255.255"), ip_to_number(sipaddr), ip_to_number(sipmask)) == 1) 
				{
					set_user_flags(id,read_flags("b"))
				}
			}
			server_print("[AMX] Loaded %d IP(s) from database",cnt)
		}
		else
		{
			mysql_error(mysql,error,32)
			server_print("MySQL error : could not load ips from db : '%s'",error)
		}
		mysql_close(mysql)
	}
	else
	{
		server_print("MySQL error : could not connect : '%s'",error)
	}
    
    return PLUGIN_CONTINUE
}

public plugin_init() {
    register_plugin("Slots reservation by IP","0.2","SYZo & Rouven")
    register_cvar("amx_mysql_host","127.0.0.1")
    register_cvar("amx_mysql_user","root")
    register_cvar("amx_mysql_pass","")
    register_cvar("amx_mysql_db","amx")
    return PLUGIN_CONTINUE
}



