/* AMXMOD script. 
* 
* (c) Copyright 2000-2002, RAV 
* This file is provided as is (no warranties). 
* 
* 
* Swearing will be filtered.
* 
* Changelog: 
*  1.10  -  Initial Release
*/ 

#include <amxmod> 

// max number of words in word list 
#define MAX_WORDS 64 

// Number of random messages.
#define MESSAGES   4 

new messages[MESSAGES][] = { 
"ADMIN, I want to be punished for my foul mouth!", 
"ADMIN, please ban me for my bad language!", 
"All these years in school and I can still only say four letter words!", 
"Someone please gag me for abusing chat!"} 

// file to read words from 
new wordlist[32] = "addons/amx/wordlist.cfg" 

new swears[MAX_WORDS][32] 
new num_words = 0 

public swear_filter(id) 
{ 
   new said[128] 
   read_args(said,128) 

   for (new i=0; i<=num_words; i++) 
   { 
       if (containi(said,swears[i]) != -1) 
       { 
	client_cmd(id,"say %s",messages[ random_num(0,MESSAGES-1) ]) 
        return PLUGIN_HANDLED 
       } 
   } 
   return PLUGIN_CONTINUE 
} 

public read_list() 
{ 
    new index=0, line[32] 
    if (file_exists(wordlist)) 
    { 
      new length 
      while(read_file(wordlist,index++,line,32,length)) 
      swears[index] = line 
      num_words = index 
    } 
    else log_message("[AMX] Swear file not found") 

    return PLUGIN_CONTINUE 
} 

public plugin_init() 
{ 
    register_plugin("SWEAR FILTER","0.6","Rav") 
    register_clcmd("say","swear_filter") 
    register_clcmd("say_team","swear_filter") 
    register_cvar("RVS_filter", "1.3",FCVAR_SERVER) 
    read_list() 
    return PLUGIN_CONTINUE 
} 

