
/* AMX Mod
*   Tuff kill Rewards
* 
*  Rewards Headshots w/ 2 frags +10 health 
*  Rewards Knife Kills w/ +25 health   
*    
*       by mongo 
*  the_mongo@hotmail.com
*  
*  Modified from Head Shot Location announcer
*/

#include <amxmod>
#include <fun>

#define MESSAGES   1


new messages[MESSAGES][] = {
"%s is being rewarded."
}

public hs_kill(){
   if(!get_cvar_num("amx_hsreward")) return PLUGIN_HANDLED 
   new killer = read_data(1)
   if (killer == 0)  
      return PLUGIN_CONTINUE
      
   new killer_name[32]
   get_user_name(read_data(1),killer_name,31)
   set_hudmessage(200, 50, 0, -1.0, 0.20, 0, 6.0, 6.0, 0.5, 0.15, 3)
   show_hudmessage(0,messages[ random_num(0,MESSAGES-1) ],killer_name)
   set_user_frags(killer, get_user_frags(killer)+1)
   set_user_health(killer, get_user_health(killer)+10)
   return PLUGIN_CONTINUE
}

public knife_kill(){
   if(!get_cvar_num("amx_knifereward")) return PLUGIN_HANDLED 
   new killer = read_data(1)
   if (killer == 0) 
      return PLUGIN_CONTINUE
      
   new killer_name[32]
   get_user_name(read_data(1),killer_name,31)
   set_hudmessage(200, 50, 0, -1.0, 0.20, 0, 6.0, 6.0, 0.5, 0.15, 3)
   show_hudmessage(0,messages[ random_num(0,MESSAGES-1) ],killer_name)
   set_user_health(killer, get_user_health(killer)+25)
   return PLUGIN_CONTINUE
}

public plugin_init() {
   register_plugin("Tuff kill Rewards","0.3","mongo")
   register_event("DeathMsg","hs_kill","ade","3=1","5=0")
   register_event("DeathMsg","knife_kill","ade","3=1","5=0")
   register_cvar("amx_hsreward", "1")
   register_cvar("amx_knifereward", "1")
   return PLUGIN_CONTINUE
}




