/* AMX Mod script. 
* 
* (c) Copyright 2002-2003, ychappyboy 
* This file is provided as is (no warranties). 
* 
* Usage: amx_usponly 
* Examples: Type amx_usponly in console to enable usponly,
* "amx_usponly" again to disable!
* Or you can use "amx_usponly on" (or off) if you forget 
* if it's on or not! 
* 
* Custom voting: 
* say voteusp 
* say /voteusp 
* 
*/ 

#include <amxmod> 
#include <amxmisc> 
#include <fun>

#define MAXGIVETIME 8 
#define MINAMMO 24 

new bool:usp 

public plugin_init() { 
   register_plugin("USP & Knife only","0.1","ychappyboy") 
   register_event("ResetHUD","newround", "be") 
   register_concmd("amx_usponly","usptoggle",ADMIN_LEVEL_A,": toggles Usp only on/off") 
   register_event("CurWeapon","holdwpn","be","1=1") 

   usp = false 

   // Voting part below 
   register_clcmd("say /voteusp","vote_usp",0,"- start voting session for USP only") 
   register_clcmd("say voteusp","vote_usp",0,"- start voting session for USP only") 
   register_menucmd(register_menuid("Usp only?"),(1<<0)|(1<<1),"mvote_count") 
   // Voting part above 
    
   return PLUGIN_CONTINUE 
} 

public usptoggle(id,level,cid) { 
   if (!cmd_access(id,level,cid,1)) 
      return PLUGIN_HANDLED 
   if (read_argc() == 2) { 
      new argument[10] 
      read_argv(1,argument,9) 
      if (equal(argument,"on")) { 
         if (usp) 
            return PLUGIN_HANDLED 
         else 
            usp = true 
      } 
      else if (equal(argument,"off")) { 
         if (!usp) 
            return PLUGIN_HANDLED 
         else 
            usp = false 
      } 
   } 
   else 
      usp = !usp 

   if (usp) { 
      set_hudmessage(0, 100, 0, -1.0, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)    
      show_hudmessage(0,"Usp only is enabled!") 
      client_print(id,print_console,"[AMX] Usp only was enabled!") 
      server_print("[AMX] Usp only was enabled!") 

      // Collect all alive players and give him a usp if they 
      // already not have one. 
      new playersList[32] 
      new playersFound 
      get_players(playersList,playersFound,"a") 
      for (new i = 0;i < playersFound;i++) { 
         giveuspifnothas(playersList[i]) 
         engclient_cmd(playersList[i],"weapon_usp") 
      } 
   } 
   else { 
      set_hudmessage(0, 100, 0, -1.0, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)    
      show_hudmessage(0,"Usp only is disabled!") 
      client_print(id,print_console,"[AMX] Usp only was disabled!") 
      server_print("[AMX] Usp only was disabled!") 
   } 
   return PLUGIN_HANDLED 
} 

public client_putinserver(id) { 
   if (usp)  
      set_task(10.0,"welcome",id) 
} 

public welcome(id) { 
   set_hudmessage(0, 130, 0, -1.0, 0.45, 2, 0.02, 15.0, 0.01, 0.1, 2)    
   show_hudmessage(id,"Welcome! Usp only Mod is enabled! ") 
} 

public holdwpn(id) { 
   if (!usp) 
      return PLUGIN_HANDLED    
   holdammo(id)
   new wpnList[32],wpname[32] 
   new number 
   new foundUsp = false 
   get_user_weapons(id,wpnList,number) 
   for (new i = 0;i < number && !foundUsp;i++) { 
      if (wpnList[i] == CSW_USP) 
         foundUsp = true 
   } 
   for (new a=0;a<number;++a) { 
      get_weaponname(wpnList[a],wpname,31) 
      if (wpnList[a] == CSW_GLOCK18 || wpnList[a] == CSW_DEAGLE || wpnList[a] == CSW_ELITE || wpnList[a] == CSW_FIVESEVEN || wpnList[a] == CSW_P228) 
         engclient_cmd(id,"drop",wpname) 
   } 
   new weapontypeid = read_data(2) 
   // Only valid weapons to hold are Usp and C4 or Knife 
   if (weapontypeid == CSW_USP || weapontypeid == CSW_C4 || weapontypeid == CSW_KNIFE) { 
   } 
   else { 
            if (foundUsp) { 
               engclient_cmd(id,"weapon_usp") 
               client_print(id,print_center,"Only Usp and Knife are Enabled!") 
            }              
            else { 
               engclient_cmd(id,"weapon_knife") 
               client_print(id,print_center,"Only Usp and Knife are Enabled!") 
            } 
   } 
   return PLUGIN_CONTINUE
} 

public holdammo(id) { 
   new clip,ammo 
   get_user_ammo(id,CSW_USP,clip,ammo) 
   if (ammo < MINAMMO) {
      for (new i = 0;i <= MAXGIVETIME;i++) 
         give_item(id,"ammo_45acp") 
      client_print(id,print_center,"Your ammos are adding to full now!") 
   }  
}  
          
public newround(id) { 
   if (!usp) 
      return PLUGIN_HANDLED  
   set_task(0.0,"newround2",id) 
   return PLUGIN_CONTINUE 
} 
                      
public newround2(id) { 
   giveuspifnothas(id) 
   set_hudmessage(0, 100, 0, -1.0, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2)  
   show_hudmessage(0,"Only Usp and Knife are Enabled!") 
} 

public giveuspifnothas(id) { 
   new wpnList[32] 
   new number 
   new foundUsp = false 
   get_user_weapons(id,wpnList,number) 
   for (new i = 0;i < number && !foundUsp;i++) { 
      if (wpnList[i] == CSW_USP) 
         foundUsp = true 
   } 
   if (!foundUsp) 
      give_item(id,"weapon_usp") 
   for (new i = 0;i <= MAXGIVETIME;i++) 
      give_item(id,"ammo_45acp") 
} 

// Voting part below 
new moption[2] 
new voteusp[] = "\yAMX %s Usp only?\w^n^n1. Yes^n2. No" 
new g_votingFailed[] = "Voting failed"
new g_votingSuccess[] = "Voting successful"

public vote_usp(id){ 
   new Float:voting = get_cvar_float("amx_last_voting") 
   if (voting > get_gametime()) { 
      client_print(id,print_chat,"* There is already one voting...") 
      return PLUGIN_HANDLED 
   } 

   if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
      client_print(id,print_chat,"* Voting not allowed at this time...") 
      return PLUGIN_HANDLED 
   } 

   new menu_msg[256] 
   format(menu_msg,255,voteusp,usp ? "Disable" : "Enable") 
   new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
   set_cvar_float("amx_last_voting",  get_gametime() + vote_time ) 
   show_menu(0,(1<<0)|(1<<1),menu_msg,floatround(vote_time)) 
   set_task(vote_time,"check_mvotes",99889988) 
   client_print(0,print_chat,"* Voting has started...") 
   moption[0]=moption[1]=0 
   return PLUGIN_HANDLED      
} 

public mvote_count(id,key){ 
   if ( get_cvar_float("amx_vote_answers") ) { 
      new name[32] 
      get_user_name(id,name,31) 
      client_print(0,print_chat,"* %s voted %s", name, key ? "against" : "for" ) 
   } 
   ++moption[key] 
   return PLUGIN_HANDLED 
} 

public check_mvotes(id){ 
   if (moption[0] > moption[1]) { 
      if (usp) 
         server_cmd("amx_usponly off") 
      else if (!usp) 
         server_cmd("amx_usponly on") 
      client_print(0,print_chat,"%s (yes ^"%d^") (needed ^"%d^").The result: %s",g_votingSuccess,moption[0],(moption[0]+moption[1])/2+1,usp ? "Usp only is disabled!" : "Usp only is enabled!") 
   } 
   else
      client_print(0,print_chat,"%s (yes ^"%d^") (no ^"%d^") (needed ^"%d^")",g_votingFailed,moption[0],moption[1],(moption[0]+moption[1])/2+1) 
   return PLUGIN_CONTINUE 
} 
// Voting part above 
